<?php
    require_once KCONFIG . '/classes/classKYaml.php';

    class KGatewayYamlException extends KYamlException
    {
    }

    class KGatewayYaml extends KYaml
    {
        public function __construct( )
        {
            // validation rules
            //@formatter:off
            $this->rules = array(
                'NAPs' => array(
                    'type' => KYaml::TYPE_LIST,
                    'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                    'default' => array(),
                    'children' => array(
                        '?' => array(
                            'type' => KYaml::TYPE_LISTHASH,
                            'children' => array(
                                'Name' => array(
                                    'type' => KYaml::TYPE_STRING,
                                ),
                                'Type' => array(
                                    'type' => KYaml::TYPE_STRING,
                                ),
                                //SIP
                                'Register' => array(
                                    'type' => KYaml::TYPE_BOOLEAN,
                                    'flags' => KYaml::FLAG_NOTREQUIRED,
                                    'default' => 'false'
                                ),
                                'Proxy' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                'ProxyPort' => array(
                                    'type' => KYaml::TYPE_INTEGER,
                                    'default' => 0,
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                'Username' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED
                                ),
                                'Password' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                'Domain' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED
                                ),
                                'DomainPort' => array(
                                    'type' => KYaml::TYPE_INTEGER,
                                    'default' => 0,
                                    'flags' => KYaml::FLAG_NOTREQUIRED
                                ),
                                'AuthorizationUser' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                'Expires' => array(
                                    'type' => KYaml::TYPE_INTEGER,
                                    'default' => 0,
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                //TRUNK
                                'Links' => array(
                                    'type' => KYaml::TYPE_LIST,
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                                    'default' => array(),
                                    'children' => array(
                                        '?' => array(
                                            'type' => KYaml::TYPE_STRING
                                        )
                                    ) // NAPs.?.Links
                                )
                            ) // NAPs.?
                        )
                    ) // NAPs
                ),
                'CodecProfiles' => array(
                    'type' => KYaml::TYPE_LIST,
                    'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                    'default' => array(),
                    'children' => array(
                        '?' => array(
                            'type' => KYaml::TYPE_LISTHASH,
                            'children' => array(
                                'Name' => array(
                                    'type' => KYaml::TYPE_STRING
                                ),
                                'CodecList' => array(
                                    'type' => KYaml::TYPE_LIST,
                                    'flags' => KYaml::FLAG_NORMALIZE,
                                    'children' => array(
                                        '?' => array(
                                            'type' => KYaml::TYPE_STRING
                                        )
                                    ) // CodecProfiles.?.CodecList
                                )
                            ) // CodecProfiles.?
                        )
                    ) // CodecProfiles
                ),
                'Routes' => array(
                    'type' => KYaml::TYPE_LIST,
                    'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                    'default' => array(),
                    'children' => array(
                        '?' => array(
                            'type' => KYaml::TYPE_LISTHASH,
                            'children' => array(
                                'Name' => array(
                                    'type' => KYaml::TYPE_STRING
                                ),
                                'OriginNAP' => array(
                                    'type' => KYaml::TYPE_STRING
                                ),
                                'Called' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'Caller' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'RemapCalled' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'RemapCaller' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'DestinationNAP' => array(
                                    'type' => KYaml::TYPE_STRING
                                ),
                                'Time' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                //SIP
                                'CodecProfile' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                )
                            ) // Routes.?
                        )
                    ) // Routes
                ),
                'TimeRestraints' => array(
                    'type' => KYaml::TYPE_LIST,
                    'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                    'default' => array(),
                    'children' => array(
                        '?' => array(
                            'type' => KYaml::TYPE_LISTHASH,
                            'children' => array(
                                'Name' => array(
                                    'type' => KYaml::TYPE_STRING
                                ),
                                'Hour' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'WDay' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'Day' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'Month' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_EMPTY
                                )
                            ) // TimeRestraints.?
                        )
                    ) // TimeRestraints
                ),
                'CDR' => array(
                    'type' => KYaml::TYPE_LISTHASH,
                    'children' => array(
                        'Pattern' => array(
                            'type' => KYaml::TYPE_STRING
                        ),
                        'Rotate' => array(
                            'type' => KYaml::TYPE_STRING
                        ),
                        'BasePath' => array(
                            'type' => KYaml::TYPE_STRING
                        )
                    ) // CDR
                )
            );
            //@formatter:on

            $app = KSystem::getInstance( );
            //TODO: windows support?
            $this->validationProgram = '/usr/sbin/khomp-sudo /etc/init.d/kgateway validate-config';
            parent::__construct( $app->getConfigDir() . DIRECTORY_SEPARATOR . 'gateway.yaml' );
        }

        /**
         * Check if route exists
         *
         * @param string $name Route name
         * @return boolean
         */
        public function hasRoute( $name )
        {
            foreach( $this->yaml['Routes'] as &$info )
            {
                if( $info['Name'] === $name )
                {
                    return true;
                }
            }
            return false;
        }

        /**
         * Count defined routes
         *
         * @return int
         */
        public function countRoutes( )
        {
            return count( $this->yaml['Routes'] );
        }

        /**
         * Get route from YAML
         *
         * @param string $name Route name
         * @return null|array
         */
        public function getRoute( $name )
        {
            foreach( $this->yaml['Routes'] as &$info )
            {
                if( $info['Name'] === $name )
                {
                    return $info;
                }
            }
            return null;
        }

        /**
         * Get all routes
         *
         * @return array
         */
        public function getAllRoutes( )
        {
            return $this->yaml['Routes'];
        }

        /**
         * Set route to YAML
         *
         * If route exists, update it
         *
         * @param array $data Route info
         * @param string $oldName Route old name
         */
        public function setRoute( $data, $oldName = '' )
        {
            // duplicated route name
            if( $oldName != $data['Name'] && $this->hasRoute( $data['Name'] ) )
            {
                throw new KGatewayYamlException( 'gateway-route-error-already-exists' );
            }
            // update route
            if( !empty( $oldName ) )
            {
                foreach( $this->yaml['Routes'] as $idx => &$route )
                {
                    $notfound = true;
                    if( $oldName == $route['Name'] )
                    {
                        $route = $data;
                        $notfound = false;
                        break;
                    }
                }
                if( $notfound )
                {
                    throw new KGatewayYamlException( 'gateway-route-error-not-found' );
                }
            }
            // add new route
            else
            {
                $this->yaml['Routes'][] = $data;
            }
        }

        /**
         * Delete route
         *
         * @param string $name Route name
         */
        public function deleteRoute( $name )
        {
            foreach( $this->yaml['Routes'] as $idx => &$route )
            {
                if( $name == $route['Name'] )
                {
                    unset( $this->yaml['Routes'][$idx] );
                    return true;
                }
            }
            return false;
        }

        /**
         * Set routes order
         *
         * @param array $order Array of route names with the new order
         * @return boolean
         */
        public function setRoutesOrder( $order )
        {
            if( count( $order ) != count( $this->yaml['Routes'] ) )
            {
                throw new KGatewayYamlException( 'gateway-route-error-reorder-invalid-size' );
            }
            $tmp = array( );
            foreach( $order as $name )
            {
                $route = $this->getRoute( $name );
                if( is_null( $route ) )
                {
                    throw new KGatewayYamlException( 'gateway-route-error-reorder-invalid-name' );
                }
                else
                {
                    $tmp[] = $route;
                }
            }
            $this->yaml['Routes'] = &$tmp;
        }

    }
