/*
 * GATEWAY KOMODO JS
 * Author: Eduardo Nunes Pereira
 * Author: Everton Fernandes
 */

function RunFirmwareUpdate( upd )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=runFirmwareUpdate&update=" + upd,
        dataType : "html",
        success : function( retorno )
        {
            $( '#refreshing' ).hide( );
            $( '#GeralField' ).html( retorno );
            startCountdownReset( );
        }
    } );
}

var g_iCount = new Number( );
var g_iCount = 60;

function startCountdownReset( )
{
    if( (g_iCount - 1) > 0 )
    {
        g_iCount = g_iCount - 1;
        $( '#time-slot' ).text( g_iCount );
        setTimeout( 'startCountdownReset()', 1000 );
    }
    else
        window.location = "/index.php";
}

function newNAP( )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=newNAP",
        dataType : "html",
        success : function( html )
        {
            $( '#refreshing' ).hide( );
            $( '#NAPsDivForm' ).html( html );
        }
    } );
}

function initNAPs( )
{
    $( '#NAPsTable' ).tablesorter(
    {
        cssAsc : 'tablesorter-asc',
        cssDesc : 'tablesorter-desc',
        cssHeader : 'tablesorter-undefined',
        headers :
        {
            2 :
            {
                sorter : false
            }
        },
        sortList : [[0, 0]]
    } );
}

function backNAPs( )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showNAPsGW",
        dataType : "html",
        success : function( html )
        {
            $( '#formulario' ).html( html );
            initNAPs( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function changeNAPType( )
{
    var type = $( '#gateway-nap-type :selected' ).val( );
    var extra = "";
    if( $.trim( $( '#gateway-nap-old-name' ).val( ) ) != "" )
        extra = "&name=" + $( '#gateway-nap-old-name' ).val( );

    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=printNAPType&type=" + type + extra,
        dataType : "html",
        success : function( html )
        {
            $( '#refreshing' ).hide( );
            $( '#NAPOptionsDiv' ).html( html );
            switch( type )
            {
                case 'SIP':
                    $( '#gateway-nap-sip-register' ).change( function( ev )
                    {
                        var disabled = ! $( this ).is( ':checked' );
                        $( '#gateway-nap-sip-authorization-user' ).prop( 'disabled', disabled );
                        $( '#gateway-nap-sip-password' ).prop( 'disabled', disabled );
                        $( '#gateway-nap-sip-expires' ).prop( 'disabled', disabled );
                    } );
                    $( '#gateway-nap-sip-domain-port' ).mask( '9?9999' );
                    $( '#gateway-nap-sip-proxy-port' ).mask( '9?9999' );
                    $( '#gateway-nap-sip-expires' ).mask( '9?999999999' );
                    $( '#gateway-nap-sip-register' ).change( );
                    break;
            }
        }
    } );
}

function editNAP( NAPname )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL + "&ajaxTo=editNAP",
        data :
        {
            "name" : NAPname
        },
        type : 'POST',
        dataType : "html",
        success : function( html )
        {
            $( '#NAPsDivForm' ).html( html );
            changeNAPType( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function removeNAP( name )
{
    if( ajaxConfirm( 'removeNAP' ) )
    {
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=removeNAP',
            data :
            {
                "name" : name
            },
            type : 'POST',
            dataType : "json",
            success : function( data )
            {
                if( data.success )
                {
                    ShowNotice( data.message, true );
                    backNAPs( );
                }
                else
                {
                    ShowNotice( data.message, false );
                }
                $( '#refreshing' ).hide( );
            }
        } );
    }
}

function construcQueryStrig( name, value )
{
    return name + '=' + value + '|';
}

function buildTeste( group )
{
    returnGroup = '';
    for( i = 0; i < group.length; i++ )
    {
        if( returnGroup == '' )
            returnGroup += group[i];
        else
            returnGroup += ',' + group[i];
        varTest = group[i];
        testVar = group[i];

        for( x = i; x < group.length; x++ )
        {
            if( testVar == group[x] )
            {
                testVar++;
                i++;
            }
        }
        i--;
        if( group[i] != varTest )
            returnGroup += '-' + group[i];
    }
    return returnGroup;
}

function onlyIntegerNumbers( event )
{
    var key;
    var keychar;
    key = event.keyCode;
    keychar = String.fromCharCode( key );

    if( (key == null) || (key == 0) || (key == 8) || (key == 9) || (key == 13) || (key == 27) || (key == 46) || (key > 34 && key < 41) || (key == 46) || (key > 95 && key < 106) )
        return true;
    else if( (("0123456789").indexOf( keychar ) > -1) )
        return true;

    return false;

}

/*
 function saveFXSNAP( )
 {
 var NAPId = $( "#NAPId" ).val( );
 var NAPPos = $( "#NAPPos" ).val( );
 var Name = $( "#NAPName" ).val( );

 if( $.trim( Name ) == '' )
 {
 ajaxAlert( 'reportNAPName' );
 }
 else
 {
 var Type = $( "#NAPSelect option:selected" ).text( );
 var devices = ($( "#seriais" ).val( ) ).split( '|' );
 var selecteds = '';
 var x = '';

 for( var s in devices )
 {
 for( var ch = 0; ch < 24; ch++ )
 {
 var id = devices[s] + '-' + ch;
 var value = $( "#" + id ).val( );
 value != '' ? selecteds += id + ':' + value + ',' : x++;
 }
 }
 //clear the last coma
 selecteds = selecteds.substr( 0, selecteds.length - 1 );

 var data = '';
 data += construcQueryStrig( "Name", Name );
 data += construcQueryStrig( "Type", Type );
 data += construcQueryStrig( "Branches", selecteds );
 //clear the last pipe
 data = data.substr( 0, data.length - 1 );

 $( '#refreshing' ).show( );
 jQuery.ajax(
 {
 url : GLOBALAjaxURL,
 data : "ajaxTo=saveNAP&id=" + NAPId + "&NAPPos=" + NAPPos + "&data=" + data,
 dataType : "text",
 success : function( retorno )
 {
 retorno = retorno.replace( /(\r\n|\n|\r)/gm, "" );
 resp = retorno.split( '|' );

 if( resp[0] == 'ok' )
 {
 ShowNotice( resp[1], true );
 backNAPs( );
 }
 else
 ShowNotice( resp[1], false );
 $( '#refreshing' ).hide( );
 }
 } );
 }
 }

 function saveFXSGroupNAP( )
 {
 var NAPId = $( "#NAPId" ).val( );
 var NAPPos = $( "#NAPPos" ).val( );
 var Name = $( "#NAPName" ).val( );

 if( $.trim( Name ) == '' )
 {
 ajaxAlert( 'reportNAPName' );
 }
 else
 {
 var Type = $( "#NAPSelect option:selected" ).text( );
 var devices = ($( "#seriais" ).val( ) ).split( '|' );
 var selecteds = '';
 var x = '';
 for( var j in devices )
 {
 var id = devices[j];
 var cb = $( '#' + id ).is( ':checked' );
 cb ? selecteds += id + ',' : x = '';
 }
 //clear the last coma
 selecteds = selecteds.substr( 0, selecteds.length - 1 );

 var data = '';
 data += construcQueryStrig( "Name", Name );
 data += construcQueryStrig( "Type", Type );
 data += construcQueryStrig( "Branches", selecteds );
 //clear the last pipe
 data = data.substr( 0, data.length - 1 );

 $( '#refreshing' ).show( );
 jQuery.ajax(
 {
 url : GLOBALAjaxURL,
 data : "ajaxTo=saveNAP&id=" + NAPId + "&NAPPos=" + NAPPos + "&data=" + data,
 dataType : "text",
 success : function( retorno )
 {
 retorno = retorno.replace( /(\r\n|\n|\r)/gm, "" );
 resp = retorno.split( '|' );
 if( resp[0] == 'ok' )
 {
 ShowNotice( resp[1], true );
 backNAPs( );
 }
 else
 ShowNotice( resp[1], false );
 $( '#refreshing' ).show( );
 }
 } );
 }
 }
 */
function saveNAP( )
{
    var mydata =
    {
        'Name' : $.trim( $( '#gateway-nap-name' ).val( ) ),
        'Type' : $( '#gateway-nap-type :selected' ).val( ),
        'oldName' : $( '#gateway-nap-old-name' ).val( )
    }

    if( mydata['Name'] == '' )
    {
        ShowNotice( ajaxI18N( 'gateway-nap-error-name-is-required' ), false );
        return;
    }
    // NAP type data
    switch( mydata['Type'] )
    {
        case 'SIP':
            mydata['Username'] = $.trim( $( '#gateway-nap-sip-username' ).val( ) );
            if( mydata['Username'] == '' )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-error-sip-username-is-required' ), false );
                return;
            }
            mydata['Domain'] = $.trim( $( '#gateway-nap-sip-domain' ).val( ) );
            if( mydata['Domain'] == '' )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-error-sip-domain-is-required' ), false );
                return;
            }
            mydata['DomainPort'] = $.trim( $( '#gateway-nap-sip-domain-port' ).val( ) );
            if( mydata['DomainPort'] == '' )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-error-sip-domain-port-is-required' ), false );
                return;
            }
            mydata['Proxy'] = $.trim( $( '#gateway-nap-sip-proxy' ).val( ) );
            mydata['ProxyPort'] = $.trim( $( '#gateway-nap-sip-proxy-port' ).val( ) );
            mydata['Register'] = $( '#gateway-nap-sip-register' ).is( ':checked' );
            mydata['AuthorizationUser'] = $.trim( $( '#gateway-nap-sip-authorization-user' ).val( ) );
            mydata['Password'] = $.trim( $( '#gateway-nap-sip-password' ).val( ) );
            mydata['Expires'] = $.trim( $( '#gateway-nap-sip-expires' ).val( ) );
            break;
        case 'Trunk':
            mydata['Links'] = [];
            // Full links
            $( '[class~="gateway-nap-trunk-link"]:checked' ).each( function( idx, elm )
            {
                mydata['Links'].push( $( elm ).attr( 'id' ) );
            } );
            // Fractions
            $( '[class~="gateway-nap-trunk-link-channel"]:checked' ).each( function( idx, elm )
            {
                mydata['Links'].push( $( elm ).attr( 'id' ) );
            } );
            if( mydata['Links'].length == 0 )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-trunk-error-link-or-channel-required' ), false );
                return;
            }
            break;
        case 'GSM':
            mydata['Channels'] = [];
            $( '[class~="gateway-nap-gsm-channel"]:checked' ).each( function( idx, elm )
            {
                mydata['Channels'].push( $( elm ).attr( 'id' ) );
            } );
            if( mydata['Channels'].length == 0 )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-gsm-error-channel-required' ), false );
                return;
            }
            break;
        case 'FXO':
            mydata['Channels'] = [];
            $( '[class~="gateway-nap-fxo-channel"]:checked' ).each( function( idx, elm )
            {
                mydata['Channels'].push( $( elm ).attr( 'id' ) );
            } );
            if( mydata['Channels'].length == 0 )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-fxo-error-channel-required' ), false );
                return;
            }
        case 'FXS':
            mydata['Branches'] =
            {
            };
            var count = 0;
            $( '[class~="gateway-nap-fxs-branch"]' ).each( function( idx, elm )
            {
                if( $( elm ).val( ) != '' )
                {
                    mydata['Branches'][$( elm ).attr( 'id' )] = $( elm ).val( );
                    count++;
                }
            } );
            if( count == 0 )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-fxs-error-branch-required' ), false );
                return;
            }
            delete count;
            break;
        default:
            ShowNotice( ajaxI18N( 'gateway-nap-error-type-is-required' ), false );
            return;
    }
    $( '#refreshing' ).show( );
    $.ajax(
    {
        url : GLOBALAjaxURL + '&ajaxTo=saveNAP',
        data : mydata,
        dataType : "json",
        type : "POST",
        success : function( data )
        {
            $( '#refreshing' ).hide( );
            if( data.success )
            {
                ShowNotice( data.message, true );
                backNAPs( );
            }
            else
            {
                ShowNotice( data.message, false );
            }
        },
        error : ajaxDefaultError
    } )
}

function initTimeRestraints( )
{
    $( '#TimeRestraintsTable' ).tablesorter(
    {
        cssAsc : 'tablesorter-asc',
        cssDesc : 'tablesorter-desc',
        cssHeader : 'tablesorter-undefined',
        headers :
        {
            1 :
            {
                sorter : false
            }
        },
        sortList : [[0, 0]]
    } );
}

function backTimeRestraints( )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showTimeRestraintsGW",
        dataType : "html",
        success : function( html )
        {
            $( '#formulario' ).html( html );
            initTimeRestraints( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function removeTimeRestraints( name )
{
    if( ajaxConfirm( 'removeTimeRestraints' ) )
    {
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=removeTimeRestraints",
            data :
            {
                'name' : name
            },
            dataType : "json",
            type : 'POST',
            success : function( data )
            {
                if( data.success )
                {
                    ShowNotice( data.message, true );
                    backTimeRestraints( );
                }
                else
                {
                    ShowNotice( data.message, false );
                }
                $( '#refreshing' ).hide( );
            }
        } );
    }
}

function newTimeRestraints( )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=newTimeRestraintsGW",
        dataType : "html",
        success : function( retorno )
        {
            $( '#TimeRestraintsDivTable' ).html( retorno );
            ApplyDropDownCheckBox( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function editTimeRestraints( name )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=newTimeRestraintsGW&name=" + name,
        dataType : "text",
        success : function( retorno )
        {
            $( '#TimeRestraintsDivTable' ).html( retorno );
            ApplyDropDownCheckBox( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function validaHorario( )
{
    var fromHour = $( "#fromHour" ).val( );
    fromHour[0] == '0' ? fromHour = fromHour[1] : '';

    var toHour = $( "#toHour" ).val( );
    toHour[0] == '0' ? toHour = toHour[1] : '';

    var fromMin = $( "#fromMinutes" ).val( );
    fromMin[0] == '0' ? fromMin = fromMin[1] : '';

    var toMin = $( "#toMinutes" ).val( );
    toMin[0] == '0' ? toMin = toMin[1] : '';

    var erros = 0;

    if( fromHour == '' || toHour == '' || fromMin == '' || toMin == '' || isNaN( fromHour ) || isNaN( toHour ) || isNaN( fromMin ) || isNaN( toMin ) )
        erros++;

    if( fromHour < 0 || fromHour > 24 )
        erros++;

    if( toHour < 0 || toHour > 24 )
        erros++;

    if( fromMin < 0 || fromMin > 59 )
        erros++;

    if( toMin < 0 || toMin > 59 )
        erros++;

    if( erros > 0 )
    {
        ajaxAlert( 'reportValidTime' );
        return false;
    }
    else
        return true;
}

function saveTimeRestraints( )
{
    var data = '';
    var TimeRestraintsId = $( "#TimeRestraintsId" ).val( );
    var TimeRestraintsPos = $( "#TimeRestraintsPos" ).val( );
    var name = $.trim( $( "#timeRestraintsName" ).val( ) );

    if( name == '' )
    {
        ajaxAlert( 'reportNameRestraints' );
        return false;
    }
    data += construcQueryStrig( "Name", name );

    //horario
    var hour = '';
    if( $( '#checkHour' ).is( ':checked' ) )
    {
        if( !validaHorario( ) )
            return false;

        var hour = $( "#fromHour" ).val( ) + ':' + $( "#fromMinutes" ).val( );
        hour += '-';
        hour += $( "#toHour" ).val( ) + ':' + $( "#toMinutes" ).val( );
    }

    data += construcQueryStrig( "Hour", hour );

    //dias da semana
    var wdays = '';
    if( $( '#checkWeekDay' ).is( ':checked' ) )
    {
        if( $( '#weekDay-combo' ).val( ) != null )
            wdays = $( '#weekDay-combo' ).val( );
        if( wdays == '' )
        {
            ajaxAlert( 'reportWeekDay' );
            return false;
        }
    }
    data += construcQueryStrig( "WDay", wdays );

    //dias do mes
    var days = '';
    if( $( '#checkMonthDay' ).is( ':checked' ) )
    {
        $( '#monthDayTable input[type="checkbox"]' ).each( function( )
        {
            if( $( this ).is( ':checked' ) )
                days += $( this ).val( ) + ', ';
        } );
        //clear the last coma
        days = days.substr( 0, days.length - 2 );
        if( days == '' )
        {
            ajaxAlert( 'reportMonthDay' );
            return false;
        }
    }
    data += construcQueryStrig( "Day", days );

    //meses
    var months = '';
    if( $( '#checkMonth' ).is( ':checked' ) )
    {
        if( $( '#month-combo' ).val( ) != null )
            months = $( '#month-combo' ).val( );
        if( months == '' )
        {
            ajaxAlert( 'reportMonth' );
            return false;
        }
    }
    data += construcQueryStrig( "Month", months );
    //clear the last pipe
    data = data.substr( 0, data.length - 1 );

    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveTimeRestraints&id=" + TimeRestraintsId + "&TimeRestraintsPos=" + TimeRestraintsPos + "&data=" + data,
        dataType : "html",
        success : function( retorno )
        {
            retorno = retorno.replace( /(\r\n|\n|\r)/gm, "" );
            resp = retorno.split( '|' );
            if( resp[0] == 'ok' )
            {
                ShowNotice( resp[1], true );
                backTimeRestraints( );
            }
            else
                ShowNotice( resp[1], false );
            $( '#refreshing' ).show( );
        }
    } );
}

function setPosition( pos, id )
{
    $( '#' + id + 'Position' ).val( pos );
}

function normalizeField( id )
{
    var v = $( '#' + id ).val( );
    if( v.length < 2 )
        var v = $( '#' + id ).val( '0' + (v) );
}

function up( id )
{
    if( $( '#' + id + 'Position' ).val( ) == 'hour' )
    {
        var campo = $( '#' + id + 'Hour' ).val( );
        if( campo != '' && !isNaN( campo ) )
        {
            if( campo[0] == '0' )
                campo = campo[1];
            var hour = parseInt( campo );
            if( hour <= 22 )
                $( '#' + id + 'Hour' ).val( hour + 1 );
            if( hour >= 23 )
                $( '#' + id + 'Hour' ).val( 0 );
        }
        else
            $( '#' + id + 'Hour' ).val( 0 );
        normalizeField( id + 'Hour' );
    }
    else
    {
        var campo = $( '#' + id + 'Minutes' ).val( );
        if( campo != '' && !isNaN( campo ) )
        {
            if( campo[0] == '0' )
                campo = campo[1];
            var minutes = parseInt( campo );
            if( minutes == '' )
                $( '#' + id + 'Minutes' ).val( 0 );
            if( minutes <= 58 )
                $( '#' + id + 'Minutes' ).val( minutes + 1 );
            if( minutes >= 59 )
                $( '#' + id + 'Minutes' ).val( 0 );
        }
        else
            $( '#' + id + 'Minutes' ).val( 0 );

        normalizeField( id + 'Minutes' );

    }
}

function down( id )
{
    if( $( '#' + id + 'Position' ).val( ) == 'hour' )
    {
        var campo = $( '#' + id + 'Hour' ).val( );
        if( campo != '' && !isNaN( campo ) )
        {
            if( campo[0] == '0' )
                campo = campo[1];
            var hour = parseInt( campo );
            if( hour == '' )
                $( '#' + id + 'Hour' ).val( 0 );
            if( hour <= 23 )
                $( '#' + id + 'Hour' ).val( hour - 1 );
            if( hour == 0 )
                $( '#' + id + 'Hour' ).val( 23 );
            if( hour > 23 )
                $( '#' + id + 'Hour' ).val( 0 );
        }
        else
            $( '#' + id + 'Hour' ).val( 0 );

        normalizeField( id + 'Hour' );
    }
    else
    {
        var campo = $( '#' + id + 'Minutes' ).val( );
        if( campo != '' && !isNaN( campo ) )
        {
            if( campo[0] == '0' )
                campo = campo[1];
            var minutes = parseInt( campo );
            if( minutes == '' )
                $( '#' + id + 'Minutes' ).val( 0 );
            if( minutes <= 59 )
                $( '#' + id + 'Minutes' ).val( minutes - 1 );
            if( minutes == 0 )
                $( '#' + id + 'Minutes' ).val( 59 );
            if( minutes > 59 )
                $( '#' + id + 'Minutes' ).val( 0 );
        }
        else
            $( '#' + id + 'Minutes' ).val( 0 );

        normalizeField( id + 'Minutes' );
    }
}

function showHourTable( )
{
    if( $( '#checkHour' ).is( ':checked' ) )
        $( '#hourTable' ).show( );
    else
        $( '#hourTable' ).hide( );
}

function showWeekDaysTable( )
{
    if( $( '#checkWeekDay' ).is( ':checked' ) )
    {
        $( '#weekDayTable' ).show( );
        $( "#ddcl-weekDay-combo" ).show( );
    }
    else
    {
        $( '#weekDayTable' ).hide( );
        $( "#ddcl-weekDay-combo" ).hide( );
    }
}

function showMonthDayTable( )
{
    if( $( '#checkMonthDay' ).is( ':checked' ) )
        $( '#monthDayTable' ).show( );
    else
        $( '#monthDayTable' ).hide( );
}

function showMonthTable( )
{
    if( $( '#checkMonth' ).is( ':checked' ) )
    {
        $( '#monthTable' ).show( );
        $( "#ddcl-month-combo" ).show( );
    }
    else
    {
        $( '#monthTable' ).hide( );
        $( "#ddcl-month-combo" ).hide( );
    }
}

function openFraction( serial )
{
    $( '#partLink-' + serial ).show( );
    $( '#fullLink-' + serial ).hide( );
    $( '#fullLink-' + serial + ' input[type="checkbox"]' ).each( function( )
    {
        $( this ).removeAttr( "checked" );
    } );
}

function closeFraction( serial )
{
    $( '#partLink-' + serial ).hide( );
    $( '#fullLink-' + serial ).show( );
    $( '#partLink-' + serial + ' input[type="checkbox"]' ).each( function( )
    {
        $( this ).removeAttr( "checked" );
    } );
}

function autoCompleteFXS( serial )
{
    var reply = $.trim( ajaxPrompt( 'enterFirstBranche' ) );
    if( isNumeric( reply ) && reply != '' )
    {
        $( '#branches-' + serial + ' input[type="text"]' ).each( function( )
        {
            $( this ).attr( "value", reply );
            reply++;
        } );
    }
}

function cleanFXS( serial )
{
    if( ajaxConfirm( 'cleanTypedBranches' ) )
    {
        $( '#branches-' + serial + ' input[type="text"]' ).each( function( )
        {
            $( this ).attr( "value", '' );
        } );
    }
}

// fim do gateway

function ApplyDropDownCheckBox( )
{
    var select = ajaxI18N( 'selectOne' );
    var close = ajaxI18N( 'closeDropDown' );
    $( "#weekDay-combo" ).dropdownchecklist(
    {
        emptyText : select + "...",
        explicitClose : close + ' [x]',
        width : 200,
        icon :
        {
        },
        maxDropHeight : 150
    } );

    $( "#month-combo" ).dropdownchecklist(
    {
        emptyText : select + "...",
        explicitClose : close + ' [x]',
        width : 200,
        icon :
        {
        },
        maxDropHeight : 250
    } );
    showWeekDaysTable( );
    showMonthTable( );
}

function initNetworkGW( )
{
    // change dns configuration method event handler
    $( '#gateway-network-dns-method' ).change( function( )
    {
        if( $( this ).val( ) == 'static' )
        {
            $( '#gateway-network-dns-config' ).show( );
        }
        else
        {
            $( '#gateway-network-dns-config' ).hide( );
        }
    } );
    // change network configuration method event handler
    $( '.gateway-network-interface-method' ).each( function( idx, elm )
    {
        $( elm ).change( function( )
        {
            var iface = $( this ).attr( 'id' ).split( '-' ).pop( );

            switch( $( this ).val( ) )
            {
                case 'dhcp':
                    $( '#gateway-network-config-dhcp-' + iface ).show( );
                    $( '#gateway-network-config-static-' + iface ).hide( );
                    $( '#gateway-network-dns-method' ).prop( 'disabled', false );
                    break;
                case 'static':
                    $( '#gateway-network-config-static-' + iface ).show( );
                    $( '#gateway-network-config-dhcp-' + iface ).hide( );
                    $( '#gateway-network-dns-method' ).val( 'static' );
                    $( '#gateway-network-dns-method' ).change( );
                    $( '#gateway-network-dns-method' ).prop( 'disabled', true );
                    break;
            }
        } );
        $( elm ).change( );
    } );

    // append dns server input text
    $( '#gateway-network-dns-add' ).click( function( ev )
    {
        var _input = $( '<input type=\'text\' class=\'gateway-network-dns-server ipv4\' />' );
        _input.ipAddress( );
        $( '#gateway-network-dns-server-list' ).append( _input );
        $( '#gateway-network-dns-server-list' ).append( '<br />' );
        ev.preventDefault( );
    } );
    // append ntp server input text
    $( '#gateway-network-ntp-add' ).click( function( ev )
    {
        $( '#gateway-network-ntp-server-list' ).append( '<input type=\'text\' class=\'gateway-network-ntp-server\' /><br />' );
        ev.preventDefault( );
    } );
    // save network configuration event
    $( '#gateway-network-save' ).click( function( )
    {
        try
        {
            var config =
            {
                'ifaces' :
                {
                },
                'ntp' :
                {
                    'enabled' : $( '#gateway-network-ntp-enable' ).is( ':checked' ) ? 'yes' : 'no',
                    'timeout' : $( '#gateway-network-ntp-timeout' ).val( ),
                    'servers' : []
                }
            };

            // network interfaces + dns
            $( '.gateway-network-interface' ).each( function( idx, elm )
            {
                getIpv4 = function( element )
                {
                    return $( element ).val( ).isIpv4( ) ? $( element ).val( ) : "";
                }
                var iface = $( this ).attr( 'id' ).split( '-' ).pop( );
                var ifacedata =
                {
                    'config' :
                    {
                    },
                    'properties' :
                    {
                        'method' : $( '#gateway-network-method-' + iface + ' :selected' ).val( ),
                        'family' : 'inet'
                    }
                };

                switch( ifacedata['properties']['method'] )
                {
                    case 'static':
                        ifacedata['config'] =
                        {
                            'address' : getIpv4( '#gateway-network-static-address-' + iface ),
                            'netmask' : getIpv4( '#gateway-network-static-netmask-' + iface ),
                            'gateway' : getIpv4( '#gateway-network-static-gateway-' + iface )
                        };
                        if( ifacedata['config']['address'].length == 0 )
                        {
                            throw 'gateway-network-interface-error-address-required';
                        }
                        if( ifacedata['config']['netmask'].length == 0 )
                        {
                            throw 'gateway-network-interface-error-netmask-required';
                        }
                        break;
                    case 'dhcp':
                        break;
                    default:
                        alert( "unsupported method" );
                        return;
                }

                switch( $('#gateway-network-dns-method').val() )
                {
                    case 'static':
                        var nameservers = [];
                        $( '.gateway-network-dns-server' ).each( function( )
                        {
                            _ip = getIpv4( this );
                            if( _ip )
                            {
                                nameservers.push( _ip );
                            }
                        } );
                        ifacedata['config']['dns-search'] = $.trim( $( '#gateway-network-dns-search' ).val( ) );
                        ifacedata['config']['dns-nameservers'] = nameservers;
                        break;
                    case 'dhcp':
                        break;
                    default:
                        alert( "unsupported method" );
                        return;
                }

                config['ifaces'][iface] = ifacedata;
            } );

            // ntp servers
            $( '.gateway-network-ntp-server' ).each( function( )
            {
                _host = $.trim( $( this ).val( ) );
                if( _host.length > 0 )
                {
                    config['ntp']['servers'].push( _host );
                }
            } );

            $.ajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=saveNetworkGW',
                data : config,
                dataType : 'json',
                type : 'post',
                success : function( data )
                {
                    $( '#refreshing' ).hide( );
                    if( data.success )
                    {
                        ShowNotice( data.message, true );
                    }
                    else
                    {
                        ShowNotice( data.message, false );
                    }
                },
                error : ajaxDefaultError
            } );
        }
        catch( err )
        {
            ShowNotice( ajaxI18N( err ), false );
        }
    } );

    // setup masks and validators
    $( '.ipv4' ).ipAddress( );
    $( '#gateway-network-ntp-timeout' ).mask( "9?99" );
}

function timeToRebootAndRedirect( type )
{
    var num = $( '#timeToReboot' ).html( );
    var stopNow = num == '0' ? true : false;
    if( !stopNow )
    {
        $( '#timeToReboot' ).html( parseInt( num ) - 1 );
        setTimeout( 'timeToRebootAndRedirect()', 1000 );
    }
    else
    {
        if( selected == 'static' )
            window.location = 'http://' + $( '#staticIP' ).val( ) + ':14100';

        $( '#rebootText' ).hide( );
    }
}

function maskMasknet( event, comp )
{
    var fullTmp;
    var tmpValue = comp.value;
    var tmpParts = tmpValue.split( "." );
    var isPeriod = (event.keyCode == 194 || event.keyCode == 190 || event.keyCode == 110);

    if( escapeKeys( event ) )
        return true;

    if( tmpParts.length == 4 && isPeriod )
        return false;

    if( tmpParts.length == 4 && tmpParts[3].length == 3 && (parseInt( parseFloat( tmpParts[3] ) ) == 0) )
        return false;

    if( (/\d{3}$/).test( comp.value ) && !isPeriod && tmpParts.length < 4 )
    {
        comp.value += '.';
        tmpValue = comp.value;
        tmpParts = tmpValue.split( "." );
    }

    if( comp.value[comp.value.length - 1] == '.' && isPeriod )
        comp.value = comp.value.substr( 0, comp.value.length - 1 );

    if( parseInt( parseFloat( tmpParts[0] ) ) == 0 )
        return false;

    var charCode = String.fromCharCode( event.keyCode );
    if( event.keyCode == 96 )
        charCode = '0';

    if( tmpParts.length == 4 )
    {
        for( var i = 0; i < tmpParts.length; i++ )
        {
            if( parseInt( parseFloat( tmpParts[i] ) ) >= 256 )
                return false;
        }
    }
    else if( tmpParts.length < 4 )
    {
        for( var i = 0; i < tmpParts.length; i++ )
        {
            if( parseInt( parseFloat( tmpParts[i] ) ) >= 256 )
                return false;
        }
    }
    else
        return false;
}

function shutdownGW( )
{
    if( ajaxConfirm( 'gateway-shutdown-confirm' ) )
    {
        $( '#gateway-power-wait .shutdown' ).show( );
        $( '#gateway-power-wait .reboot' ).hide( );
        var title = ajaxI18N( 'gateway-shutdown' ).toUpperCase( );
        var done = ajaxI18N( 'gateway-shutdown-done' );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=shutdown',
            dataType : 'json',
            type : 'POST',
            success : function( data )
            {
                if( data.success )
                {
                    var wait = $( '#gateway-power-wait' );
                    wait.dialog(
                    {
                        closeOnEscape : false,
                        draggable : false,
                        resizable : false,
                        title : title,
                        modal : true,
                        open : function( event, ui )
                        {
                            $( ".ui-dialog-titlebar-close", $( this ).parent( ) ).hide( );
                        }
                    } );
                    countdown = function( v )
                    {
                        if( v == 0 )
                        {
                            wait.html( done );
                            return;
                        }
                        var b = '';
                        for( var i = 0; i < v; i++ )
                        {
                            b += '.';
                        }
                        $( '#gateway-power-wait .countdown' ).text( b );
                        setTimeout( countdown, 1000, v - 1 );
                    }
                    countdown( 10 );
                }
                else
                {
                    ShowNotice( data.message, false );
                }
            }
        } );
    }
}

function rebootGW( )
{
    if( ajaxConfirm( 'gateway-reboot-confirm' ) )
    {
        $( '#gateway-power-wait .shutdown' ).hide( );
        $( '#gateway-power-wait .reboot' ).show( );
        var title = ajaxI18N( 'gateway-reboot' ).toUpperCase( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=reboot',
            dataType : 'json',
            type : 'POST',
            success : function( data )
            {
                if( data.success )
                {
                    var wait = $( '#gateway-power-wait' );
                    wait.dialog(
                    {
                        closeOnEscape : false,
                        draggable : false,
                        resizable : false,
                        title : title,
                        modal : true,
                        open : function( event, ui )
                        {
                            $( ".ui-dialog-titlebar-close", $( this ).parent( ) ).hide( );
                        }
                    } );
                    countdown = function( v )
                    {
                        if( v == 0 )
                        {
                            wait.dialog( 'destroy' );
                            $( '#refreshing' ).show( );
                            window.location.reload( );
                            return;
                        }
                        var b = '';
                        for( var i = 0; i < v; i++ )
                        {
                            b += '.';
                        }
                        $( '#gateway-power-wait .countdown' ).text( b );
                        setTimeout( countdown, 1000, v - 1 );
                    }
                    countdown( 30 );
                }
                else
                {
                    ShowNotice( data.message, false );
                }
            }
        } );
    }
}

// Fim GW

function getMousePosition( event )
{
    event = event || window.event;
    var e =
    {
        _x : (event.pageX || event.clientX + (document.documentElement || document.body).scrollLeft),
        _y : (event.pageY || event.clientY + (document.documentElement || document.body).scrollTop)
    };
    mousePosition = e._x + e._y;
}

function checkDeviceListOrder( )
{
    var deviceOrder = document.getElementById( 'sortableDevice' ).children;
    var deviceOrderLength = deviceOrder.length;
    var deviceOrder = '';
    for( var i = 0; i < deviceOrderLength; i++ )
    {
        if( document.getElementById('sortableDevice').children[i].children[0] )
        {
            node = document.getElementById('sortableDevice').children[i].children[0].id;
            if( deviceOrder == '' )
                deviceOrder = document.getElementById( node ).value;
            else
                deviceOrder += '|' + document.getElementById( node ).value;
        }
    }
    return deviceOrder;
}

function checkOriginalDeviceOrder( )
{
    var originalOrder = document.getElementById( 'originalDeviceOrder' ).value;
    var order = checkDeviceListOrder( );
    if( originalOrder == order )
        return true;
    else
    {
        document.getElementById( 'originalDeviceOrder' ).value = order;
        return false;
    }
}

// variaveis gerais
var mousePosition;
var mouseFinalPos;
var deviceSend = '';
var valueIndex;
var selectedText = new Array( );
var selectedValues = new Array( );
var from = "";
var to = "";

function checkDeviceOrder( send, event )
{
    deviceSend = send;
    mouseFinalPos = getMouseFinalPosition( event );
    setTimeout( "delayedCheck()", 1000 );
}

function getMouseFinalPosition( event )
{
    event = event || window.event;
    var e =
    {
        _x : (event.pageX || event.clientX + (document.documentElement || document.body).scrollLeft),
        _y : (event.pageY || event.clientY + (document.documentElement || document.body).scrollTop)
    };
    return e._x + e._y;
}

function delayedCheck( )
{
    if( checkOriginalDeviceOrder( ) )
    {
        var finalPosition = mouseFinalPos;
        if( finalPosition < (mousePosition + 10) & finalPosition > (mousePosition - 10) )
            editDevice( deviceSend );
    }
    else
    {
        var teste = checkDeviceListOrder( );
        changeDeviceOrder( teste );
    }
    return;
}

function getMouseFinalPosition( event )
{
    event = event || window.event;
    var e =
    {
        _x : (event.pageX || event.clientX + (document.documentElement || document.body).scrollLeft),
        _y : (event.pageY || event.clientY + (document.documentElement || document.body).scrollTop)
    };
    return e._x + e._y;
}

function checkDeviceOrder( send, event )
{
    deviceSend = send;
    mouseFinalPos = getMouseFinalPosition( event );
    setTimeout( "delayedCheck()", 1000 );
}

function changeDeviceOrder( deviceList )
{
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=changeDeviceOrder&deviceList=" + deviceList,
        dataType : "html",
        success : function( text )
        {
        }
    } );
}

function k3lreload( )
{
    $( '#refreshing' ).show( );
    $( '#reload-button' ).attr( 'disabled', 'true' );
    $( '#reload-button' ).css( 'background', 'gray' );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=k3lReload",
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );

            var tmp = text.split( '|' );
            tmp[0] = tmp[0].replace( /(\r\n|\n|\r)/gm, "" );

            if( tmp[0] == 'ok' )
                ShowNotice( tmp[1], true );
            else
                ShowNotice( tmp[1], false );

            $( '#reload-button' ).removeAttr( 'disabled' );
            $( '#reload-button' ).css( 'background', '#339966' );
        }
    } );
}

function saveGeneral( )
{
    var MPC = '&MfcPatternCountry=' + $( '#MfcPatternCountry' ).val( );

    var LineSensibility = '&FXOLineSensibility=';
    var qtde = $( '#FXOChannelsTotal' ).val( );
    if( qtde > 0 )
    {
        for( i = 0; i < qtde; i++ )
            LineSensibility += $( '#FXOLineSensibility' + i ).val( ) + ',';
    }
    LineSensibility = LineSensibility.substr( 0, LineSensibility.length - 1 );

    var GSMPin = '&GSMPin=';
    var qtdeP = $( '#GSMPinsTotal' ).val( );
    if( qtdeP > 0 )
    {
        for( j = 0; j < qtdeP; j++ )
        {
            GSMPin += $( '#GSMPinA' + j ).val( ) + ':' + $( '#GSMPinB' + j ).val( ) + ',';
        }

    }
    GSMPin = GSMPin.substr( 0, GSMPin.length - 1 );

    $( '#refreshing' ).show( );
    $( '#saveGeneralB' ).attr( 'disabled', 'true' );
    $( '#saveGeneralB' ).css( 'background', 'gray' );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveGeneral" + MPC + LineSensibility + GSMPin,
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );
            ShowNotice( text, true );
            $( '#saveGeneralB' ).removeAttr( 'disabled' );
            $( '#saveGeneralB' ).css( 'background', '#339966' );
        }
    } );
}

function initPointCodes( )
{
    /**
     * Back to point codes list
     */
    var backPointCodes = function( )
    {
        changeView( 'showPointCodes', null, 'menu-telephony,menu-ss7,menu-point-codes' );
    };
    /**
     * Find point code name inside main table
     */
    var findPointCode = function( elm )
    {
        return $( elm ).parent( ).parent( ).children( ).first( ).text( );
    };
    /**
     * Convert decimal do point code parts
     */
    var decToPointCode = function( )
    {
        var _val = parseInt( $( "#ss7-pointcode-form-decimal" ).val( ) );
        if( isNaN( _val ) )
        {
            $( "#ss7-pointcode-form-first" ).val( 0 );
            $( "#ss7-pointcode-form-middle" ).val( 0 );
            $( "#ss7-pointcode-form-last" ).val( 0 );
            return;
        }
        var _bin = d2b( _val );
        var _padsize = 14 - _bin.length;
        var _padding = '';

        if( _padsize >= 0 )
        {
            for( var x = 0; x < _padsize; x++ )
                _padding += '0';

            _bin = _padding + _bin;
            $( "#ss7-pointcode-form-first" ).val( b2d( _bin.substr( 0, 3 ) ) );
            $( "#ss7-pointcode-form-middle" ).val( b2d( _bin.substr( 3, 8 ) ) );
            $( "#ss7-pointcode-form-last" ).val( b2d( _bin.substr( 11, 3 ) ) );
        }
    };
    /**
     * Convert point code parts to decimal
     */
    var pointCodeToDec = function( )
    {
        var _tobinary = function( value, size )
        {
            value = parseInt( value );
            if( isNaN( value ) )
            {
                throw 'isNaN';
            }
            value = d2b( value );
            var _padsize = size - value.length;
            for( var x = 0; x < _padsize; x++ )
            {
                value = '0' + value;
            }
            return value;
        };
        try
        {
            var first = _tobinary( $( "#ss7-pointcode-form-first" ).val( ), 3 );
            var middle = _tobinary( $( "#ss7-pointcode-form-middle" ).val( ), 8 );
            var last = _tobinary( $( "#ss7-pointcode-form-last" ).val( ), 3 );

            $( "#ss7-pointcode-form-decimal" ).val( b2d( first + middle + last ) );
        }
        catch( e )
        {
            $( "#ss7-pointcode-form-decimal" ).val( 0 );
        }
    };
    /**
     * Initialize point code form
     */
    var initPointCodeForm = function( data )
    {
        $( '#ss7-pointcode-content' ).html( data );
        $( '#refreshing' ).hide( );

        //TODO: attach max number check for each field
        $( "#ss7-pointcode-form-decimal" ).mask( "9?9999" ).keyup( decToPointCode );
        $( "#ss7-pointcode-form-first" ).mask( "9" ).keyup( pointCodeToDec );
        $( "#ss7-pointcode-form-middle" ).mask( "9?99" ).keyup( pointCodeToDec );
        $( "#ss7-pointcode-form-last" ).mask( "9" ).keyup( pointCodeToDec );

        $( ".ss7-pointcode-save" ).click( savePointCode );
        $( ".ss7-pointcode-back" ).click( backPointCodes );
    };
    /**
     * Save point code form
     */
    var savePointCode = function( )
    {
        $( ".ss7-pointcode-save" ).addClass( "disabled" ).attr( "disabled", true );
        $( ".ss7-pointcode-back" ).addClass( "disabled" ).attr( "disabled", true );
        var mydata =
        {
        };
        try
        {
            $( "#ss7-pointcode-content table input:text" ).each( function( )
            {
                mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
            } );
            $( "#ss7-pointcode-content table input:hidden" ).each( function( )
            {
                mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
            } );
            if( mydata['__name__'] == '' )
            {
                throw 'ss7-pointcode-error-name-is-required';
            }
            if( mydata['__decimal__'] == '' )
            {
                throw 'ss7-pointcode-error-decimal-is-required';
            }
            if( mydata['__first__'] == '' || mydata['__middle__'] == '' || mydata['__last__'] == '' )
            {
                throw 'ss7-pointcode-error-3-8-3-is-required';
            }
            $( '#refreshing' ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=savePointCode",
                data : mydata,
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( '#refreshing' ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        backPointCodes( );
                    }
                    $( ".ss7-pointcode-save" ).removeClass( "disabled" ).removeAttr( "disabled" );
                    $( ".ss7-pointcode-back" ).removeClass( "disabled" ).removeAttr( "disabled" );
                },
                error : ajaxDefaultError
            } );
        }
        catch( err )
        {
            ShowNotice( ajaxI18N( err ), false );
            $( ".ss7-pointcode-save" ).removeClass( "disabled" ).removeAttr( "disabled" );
            $( ".ss7-pointcode-back" ).removeClass( "disabled" ).removeAttr( "disabled" );
        }
    };
    /**
     * Add Point Code
     */
    var addPointCode = function( )
    {
        $( '#refreshing' ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=addPointCode",
            dataType : "html",
            success : initPointCodeForm,
            error : ajaxDefaultError
        } );
    };
    /**
     * Edit Point Code
     */
    var editPointCode = function( )
    {
        var name = findPointCode( $( this ) );
        $( '#refreshing' ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=addPointCode",
            data :
            {
                name : name
            },
            dataType : "html",
            type : "POST",
            success : initPointCodeForm,
            error : ajaxDefaultError
        } );
    };
    /**
     * Delete Point Code
     */
    var deletePointCode = function( )
    {
        if( ajaxConfirm( 'ss7-pointcode-confirm-delete' ) )
        {
            var name = findPointCode( $( this ) );
            $( "#refreshing" ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=removePointCode",
                data :
                {
                    name : name
                },
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( "#refreshing" ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        backPointCodes( );
                    }
                },
                error : ajaxDefaultError
            } );
        }
    };
    // main table handlers
    $( '.ss7-pointcode-edit' ).click( editPointCode );
    $( '.ss7-pointcode-delete' ).click( deletePointCode );
    $( '.ss7-pointcode-add' ).click( addPointCode );
}

function initMtp2( )
{
    /**
     * Back to MTP2 list
     */
    var backMtp2 = function( )
    {
        changeView( 'showMTP2', null, 'menu-telephony,menu-ss7,menu-mtp7' );
    };
    /**
     * Find MTP2 link name inside main table
     */
    var findMtp2 = function( elm )
    {
        return $( elm ).parent( ).parent( ).children( ).first( ).text( );
    };
    /**
     * Save MTP2 form
     */
    var saveMtp2 = function( )
    {
        try
        {
            $( '.ss7-mtp2-save' ).addClass( "disabled" ).attr( "disabled", true );
            $( '.ss7-mtp2-back' ).addClass( "disabled" ).attr( "disabled", true );

            var mydata =
            {
                'Passive' : $( '#ss7-mtp2-content input[name~="Passive"]' ).is( ':checked' )
            };
            $( '#ss7-mtp2-content input:text' ).each( function( idx, elm )
            {
                mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
            } );
            $( '#ss7-mtp2-content input:hidden' ).each( function( idx, elm )
            {
                mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
            } );

            if( mydata['__name__'] == '' )
            {
                throw 'ss7-mtp2-error-name-is-required';
            }
            if( ! mydata['Address'].isIpv4( ) )
            {
                throw 'ss7-mtp2-error-address-is-required';
            }
            if( mydata['Device'] == '' )
            {
                throw 'ss7-mtp2-error-device-is-required';
            }
            if( mydata['Link'] == '' )
            {
                throw 'ss7-mtp2-error-device-link-is-required';
            }
            var timers = ['T1', 'T2', 'T3', 'T5', 'T6', 'T7', 'ProvingEmergency', 'ProvingNormal'];
            // validate and populate the timers array
            mydata['Timers'] =
            {
            };
            for( var i = 0; i < timers.length; i++ )
            {
                if( mydata[timers[i]] == '' )
                {
                    throw 'ss7-mtp2-error-all-timers-are-required';
                }
                else
                {
                    mydata['Timers'][timers[i]] = mydata[timers[i]];
                    delete mydata[timers[i]];
                }
            }

            //  seems all valid, submit the data
            $( '#refreshing' ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=saveMTP2',
                data : mydata,
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( '#refreshing' ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        backMtp2( );
                    }
                    $( '.ss7-mtp2-save' ).removeClass( "disabled" ).removeAttr( "disabled" );
                    $( '.ss7-mtp2-back' ).removeClass( "disabled" ).removeAttr( "disabled" );
                },
                error : ajaxDefaultError
            } );
        }
        catch( err )
        {
            $( '.ss7-mtp2-save' ).removeClass( "disabled" ).removeAttr( "disabled" );
            $( '.ss7-mtp2-back' ).removeClass( "disabled" ).removeAttr( "disabled" );
            ShowNotice( ajaxI18N( err ), false );
        }
    };
    /**
     * Initialize MTP2 form
     */
    var initMtp2Form = function( data )
    {
        $( '#ss7-mtp2-content' ).html( data );
        $( '#refreshing' ).hide( );
        // fields handlers
        $( '.ipv4' ).ipAddress( );
        //$( '.integer' ).k3l( 'bind', 'validator', 'required' ).mask(
        // '9?999999999' );
        $( '.integer' ).mask( '9?999999999' );
        //$( '#ss7-mtp2-device').k3l( 'bind', 'validator', 'serial' ).mask(
        // '999?9999999' ).k3l( 'bind', 'validator', 'required' );
        $( '#ss7-mtp2-device' ).mask( '999?9999999' );
        $( '#ss7-mtp2-device-link' ).mask( '9' );

        $( '.ss7-mtp2-save' ).click( saveMtp2 );
        $( '.ss7-mtp2-back' ).click( backMtp2 );
    };
    /**
     * Display MTP2 form for addition
     */
    var addMtp2 = function( )
    {
        $( '#refreshing' ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=addMTP2",
            dataType : "html",
            success : initMtp2Form,
            error : ajaxDefaultError
        } );
    };
    /**
     * Display MTP2 form for edition
     */
    var editMtp2 = function( )
    {
        var name = findMtp2( $( this ) );
        $( '#refreshing' ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=editMTP2",
            data :
            {
                name : name
            },
            dataType : "html",
            type : "POST",
            success : initMtp2Form,
            error : ajaxDefaultError
        } );
    };
    /**
     * Delete MTP2
     */
    var deleteMtp2 = function( )
    {
        if( ajaxConfirm( 'ss7-mtp2-delete-confirm' ) )
        {
            var name = findMtp2( $( this ) );
            $( '#refreshing' ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=removeMTP2",
                data :
                {
                    name : name
                },
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( '#refreshing' ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        backMtp2( );
                    }
                },
                error : ajaxDefaultError

            } );
        }
        return;
    };
    // initialize main list
    $( '.ss7-mtp2-edit' ).click( editMtp2 );
    $( '.ss7-mtp2-delete' ).click( deleteMtp2 );
    $( '.ss7-mtp2-add' ).click( addMtp2 );
}

function initMtp3LinkSets( )
{
    /**
     * Back to MTP3 link set list
     */
    var backMtp3LinkSet = function( )
    {
        changeView( 'showLinkSets', null, 'menu-telephony,menu-ss7,menu-mtp3,menu-linksets' );
    };
    /**
     * Find MTP3 link set name inside main table
     */
    var findMtp3LinkSet = function( elm )
    {
        return $( elm ).parent( ).parent( ).children( ).first( ).text( );
    };
    /**
     * Save MTP3 link set form
     */
    var saveMtp3LinkSet = function( )
    {
        $( ".ss7-mtp3-linkset-save" ).addClass( "disabled" ).attr( "disabled", true );
        $( ".ss7-mtp3-linkset-back" ).addClass( "disabled" ).attr( "disabled", true );

        try
        {
            var mydata =
            {
                'Links' : []
            };
            $( "#ss7-mtp3-linkset-form-table input:text" ).each( function( )
            {
                mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
            } );
            $( "#ss7-mtp3-linkset-form-table input:hidden" ).each( function( )
            {
                mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
            } );
            $( "#ss7-mtp3-linkset-form-table select" ).each( function( )
            {
                mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
            } );
            // add links
            $( "#ss7-mtp3-linkset-links ul li input" ).each( function( )
            {
                var tmp = JSON.parse( $( this ).val( ) );
                var _link =
                {
                };
                _link[tmp.Mtp2] = tmp;
                mydata['Links'].push( _link );
            } );

            // validation
            if( mydata['__name__'] == '' )
            {
                throw 'ss7-mtp3-linkset-error-name-is-required';
            }
            if( mydata['Origin'] == '<SELECT>' )
            {
                throw 'ss7-mtp3-linkset-error-origin-point-code-is-required';
            }
            if( mydata['Adjacent'] == '<SELECT>' )
            {
                throw 'ss7-mtp3-linkset-error-adjacent-point-code-is-required';
            }
            if( mydata['Origin'] == mydata['Adjacent'] )
            {
                throw 'ss7-mtp3-linkset-error-origin-adjacent-should-be-different';
            }
            if( mydata['NetworkIndicator'] == '<SELECT>' )
            {
                throw 'ss7-mtp3-linkset-error-network-indicator-is-required';
            }
            if( mydata['Links'].length == 0 )
            {
                throw 'ss7-mtp3-linkset-error-at-least-one-link-is-required';
            }

            $( "#refreshing" ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=saveLinkSet",
                data : mydata,
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( "#refreshing" ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        backMtp3LinkSet( );
                    }
                    $( ".ss7-mtp3-linkset-save" ).removeClass( "disabled" ).removeAttr( "disabled" );
                    $( ".ss7-mtp3-linkset-back" ).removeClass( "disabled" ).removeAttr( "disabled" );
                },
                error : ajaxDefaultError
            } );
        }
        catch( err )
        {
            $( ".ss7-mtp3-linkset-save" ).removeClass( "disabled" ).removeAttr( "disabled" );
            $( ".ss7-mtp3-linkset-back" ).removeClass( "disabled" ).removeAttr( "disabled" );
            ShowNotice( ajaxI18N( err ), false );
        }
    };
    /**
     * Initialize MTP3 link set form
     */
    var initMtp3LinkSetForm = function( data )
    {
        $( "#refreshing" ).hide( );
        $( "#ss7-mtp3-linkset" ).html( data );

        // buttons
        $( ".ss7-mtp3-linkset-save" ).click( saveMtp3LinkSet );
        $( ".ss7-mtp3-linkset-back" ).click( backMtp3LinkSet );

        // advanced configuration options
        $( ".expand-next" ).each( function( idx, elm )
        {
            $( elm ).collapser(
            {
                target : 'next',
                effect : 'fade',
                changeText : 0
            }, function( )
            {
            }, function( )
            {
                var txt = $( this ).text( )
                if( txt[0] == "+" )
                {
                    $( this ).text( txt.replace( "+", "-" ) );
                }
                else
                {
                    $( this ).text( txt.replace( "-", "+" ) );
                }
            } );
        } );

        // remove mtp2 link from linkset
        var removeMtp2Link = function( ev )
        {
            var data = JSON.parse( $( this ).parent( ).children( 'input' ).val( ) );
            var _ul = $( this ).parent( ).parent( );

            if( $( "#ss7-mtp3-linkset-mtp2-link" ).children( ).length == 0 || $( "#ss7-mtp3-linkset-slc" ).children( ).length == 0 )
            {
                $( "#ss7-mtp3-linkset-link-form p" ).fadeOut( );
                $( "#ss7-mtp3-linkset-link-form div" ).fadeIn( );
            }
            $( "#ss7-mtp3-linkset-mtp2-link" ).append( $( "<option value='" + data.Mtp2 + "'>" + data.Mtp2 + "</option>" ) );
            $( "#ss7-mtp3-linkset-slc" ).append( $( "<option value='" + data.Slc + "'>" + data.Slc + "</option>" ) );
            $( this ).parent( ).remove( );
            if( _ul.children( ).length == 0 )
            {
                $( "#ss7-mtp3-linkset-links p" ).fadeIn( );
                _ul.fadeOut( );
            }
            ev.stopPropagation( );
        }
        // manage associated linksets
        $( ".ss7-mtp3-linkset-add-link" ).click( function( )
        {
            if( !$( "#ss7-mtp3-linkset-mtp2-link" ).val( ) )
            {
                return;
            }
            var _ul = $( "#ss7-mtp3-linkset-links ul" );
            var _info =
            {
                Mtp2 : $( "#ss7-mtp3-linkset-mtp2-link" ).val( ),
                Slc : $( "#ss7-mtp3-linkset-slc" ).val( ),
                Timers :
                {
                    Q707T1 : $( "#ss7-mtp3-linkset-q707t1" ).val( ),
                    Q707T2 : $( "#ss7-mtp3-linkset-q707t2" ).val( ),
                    Q704T17 : $( "#ss7-mtp3-linkset-q704t17" ).val( )
                }
            };

            var _li = $( "<li>SLC " + _info.Slc + ": " + _info.Mtp2 + "<input type='hidden' class='ss7-mtp3-linkset-mtp2-link-data' value='" + JSON.stringify( _info ) + "' /><img src='" + image_dir + "/imagens/lixeira.gif' class='ss7-mtp3-linkset-mtp3-link-delete' /></li>" );
            // remove the link from linkset callback
            _li.children( "img" ).click( removeMtp2Link );
            _ul.append( _li );

            $( "#ss7-mtp3-linkset-mtp2-link :selected" ).remove( );
            $( "#ss7-mtp3-linkset-slc :selected" ).remove( );
            if( _ul.children( ).length == 1 )
            {
                $( "#ss7-mtp3-linkset-links p" ).fadeOut( );
                _ul.fadeIn( );
            }
            if( $( "#ss7-mtp3-linkset-mtp2-link" ).children( ).length == 0 || $( "#ss7-mtp3-linkset-slc" ).children( ).length == 0 )
            {
                $( "#ss7-mtp3-linkset-link-form p" ).fadeIn( );
                $( "#ss7-mtp3-linkset-link-form div" ).fadeOut( );
            }
        } );

        // existing mtp2 links in linkset
        $( '#ss7-mtp3-linkset-links ul li img' ).each( function( )
        {
            $( this ).click( removeMtp2Link )
        } );
    };
    /**
     * Add MTP3 link set
     */
    var addMtp3LinkSet = function( )
    {
        $( "#refreshing" ).show( );
        $.ajax(
        {

            url : GLOBALAjaxURL + "&ajaxTo=addLinkSet",
            dataType : "html",
            success : initMtp3LinkSetForm,
            error : ajaxDefaultError
        } )
    };
    /**
     * Edit MTP3 link set
     */
    var editMtp3LinkSet = function( )
    {
        var name = findMtp3LinkSet( $( this ) );
        $( "#refreshing" ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=editLinkSet",
            data :
            {
                name : name
            },
            dataType : "html",
            type : "POST",
            success : initMtp3LinkSetForm,
            error : ajaxDefaultError
        } )
    };
    /**
     * Delete MTP3 link set
     */
    var deleteMtp3LinkSet = function( )
    {
        if( ajaxConfirm( 'ss7-mtp3-linkset-confirm-delete' ) )
        {
            var name = findMtp3LinkSet( $( this ) );
            $( '#refreshing' ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=removeLinkSet",
                data :
                {
                    name : name
                },
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( "#refreshing" ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        backMtp3LinkSet( );
                    }
                },
                error : ajaxDefaultError
            } );
        }
    };
    // initialize main list
    $( '.ss7-mtp3-linkset-edit' ).click( editMtp3LinkSet );
    $( '.ss7-mtp3-linkset-delete' ).click( deleteMtp3LinkSet );
    $( '.ss7-mtp3-linkset-add' ).click( addMtp3LinkSet );
}

function initMtp3Routes( )
{
    /**
     * Back to main table
     */
    var backMtp3Routes = function( )
    {
        changeView( 'showRoutes', null, 'menu-telephony,menu-ss7,menu-mtp3,menu-routes' );
    };
    /**
     * Find MTP3 route name inside main table
     */
    var findMtp3Route = function( elm )
    {
        return $( elm ).parent( ).parent( ).children( ).first( ).text( );
    };
    /**
     * Save MTP3 route form
     */
    var saveMtp3Route = function( )
    {
        $( ".ss7-mtp3-route-save" ).addClass( "disabled" ).attr( "disabled", true );
        $( ".ss7-mtp3-route-back" ).addClass( "disabled" ).attr( "disabled", true );
        try
        {
            var mydata =
            {
                LinkSets : []
            };
            $( '#ss7-mtp3-route-form-table input' ).each( function( )
            {
                mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
            } );
            $( '#ss7-mtp3-route-form-table select' ).each( function( )
            {
                mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
            } );
            $( '#ss7-mtp3-route-linksets ul li' ).each( function( )
            {
                mydata.LinkSets.push( $( this ).text( ) );
            } );

            if( mydata['__name__'] == '' )
            {
                throw 'ss7-mtp3-route-error-name-is-required';
            }
            if( mydata['PointCode'] == '<SELECT>' )
            {
                throw 'ss7-mtp3-route-error-point-code-is-required';
            }
            if( mydata['LinkSets'].length == 0 )
            {
                throw 'ss7-mtp3-route-error-at-least-one-linkset-is-required';
            }

            $( "#refreshing" ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=saveRoute",
                data : mydata,
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( "#refreshing" ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        backMtp3Routes( );
                    }
                    $( ".ss7-mtp3-route-save" ).removeClass( "disabled" ).removeAttr( "disabled" );
                    $( ".ss7-mtp3-route-back" ).removeClass( "disabled" ).removeAttr( "disabled" );
                },
                error : ajaxDefaultError
            } );
        }
        catch( err )
        {
            $( ".ss7-mtp3-route-save" ).removeClass( "disabled" ).removeAttr( "disabled" );
            $( ".ss7-mtp3-route-back" ).removeClass( "disabled" ).removeAttr( "disabled" );
            ShowNotice( ajaxI18N( err ), false );
        }
    };
    /**
     * Initialzie MTP3 route form
     */
    var initMtp3RouteForm = function( data )
    {
        $( "#refreshing" ).hide( );
        $( "#ss7-mtp3-routes" ).html( data );
        // buttons
        $( ".ss7-mtp3-route-save" ).click( saveMtp3Route );
        $( ".ss7-mtp3-route-back" ).click( backMtp3Routes );

        var removeMtp3LinkSet = function( ev )
        {
            var _linkset = $( this ).parent( ).text( );
            var _ul = $( this ).parent( ).parent( );
            if( $( "#ss7-mtp3-route-form-linkset" ).children( ).length == 0 )
            {
                $( "#ss7-mtp3-route-linksets-form p" ).fadeOut( );
                $( "#ss7-mtp3-route-linksets-form div" ).fadeIn( );
            }
            $( "#ss7-mtp3-route-form-linkset" ).append( $( "<option value='" + _linkset + "'>" + _linkset + "</option>" ) );
            $( this ).parent( ).remove( );
            if( _ul.children( ).length == 0 )
            {
                $( "#ss7-mtp3-route-linksets p" ).fadeIn( );
                _ul.fadeOut( );
            }
            ev.stopPropagation( );
        };
        // manage linksets
        $( ".ss7-mtp3-route-add-linkset" ).click( function( )
        {
            if( !$( "#ss7-mtp3-route-form-linkset" ).val( ) )
            {
                return;
            }

            var _ul = $( "#ss7-mtp3-route-linksets ul" );
            var _linkset = $( "#ss7-mtp3-route-form-linkset" ).val( );
            var _li = $( "<li>" + _linkset + "<img src='" + image_dir + "/imagens/lixeira.gif' class='ss7-mtp3-route-linkset-delete' /></li>" );
            _li.children( "img" ).click( removeMtp3LinkSet );
            _ul.append( _li );

            $( "#ss7-mtp3-route-form-linkset :selected" ).remove( );
            if( _ul.children( ).length == 1 )
            {
                $( "#ss7-mtp3-route-linksets p" ).fadeOut( );
                _ul.fadeIn( );
            }
            if( $( "#ss7-mtp3-route-form-linkset" ).children( ).length == 0 )
            {
                $( "#ss7-mtp3-route-linksets-form p" ).fadeIn( );
                $( "#ss7-mtp3-route-linksets-form div" ).fadeOut( );
            }
        } );
        // existing linksets
        $( '#ss7-mtp3-route-linksets ul li img' ).each( function( )
        {
            $( this ).click( removeMtp3LinkSet )
        } );
        // make linksets sortable
        $( "#ss7-mtp3-route-linksets ul" ).sortable( );

    };
    /**
     * Show MTP3 route form for addition
     */
    var addMtp3Route = function( )
    {
        $( "#refreshing" ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=addRoute",
            dataType : "html",
            success : initMtp3RouteForm,
            error : ajaxDefaultError
        } );
    };
    /**
     * Show MTP3 route form for eddition
     */
    var editMtp3Route = function( )
    {
        var name = findMtp3Route( $( this ) );
        $( "#refreshing" ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=editRoute",
            data :
            {
                name : name
            },
            dataType : "html",
            type : "POST",
            success : initMtp3RouteForm,
            error : ajaxDefaultError
        } );
    };
    /**
     * Delete MTP3 route
     */
    var deleteMtp3Route = function( )
    {
        if( ajaxConfirm( 'ss7-mtp3-route-confirm-delete' ) )
        {
            var name = findMtp3Route( $( this ) );
            $( "#refreshing" ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=removeRoute",
                data :
                {
                    name : name
                },
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( "#refreshing" ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        backMtp3Routes( );
                    }
                },
                error : ajaxDefaultError
            } );
        }
    };
    // initialize main table
    $( ".ss7-mtp3-route-edit" ).click( editMtp3Route );
    $( ".ss7-mtp3-route-delete" ).click( deleteMtp3Route );
    $( ".ss7-mtp3-route-add" ).click( addMtp3Route );
};

function initIsupCircuitGroups( )
{
    /**
     * Back to main table
     */
    var backIsupCircuitGroups = function( )
    {
        changeView( 'showCircuitGroups', null, 'menu-telephony,menu-ss7,menu-isup,menu-circuit-groups' );
    };
    /**
     * Get circuit group name from main table
     */
    var findIsupCircuitGroupName = function( elm )
    {
        return $( elm ).parent( ).parent( ).children( ).first( ).text( );
    };
    /**
     * Save circuit group
     */
    var saveIsupCircuitGroup = function( )
    {
        $( ".ss7-isup-circuit-group-save" ).addClass( "disabled" ).attr( "disabled", true );
        $( ".ss7-isup-circuit-group-back" ).addClass( "disabled" ).attr( "disabled", true );

        var mydata =
        {
            __timeslotmap__ : []
        };
        $( "#ss7-isup-circuit-groups input:text" ).each( function( idx, elm )
        {
            mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
        } );
        $( "#ss7-isup-circuit-groups input:hidden" ).each( function( idx, elm )
        {
            mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
        } );
        $( "#ss7-isup-circuit-groups select" ).each( function( idx, elm )
        {
            mydata[$( this ).attr( 'name' )] = $.trim( $( this ).val( ) );
        } );

        mydata['Passive'] = $( "#ss7-isup-circuit-group-form-passive" ).is( ":checked" ) ? "true" : "false";

        $( "#ss7-isup-circuit-group-timeslot-map input:checkbox:checked:not(:disabled)" ).each( function( idx, elm )
        {
            var _id = $( elm ).attr( 'id' );
            _id = _id.split( '-' );
            mydata["__timeslotmap__"].push( parseInt( _id[_id.length - 1] ) );
        } );

        try
        {
            if( mydata['__name__'] == '' )
            {
                throw 'ss7-isup-circuit-group-error-name-is-required';
            }
            if( mydata['Origin'] == '<SELECT>' )
            {
                throw 'ss7-isup-circuit-group-error-origin-is-required';
            }
            if( mydata['Destination'] == '<SELECT>' )
            {
                throw 'ss7-isup-circuit-group-error-destination-is-required';
            }
            if( mydata['Origin'] == mydata['Destination'] )
            {
                throw 'ss7-isup-circuit-group-error-origin-and-destination-should-be-different';
            }
            if( mydata['Device'] == '' )
            {
                throw 'ss7-isup-circuit-group-error-device-is-required';
            }
            if( mydata['Link'] == '' )
            {
                throw 'ss7-isup-circuit-group-error-link-is-required';
            }
            if( mydata['BaseCIC'] == '' )
            {
                throw 'ss7-isup-circuit-group-error-basecic-is-required';
            }
            if( ! mydata['Address'].isIpv4( ) )
            {
                throw 'ss7-isup-circuit-group-error-address-should-be-ipv4';
            }
            else
            {
                // KSs7Config.h
                var _basecic = parseInt( mydata['BaseCIC'] );
                if( (_basecic - 1) % 32 != 0 )
                {
                    throw 'ss7-isup-circuit-group-error-basecic-invalid-value';
                }
                delete _basecic;
            }
            if( mydata['__timeslotmap__'].length == 0 )
            {
                throw 'ss7-isup-circuit-group-error-at-least-one-timeslot-is-required';
            }

            $( "#refreshing" ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=saveCircuitGroup",
                data : mydata,
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( "#refreshing" ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        backIsupCircuitGroups( );
                    }
                    $( ".ss7-isup-circuit-group-save" ).removeClass( "disabled" ).removeAttr( "disabled" );
                    $( ".ss7-isup-circuit-group-back" ).removeClass( "disabled" ).removeAttr( "disabled" );
                },
                error : ajaxDefaultError
            } );
        }
        catch( err )
        {
            $( ".ss7-isup-circuit-group-save" ).removeClass( "disabled" ).removeAttr( "disabled" );
            $( ".ss7-isup-circuit-group-back" ).removeClass( "disabled" ).removeAttr( "disabled" );
            ShowNotice( ajaxI18N( err ), false );
        }
    };
    /**
     * Initialize circuit group form
     */
    var initIsupCircuitGroupForm = function( data )
    {
        $( "#refreshing" ).hide( );
        $( "#ss7-isup-circuit-groups" ).html( data );

        // buttons
        $( ".ss7-isup-circuit-group-save" ).click( saveIsupCircuitGroup );
        $( ".ss7-isup-circuit-group-back" ).click( backIsupCircuitGroups );
        // timeslot (de)select all
        $( ".ss7-isup-circuit-group-timeslot-select-all" ).click( function( )
        {
            $( "#ss7-isup-circuit-group-timeslot-map input:checkbox:not(:disabled)" ).attr( "checked", true )
        } );
        $( ".ss7-isup-circuit-group-timeslot-deselect-all" ).click( function( )
        {
            $( "#ss7-isup-circuit-group-timeslot-map input:checkbox:not(:disabled)" ).attr( "checked", false )
        } );
        // field masks
        $( ".ipv4" ).ipAddress( );
        $( "#ss7-isup-circuit-group-form-link" ).mask( "9" );
        $( "#ss7-isup-circuit-group-form-device" ).mask( "999?9999999" );
        $( "#ss7-isup-circuit-group-form-basecic" ).mask( "9?9999" );
    };
    /**
     * Show circuit group form for addition
     */
    var addIsupCircuitGroup = function( )
    {
        $( "#refreshing" ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=addCircuitGroup",
            dataType : "html",
            success : initIsupCircuitGroupForm,
            error : ajaxDefaultError
        } );
    };
    /**
     * Show circuit group from for eddition
     */
    var editIsupCircuitGroup = function( )
    {
        $( "#refreshing" ).show( );
        var name = findIsupCircuitGroupName( $( this ) );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=editCircuitGroup",
            data :
            {
                name : name
            },
            dataType : "html",
            success : initIsupCircuitGroupForm,
            error : ajaxDefaultError
        } );
    };
    /**
     * Delete circuit group
     */
    var deleteIsupCircuitGroup = function( )
    {
        if( ajaxConfirm( 'ss7-isup-circuit-group-confirm-delete' ) )
        {
            $( "#refreshing" ).show( );
            var name = findIsupCircuitGroupName( $( this ) );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=removeCircuitGroup",
                data :
                {
                    name : name
                },
                dataType : "json",
                success : function( data )
                {
                    $( "#refreshing" ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        backIsupCircuitGroups( );
                    }
                },
                error : ajaxDefaultError
            } );
        }
    };
    // initialize main table
    $( ".ss7-isup-circuit-group-edit" ).click( editIsupCircuitGroup );
    $( ".ss7-isup-circuit-group-delete" ).click( deleteIsupCircuitGroup );
    $( ".ss7-isup-circuit-group-add" ).click( addIsupCircuitGroup );
};

function initIsupTimers( )
{
    var saveTimers = function( )
    {
        $( ".ss7-isup-timer-save" ).addClass( "disabled" ).attr( "disabled", true );

        var mydata =
        {
        };
        try
        {
            $( "#ss7-isup-timer-table input:text" ).each( function( idx, elm )
            {
                var _val = $.trim( $( this ).val( ) );
                if( _val == '' )
                {
                    throw 'ss7-isup-timer-error-all-required';
                }
                if( parseInt( _val ) == 0 )
                {
                    throw 'ss7-isup-timer-error-should-be-greater-than-zero';
                }
                mydata[$( this ).attr( 'name' )] = _val;
            } );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=saveTimers",
                data : mydata,
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    ShowNotice( data.message, data.success );
                    $( ".ss7-isup-timer-save" ).removeClass( "disabled" ).removeAttr( "disabled" );
                },
                error : ajaxDefaultError

            } );
        }
        catch( err )
        {
            $( ".ss7-isup-timer-save" ).removeClass( "disabled" ).removeAttr( "disabled" );
            ShowNotice( ajaxI18N( err ), false );
        }
    };
    // buttons
    $( ".ss7-isup-timer-save" ).click( saveTimers );
    // masks
    $( "#ss7-isup-timer-table input:text" ).mask( "9?99999" );
}

function closeChangePassword( )
{
    $( '#divNewPassword' ).hide( );
    $( '#divUsers' ).show( );

}

function showChangePassword( login )
{
    $( '#divUsers' ).hide( );
    $( '#loginNewPassword' ).val( login );
    $( '#divNewPassword' ).show( );
}

function changePassword( self )
{

    var login = $( '#loginNewPassword' ).val( );
    var password1 = $( '#newPassword1' ).val( );
    var password2 = $( '#newPassword2' ).val( );

    if( checkInsertedPassword( 'newPassword1', 'newPassword2' ) )
    {
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data :
            {
                'ajaxTo' : 'changePassword',
                'login' : login,
                'password' : password1,
                'self' : self
            },
            dataType : "json",
            success : function( result )
            {
                if( result['executed'] == true )
                {
                    ShowNotice( result['message'], true );
                    $( '#formulario2' ).html( result['users'] );
                }
                else
                    ShowNotice( result['message'], false );
            }
        } );
    }
}

function saveModifications( )
{

    var tableRows = document.getElementById( 'users' ).getElementsByTagName( 'tr' );
    var data = '';
    for( var i = 0; i < tableRows.length - 1; i++ )
    {
        var login = document.getElementById( "login-user-" + i ).innerHTML;
        var config = document.getElementById( "config-user-" + i ).value;
        var monitoring = document.getElementById( "monitoring-user-" + i ).value;
        var diagnostic = document.getElementById( "diagnostic-user-" + i ).value;
        var administration = document.getElementById( "admin-user-" + i ).value;
        data += login + '|' + config + '|' + monitoring + '|' + diagnostic + '|' + administration + "@";
    };
    data = data.substr( 0, data.length - 1 );

    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveModifications&data=" + data,
        dataType : "json",
        success : function( result )
        {
            if( result['executed'] == true )
            {
                $( 'AjaxAlert' ).html( result['users'] );
                ShowNotice( result['message'], true );
            }
            else
                ShowNotice( result['message'], false );
        }
    } );
}

function clearNewUserData( )
{
    document.getElementById( 'user' ).value = '';
    document.getElementById( 'password1' ).value = '';
    document.getElementById( 'password2' ).value = '';
    document.getElementById( 'newUserConfig' ).selected = 0;
    document.getElementById( 'newUserMonitoring' ).selected = 0;
    document.getElementById( 'newUserDiagnostic' ).selected = 0;
    document.getElementById( 'newUserAdmin' ).selected = 0;
}

function removeUser( user )
{

    if( ajaxConfirm( 'sureToRemoveUser' ) )
    {
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=removeUser&login=" + user,
            dataType : "json",
            success : function( result )
            {
                if( result['executed'] == true )
                {
                    ShowNotice( result['message'], true );
                    $( '#formulario2' ).html( result['users'] );
                }
                else
                    ShowNotice( result['message'], false );
            }
        } );
    }
}

function openNewUser( )
{
    $( '#divNewUser' ).show( );
    $( '#divUsers' ).hide( );
    if( $( '#upload-firmware' ).length > 0 )
        $( '#upload-firmware' ).hide( );

}

function hideNewUser( )
{
    $( '#divUsers' ).show( );
    $( '#divNewUser' ).hide( );
    if( $( '#upload-firmware' ).length > 0 )
        $( '#upload-firmware' ).show( );
}

function saveNewUser( )
{

    if( ajaxConfirm( 'sureToAddNewUser' ) )
    {
        if( checkUserData( ) && checkInsertedPassword( 'password1', 'password2' ) )
        {
            var login = $.trim( $( '#user' ).val( ) );
            var password = $.trim( $( '#password1' ).val( ) );
            var config = $( '#newUserConfig' ).val( );
            var monitoring = $( '#newUserMonitoring' ).val( );
            var admin = $( '#newUserAdmin' ).val( );
            var diag = $( '#newUserDiagnostic' ).val( );

            jQuery.ajax(
            {
                url : GLOBALAjaxURL,
                data :
                {
                    'ajaxTo' : 'addNewUser',
                    'login' : login,
                    'password' : password,
                    'configuration' : config,
                    'administration' : admin,
                    'diagnostic' : diag,
                    "monitoring" : monitoring
                },
                dataType : "json",
                success : function( result )
                {
                    if( result['executed'] == true )
                    {
                        ShowNotice( result['message'], true );
                        $( '#formulario2' ).html( result['users'] );
                    }
                    else
                        ShowNotice( result['message'], false );

                    hideNewUser( );
                    clearNewUserData( );
                }
            } );
        }
    }
}

function normalizaTabela( count )
{
    var tableRows = document.getElementById( 'users' ).getElementsByTagName( 'tr' );
    if( count >= tableRows.length )
    {
        //tabela menor que o resultado obtido
        var tabela = document.getElementById( 'tabelaConteudo' );
        var diff = count - tableRows.length;
        var size = tableRows.length;
        for( var i = 0; i < diff; i++ )
        {
            var row = tabela.insertRow( tableRows.length );
            var cell = row.insertCell( 0 );
            cell.id = size + i;
        };
    }
    else
    {
        var size = tableRows.length;
        for( var i = size; i > count; i-- )
            document.getElementById( 'tabelaConteudo' ).deleteRow( i - 1 );
    }
}

function countElements( obj )
{
    var prop;
    var propCount = 0;
    for( prop in obj )
    {
        propCount++;
    }
    return propCount;
}

function checkUserData( )
{
    if( $.trim( $( '#user' ).val( ) ) != '' )
        return true;
    else
    {
        ajaxAlert( 'needtoEnterNewUserLogin' );
        return false;
    }
}

function checkInsertedPassword( comp1Id, comp2Id )
{

    passwd1 = $.trim( $( '#' + comp1Id ).val( ) );
    passwd2 = $.trim( $( '#' + comp2Id ).val( ) );

    if( passwd1 != '' && passwd2 != '' )
    {
        if( passwd1 == passwd2 )
            return true;
        else
        {
            ajaxAlert( 'passwrodAreDiferent' );
            return false;
        }
    }
    else
    {
        ajaxAlert( 'needtoEnterThePassword' )
        return false;
    }
}

function saveGeneratedCadences( )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=assistant&action=saveGeneratedCadences",
        dataType : "html",
        success : function( text )
        {
            ajaxAlert( text );
            $( '#refreshing' ).hide( );
            $( '#dialog-modal' ).dialog( 'close' );
            showCadence( );
        }
    } );
}

function showCadence( )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showCadence",
        dataType : "html",
        success : function( text )
        {
            $( '#Cadences' ).html( text );
            $( '#refreshing' ).hide( );
        }
    } );
}

function initAssintant( )
{
    var fxoDevice = $( '#fxodevice' ).val( );
    var busy = $.trim( $( '#busy' ).val( ) );
    var invalid = $.trim( $( '#invalid' ).val( ) );
    var ringback = $.trim( $( '#ringback' ).val( ) );
    var channel = $( '#fxoDeviceChannel' ).val( );

    if( busy != '' & invalid != '' & ringback != '' )
    {
        var execute = 'device=' + fxoDevice + '&busy=' + busy + '&invalid=' + invalid + '&ringback=' + ringback + '&channel=' + channel;
        $( '#refreshing' ).show( );
        $( '#looper' ).html( '' );

        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=assistant&action=initFXOCadenceAssistant&" + execute,
            dataType : "html",
            success : function( text )
            {
                $( '#refreshing' ).hide( );
            }
        } );
        sleep( 2000 );
        updateCadenceAssistantMessages( );
    }
    else
        ajaxAlert( 'needToFillAllFields' );
}

function selectFXODeviceChannels( device )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=assistant&action=changeDevice&device=" + device,
        dataType : "html",
        success : function( text )
        {
            $( '#fxoDeviceChannelsList' ).html( text );
            $( '#refreshing' ).hide( );
        }
    } );
}

function updateCadenceAssistantMessages( )
{
    jQuery.ajax(
    {
        url : modulo_dir + '/readFile.php',
        dataType : "text",
        success : function( text )
        {
            var piece = text.split( '^' );
            if( piece[1] == 'notOK' )
            {
                $( '#looper' ).html( piece[0] );
                sleep( 1000 );
                updateCadenceAssistantMessages( );
            }
            else if( (piece[1] == 'OK') )
            {
                $( '#looper' ).html( piece[0] );
                $( '#loading' ).hide( );
            }
        }
    } );
}

function saveCadences( )
{
    var data = '';
    qtde_Cadences = $( '#cadencesQtd' ).val( );

    for( i = 0; i < qtde_Cadences; i++ )
    {
        if( $.trim( $( '#Name-' + i ).val( ) ) == '' )
        {
            ajaxAlert( 'needoToEnterCadenceName' );
            return false;
        }
        if( $.trim( $( '#Cadence-' + i ).val( ) ) == '' )
        {
            ajaxAlert( 'needoToEnterCadenceValue' );
            return false;
        }
        var cad = $( '#Cadence-' + i ).val( );
        if( !validateCadenceValue( cad ) )
        {
            ajaxAlert( 'needoToEnterCadenceValue' );
            return false;
        }

        data += $( '#Id-' + i ).val( ) + '_';
        data += 'Type:' + $( '#Type-' + i ).val( ) + ';';
        data += 'Name:' + $( '#Name-' + i ).val( ) + ';';
        data += 'Repetitions:' + $( '#Repetitions-' + i ).val( ) + ';';
        data += 'Tolerance:' + $( '#Tolerance-' + i ).val( ) + ';';
        data += 'Cadence:' + cad + '|';

    }
    data = data.substr( 0, data.length - 1 );

    $( '#refreshing' ).show( );
    $( '#saveCadencesB' ).attr( 'disabled', 'true' );
    $( '#saveCadencesB' ).css( 'background', 'gray' );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveCadences&data=" + data,
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );
            ajaxAlert( text );
            $( '#saveCadencesB' ).removeAttr( 'disabled' );
            $( '#saveCadencesB' ).css( 'background', '#339966' );
        }
    } );
}

function validateCadenceValue( value )
{
    var cad = new String( value );

    if( cad.charAt( 0 ) == ',' )
        return false;

    if( cad.charAt[cad.length - 1] == ',' )
        return false;

    for( j = 0; j < cad.length; j++ )
    {
        if( cad.charAt( j ) == ' ' )
            return false;

        if( isNaN( cad.charAt( j ) ) && cad.charAt( j ) != ',' )
            return false;

        if( cad.length > 1 )
        {
            if( cad.charAt( j ) == ',' && cad.charAt( j - 1 ) == ',' )
                return false;
        }

    }
    return true;
}

function InitCadenceAssistant( )
{

    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=assistant&action=getAssistant",
        dataType : "html",
        success : function( text )
        {

            var div = $( "<div id='dialog-modal' > </div>" );
            div.html( text );
            div.css( 'text-align', 'left' );
            div.dialog(
            {
                height : 400,
                width : 600,
                modal : true,
                close : function( )
                {
                    $( this ).dialog( 'destroy' );
                    div.remove( );
                }
            } );

            if( $( '#tabs' ).lenght > 0 )
            {
                $( function( )
                {
                    $( "#tabs" ).tabs( );
                } );
            }
            $( '#refreshing' ).hide( );
        }
    } );
}

function deleteCadence( cadenceRow )
{
    document.getElementById( 'cadencesQtd' ).value--;
    var row = $( '#trId_' + cadenceRow );
    $( row, '#cadenceTable tbody' ).remove( );
    if( $( '#cadencesQtd' ).val( ) == 0 )
    {
        $( '#warningCadence' ).show( 'slow' );
        $( '#cadenceTable' ).hide( );
    }
    else
        $( '#warningCadence' ).hide( );
}

function newCadenceRow( object )
{
    var tr = createNewTR( );
    tr.appendChild( createCadence( ) );
    tr.appendChild( createTypeComboBox( ) );
    tr.appendChild( createInputName( ) );
    tr.appendChild( createRepComboBox( ) );
    tr.appendChild( createToleranceComboBox( ) );
    tr.appendChild( createInputCadences( ) );
    tr.appendChild( createDeleteLink( ) );
    $( '#cadenceTable tbody' ).append( tr );
    incrementQtd( );
    leColore( )
}

function createNewTR( )
{
    var tr = document.createElement( 'tr' );
    var lastCSSValue = document.getElementById( 'lastCSSClass' );

    if( lastCSSValue.value == 'lgreen' )
    {
        tr.setAttribute( 'class', 'green' );
        lastCSSValue.value = 'green';
    }
    else
    {
        tr.setAttribute( 'class', 'lgreen' );
        lastCSSValue.value = 'lgreen';
    }
    tr.id = "trId_" + document.getElementById( 'cadencesQtd' ).value
    $( '#cadenceTable' ).show( );
    $( '#warningCadence' ).hide( );

    return tr;
}

function createCadence( )
{
    var td = document.createElement( 'td' );
    td.id = "tdId_" + document.getElementById( 'cadencesQtd' ).value;

    var lastCadence = document.getElementById( 'lastCadence' );
    lastCadence.value = String.fromCharCode( lastCadence.value.charCodeAt( 0 ) + 1 );

    if( lastCadence.value.charCodeAt( 0 ) > 90 )
        lastCadence.value = "@";
    var element = document.createElement( 'select' );
    td.appendChild( element );
    totalValue = document.getElementById( 'cadencesQtd' ).value;
    totalValue = parseInt( totalValue );

    element.id = 'Id-' + totalValue;
    element.name = 'Id-' + totalValue;
    element.value = 'Id-' + totalValue;

    for( var i = 65; i <= 90; i++ )
    {
        var opt;
        opt = document.createElement( "option" );

        if( lastCadence.value.charCodeAt( 0 ) == i )
            opt.selected = true;

        opt.setAttribute( "value", String.fromCharCode( i ) );
        opt.innerHTML = String.fromCharCode( i );
        element.appendChild( opt );
    }
    element.setAttribute( "class", "combox" );
    return td;
}

function createTypeComboBox( )
{
    var td = document.createElement( 'td' );
    var element = document.createElement( 'select' );
    td.appendChild( element );
    totalValue = document.getElementById( 'cadencesQtd' ).value
    totalValue = parseInt( totalValue );

    element.id = 'Type-' + totalValue;
    element.name = 'Type-' + totalValue;
    element.value = 'Type-' + totalValue;

    var opt1;
    opt1 = document.createElement( "option" );
    opt1.setAttribute( "value", "0" );
    opt1.innerHTML = "Dial Tone";
    element.appendChild( opt1 );

    var opt2;
    opt2 = document.createElement( "option" );
    opt2.setAttribute( "value", "1" );
    opt2.innerHTML = "Ring Back";
    element.appendChild( opt2 );

    var opt3;
    opt3 = document.createElement( "option" );
    opt3.setAttribute( "value", "2" );
    opt3.innerHTML = "Busy";
    element.appendChild( opt3 );

    var opt4;
    opt4 = document.createElement( "option" );
    opt4.setAttribute( "value", "3" );
    opt4.innerHTML = "Fast Busy";
    element.appendChild( opt4 );

    return td;
}

function createInputName( )
{
    var td = document.createElement( 'td' );
    var element = document.createElement( 'input' );
    td.appendChild( element );
    totalValue = document.getElementById( 'cadencesQtd' ).value
    totalValue = parseInt( totalValue );
    element.type = "text"
    element.id = 'Name-' + totalValue;
    element.name = 'Name-' + totalValue;
    element.className = 'inputText';

    element.size = 20;
    return td;
}

function createRepComboBox( )
{
    var td = document.createElement( 'td' );
    var element = document.createElement( 'select' );
    td.appendChild( element );
    totalValue = document.getElementById( 'cadencesQtd' ).value
    totalValue = parseInt( totalValue );

    element.id = 'Repetitions-' + totalValue;
    element.name = 'Repetitions-' + totalValue;
    element.value = 'Repetitions-' + totalValue;

    for( var i = 1; i <= 8; i++ )
    {
        var opt;
        opt = document.createElement( "option" );
        opt.setAttribute( "value", i );
        opt.innerHTML = i;
        element.appendChild( opt );
    }
    return td;
}

function createToleranceComboBox( )
{
    var td = document.createElement( 'td' );
    var element = document.createElement( 'select' );
    td.appendChild( element );
    totalValue = document.getElementById( 'cadencesQtd' ).value
    totalValue = parseInt( totalValue );

    element.id = 'Tolerance-' + totalValue;
    element.name = 'Tolerance-' + totalValue;
    element.value = 'Tolerance-' + totalValue;

    for( var i = 5; i <= 250; i += 5 )
    {
        var opt;
        opt = document.createElement( "option" );
        opt.setAttribute( "value", i );
        opt.innerHTML = i;
        element.appendChild( opt );
    }

    return td;
}

function createInputCadences( )
{
    var td = document.createElement( 'td' );
    var element = document.createElement( 'input' );
    td.appendChild( element );
    totalValue = document.getElementById( 'cadencesQtd' ).value
    totalValue = parseInt( totalValue );
    element.id = 'Cadence-' + totalValue;
    element.name = 'Cadence-' + totalValue;
    element.size = 10;

    return td;
}

function createDeleteLink( )
{
    var td = document.createElement( 'td' )
    td.innerHTML = '<a href="#" onClick="javascript:deleteCadence(' + $( '#cadencesQtd' ).val( ) + ')"><img src="' + image_dir + '/imagens/lixeira.gif"/></a>';
    return td;
}

function incrementQtd( )
{
    document.getElementById( 'cadencesQtd' ).value++;
    document.getElementById( 'lastIndex' ).value++;
}

function saveCallProgressOptions( )
{
    var data = '';
    $( 'select' ).each( function( i, c )
    {
        data += $( c ).attr( 'id' ) + ':' + $( c ).val( ) + '|';
    } );
    $( 'input[type=checkbox] ' ).each( function( i, c )
    {
        data += $( c ).is( ':checked' ) ? $( c ).attr( 'id' ) + ':true' + '|' : $( c ).attr( 'id' ) + ':false' + '|';
    } );
    data = data.substr( 0, data.length - 1 );

    $( '#refreshing' ).show( );
    $( '#saveCallProgressOptionsB' ).attr( 'disabled', 'true' );
    $( '#saveCallProgressOptionsB' ).css( 'background', 'gray' );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveCallProgressOptions&data=" + data,
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );
            ajaxAlert( text );
            $( '#saveCallProgressOptionsB' ).removeAttr( 'disabled' );
            $( '#saveCallProgressOptionsB' ).css( 'background', '#339966' );
        }
    } );
}

function saveLinksE1( )
{
    var devices = '';
    var system = '';
    seriais = $( '#SeriaisE1Links' ).val( );
    seriais = seriais.split( ',' );
    for( var x in seriais )
    {
        serial = seriais[x];
        cereal = serial.replace( '.', '\\.' );
        name = $( '#Name-' + cereal ).val( );
        profile = $( '#Profile-' + cereal ).val( );
        devices += serial + ':' + name + ':' + profile + '|';

        EnableLinkAsReference = $( '#Clock-' + cereal ).val( );
        // EnableLinkAsReference =
        // $('#EnableLinkAsReference-'+cereal).is(':checked') ? 'true' : 'false';
        CentralOfficePrefix = $( '#CentralOfficePrefix-' + cereal ).val( );
        IncomingDigitsCount = $( '#IncomingDigitsCount-' + cereal ).val( );
        CRC4 = $( '#CRC4-' + cereal ).is( ':checked' ) ? 'true' : 'false';
        UseCentralOfficePrefixOnIncomingCalls = $( '#UseCentralOfficePrefixOnIncomingCalls-' + cereal ).is( ':checked' ) ? 'true' : 'false';

        system += serial + '-' + 'EnableLinkAsReference:' + EnableLinkAsReference + ',CentralOfficePrefix:' + CentralOfficePrefix + ',IncomingDigitsCount:' + IncomingDigitsCount + ',CRC4:' + CRC4 + ',UseCentralOfficePrefixOnIncomingCalls:' + UseCentralOfficePrefixOnIncomingCalls;
        if( $( '#advanced' ).length > 0 )
        {
            k3lr = $( '#k3lr-' + cereal ).val( );
            CasLineValidateTime = $( '#CasLineValidateTime-' + cereal ).val( );
            StartTime = $( '#StartTime-' + cereal ).val( );
            ReleaseTime = $( '#ReleaseTime-' + cereal ).val( );
            AlarmTime = $( '#AlarmTime-' + cereal ).val( );
            system += ',k3lr:' + k3lr + ',CasLineValidateTime:' + CasLineValidateTime + ',StartTime:' + StartTime + ',ReleaseTime:' + ReleaseTime + ',AlarmTime:' + AlarmTime;
        }
        system += '@';
    }

    system = system.substr( 0, system.length - 1 );
    devices = devices.substr( 0, devices.length - 1 );

    $( '#refreshing' ).show( );
    $( '#saveLinksE1B' ).attr( 'disabled', 'true' );
    $( '#saveLinksE1B' ).css( 'background', 'gray' );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveLinksE1&system=" + system + "&devices=" + devices,
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );
            ajaxAlert( text );
            $( '#saveLinksE1B' ).removeAttr( 'disabled' );
            $( '#saveLinksE1B' ).css( 'background', '#339966' );
        }
    } );
}

function advancedConfig( adv )
{
    $( '#refreshing' ).show( );
    var data = adv ? '&advancedTable=true' : '';
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showLinksE1" + data,
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );
            $( '#formulario' ).html( text );

            $( '.collapsePara' ).collapser(
            {
                target : 'next',
                effect : 'slide',
                changeText : 0
            } );
        }
    } );
}

function saveDevice( serial )
{
    var replacer = '';
    var data = '';
    var ip = '';
    if( document.getElementById( 'IP' ) )
    {
        var ipdoc = document.getElementById( 'IP' );
        ipdoc.click( );
        var validacao = validateIP( ipdoc );

        if( !validacao )
        {
            ajaxAlert( 'WAddress' );
            return false;
        }
        else
            ip += '&ip=' + ipdoc.value;
    }

    var qtdeLinks = $( '#qtdeLinks' ).val( );
    for( var i = 0; i < qtdeLinks; i++ )
    {
        data += $( '#Clock-' + i ).attr( 'name' ) + ':' + $( '#Clock-' + i ).val( ) + '|';
        data += $( '#Links-' + i ).attr( 'name' ) + ':' + $( '#Links-' + i ).val( ) + '|';

    }
    $( '#channelGroup select' ).each( function( i, c )
    {
        data += $( c ).attr( 'id' ) + ':' + $( c ).val( ) + '|';
    } );
    data = data.substr( 0, data.length - 1 );

    var replacer = '';
    if( $( '#Replacer' ).length > 0 && $( '#Replacer' ).val( ).length > 0 )
    {
        var repl = document.getElementById( 'Replacer' );
        repl.click( );
        if( !validateSerial( repl ) )
        {
            ajaxAlert( 'WSerial' );
            return false;
        }
        else
            replacer += '&Replacer=' + repl.value;
    }

    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveDevice&serial=" + serial + ip + replacer + "&data=" + data,
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );
            var tmp = text.split( '|' );
            ajaxAlert( tmp[1] );

            if( tmp[0] > 0 )
            {
                openMaintenance( );
                $( '#Replacer' ).css( 'background', '#F96868' );
            }
            else
                showDevices( );
        }
    } );
}

function openMaintenance( )
{
    $( '#MaintenanceClosed' ).hide( );
    $( '#MaintenanceOpened' ).show( );
    $( '#Maintenance' ).show( );
}

function closeMaintenance( )
{
    $( '#MaintenanceClosed' ).show( );
    $( '#MaintenanceOpened' ).hide( );
    $( '#Maintenance' ).hide( );
}

function validateIP( comp )
{
    ipaddr = comp.value;
    var posClick = comp.selectionStart;

    var re = /\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b/;
    var parts = ipaddr.split( "." );

    if( parts.length == 1 && parts[0] == '' )
    {
        comp.style.background = '';
        return true;
    }

    if( re.test( ipaddr ) )
    {
        if( parseInt( parseFloat( parts[0] ) ) == 0 )
        {
            comp.style.background = '#F96868';
            return false;
        }

        for( var i = 0; i < parts.length; i++ )
        {
            if( parseInt( parseFloat( parts[i] ) ) > 255 )
            {
                comp.style.background = '#F96868';
                return false;
            }
        }
        for( var i = 0; i < parts.length; i++ )
        {
            if( parts[i] != '' )
                parts[i] = parseInt( parseFloat( parts[i] ) );
        }
        for( var a = 0; a < parts.length; a++ )
        {
            if( a == 0 )
                var fullStr = parts[a];
            else
                fullStr = fullStr + '.' + parts[a];
        }
        if( fullStr != ipaddr )
        {
            comp.value = fullStr;
            comp.selectionStart = posClick;
        }

        comp.style.background = '';

        return true;

    }
    else
    {
        comp.style.background = '#F96868';
        return false;
    }
}

function maskIP( event, comp )
{
    var fullTmp;
    var tmpValue = comp.value;
    var tmpParts = tmpValue.split( "." );
    var isPeriod = (event.keyCode == 194 || event.keyCode == 190 || event.keyCode == 110);

    if( escapeKeys( event ) )
        return true;

    if( tmpParts.length == 4 && isPeriod )
        return false;

    if( tmpParts.length == 4 && tmpParts[3].length == 3 && (parseInt( parseFloat( tmpParts[3] ) ) == 0) )
        return false;

    if( (/\d{3}$/).test( comp.value ) && !isPeriod && tmpParts.length < 4 )
    {
        comp.value += '.';
        tmpValue = comp.value;
        tmpParts = tmpValue.split( "." );
    }

    if( comp.value[comp.value.length - 1] == '.' && isPeriod )
        comp.value = comp.value.substr( 0, comp.value.length - 1 );

    if( parseInt( parseFloat( tmpParts[0] ) ) == 0 )
        return false;

    var charCode = String.fromCharCode( event.keyCode );
    if( event.keyCode == 96 )
        charCode = '0';
    if( tmpParts.length == 4 && parseInt( parseFloat( tmpParts[3] + charCode ) ) == 0 )
    {
        var tmpDump = tmpParts[0] + '.' + tmpParts[1] + '.' + tmpParts[2] + '.';
        comp.value = tmpDump;
        return false;
    }

    if( tmpParts.length == 4 )
    {
        for( var i = 0; i < tmpParts.length; i++ )
        {
            if( parseInt( parseFloat( tmpParts[i] ) ) > 255 )
                return false;
        }
    }
    else
    {
        if( tmpParts.length < 4 )
        {
            for( var i = 0; i < tmpParts.length; i++ )
            {
                if( parseInt( parseFloat( tmpParts[i] ) ) > 255 )
                    return false;
            }
        }
        else
            return false;
    }
}

function editDevice( device )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=editDevice&" + device,
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );
            $( '#divDevices' ).html( text );
        }
    } );
}

function removeDevice( serial )
{
    if( ajaxConfirm( 'sureToRemoveDevice' ) )
    {
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=removeDevice&serial=" + serial,
            dataType : "html",
            success : function( text )
            {
                ajaxAlert( text );
                showDevices( );
            }
        } );
    }
}

function showDevices( )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showDevices",
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );
            $( '#divDevices' ).html( text );
            $( "#sortableDevice" ).sortable( );
            $( "#sortableDevice" ).sortable( );
            $( "#sortableDevice" ).sortable(
            {
                update : function( event, ui )
                {
                    delayedCheck( );
                }
            } );
        }
    } );
}

function autoCreateDevice( )
{
    var send = '';
    var x = 0;
    var deviceName = 'deviceList';
    var deviceNameType = 'deviceListType';
    var serialGroup = '';
    var error = false;

    while( document.getElementById( deviceName + x ) )
    {
        if( document.getElementById( deviceName + x ).checked == true )
        {
            if( serialGroup == '' )
            {
                if( document.getElementById( deviceNameType + x ) )
                {
                    if( document.getElementById( deviceNameType + x ).value != '' )
                        serialGroup = document.getElementById( deviceName + x ).value + ':' + document.getElementById( deviceNameType + x ).value;
                    else
                        error = true;
                }
                else
                    serialGroup = document.getElementById( deviceName + x ).value;

                serialGroup += $( '#version' + x ).val( ) != '' ? ';' + $( '#version' + x ).val( ) : '';

            }
            else
            {
                if( document.getElementById( deviceNameType + x ) )
                {
                    if( document.getElementById( deviceNameType + x ).value != '' )
                        serialGroup += '|' + document.getElementById( deviceName + x ).value + ':' + document.getElementById( deviceNameType + x ).value;
                    else
                        error = true;
                }
                else
                    serialGroup += '|' + document.getElementById( deviceName + x ).value;

                serialGroup += $( '#version' + x ).val( ) != '' ? ';' + $( '#version' + x ).val( ) : '';
            }
        }
        x++;
    }
    send = send + '&serialGroup=' + serialGroup;
    if( serialGroup != '' & error == false )
    {
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=autoCreateDevice" + send,
            dataType : "html",
            success : function( text )
            {

                ret = text.split( '|' );

                if( ret[0] > 0 )
                    ajaxAlert( ret[1] )
                else
                    showDevices( );

                $( '#refreshing' ).hide( );
            }
        } );
    }
    else
    {
        if( serialGroup == '' && error == false )
            ajaxAlert( 'selectOneAtLeast' );
        else if( error )
            ajaxAlert( 'selecioneType' );
    }
}

function refreshKibsTime( )
{
    data = $( '#kibsTime' ).val( );
    preCreateDevice( data );
}

function preCreateDevice( time )
{
    if( time )
        data = '&time=' + $( '#kibsTime' ).val( );
    else
        data = '&time=';

    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showAutoCreateDevice" + data,
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );
            $( '#divDevices' ).html( text );
            $( "#sortableDevice" ).sortable( );
        }
    } );
}

function preManualCreateDevice( )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showManualCreateDevice",
        dataType : "html",
        success : function( text )
        {
            $( '#refreshing' ).hide( );
            $( '#divDevices' ).html( text );
            $( "#sortableDevice" ).sortable( );
        }
    } );
}

function showId( target, hideTarget )
{
    element = document.getElementById( target );
    if( element.style.display == 'block' )
        element.style.display = 'none';
    else
        element.style.display = 'block';
    if( hideTarget )
    {
        hideTarget = hideTarget.split( '|' );
        var hideTargetSize = hideTarget.length;
        for( var x = 0; x < hideTargetSize; x++ )
            document.getElementById( hideTarget[x] ).style.display = 'none';
    }
}

function hideModularTypes( )
{
    var totalTypes = document.getElementById( 'totalTypes' ).value;
    for( var i = 0; i < totalTypes; i++ )
        $( '#modularType' + i ).hide( );
}

function showModularType( name )
{
    $( '#' + name ).show( 'slow' );
}

function manualCreateDevice( )
{
    var serial = document.getElementById( 'manualSerial' ).value;
    var manualDevice = getValor( document.getElementsByName( 'manualDevice' ) );
    var preDevice = manualDevice.split( '|' );
    var data = '&deviceDef=' + manualDevice + '&serialGroup=' + serial;

    if( manualDevice != false )
    {
        if( serial != '' )
        {
            $( '#refreshing' ).show( );
            jQuery.ajax(
            {
                url : GLOBALAjaxURL,
                data : "ajaxTo=checkDevice" + data,
                dataType : "text",
                success : function( text )
                {
                    if( text == 0 )
                    {
                        var serial = document.getElementById( 'manualSerial' ).value;
                        var manualDevice = getValor( document.getElementsByName( 'manualDevice' ) );
                        var preDevice = manualDevice.split( '|' );
                        var index = valueIndex - 21;

                        if( index >= 0 )
                        {
                            if( document.getElementById( 'manualType' + index ) )
                            {
                                var CTI = false;
                                $( "input[name='manualType" + index + "']" ).each( function( i, v )
                                {
                                    if( $( v ).val( ) == 'CTI' && $( v ).is( ':checked' ) )
                                        CTI = true;
                                } );
                                if( !CTI )
                                {
                                    preDevice[1] = parseInt( preDevice[1] ) + 1;
                                    manualDevice = preDevice[0] + '|' + preDevice[1] + '|' + preDevice[2];
                                }
                            }
                        }

                        var data = '&serialGroup=' + serial + '&deviceDef=' + manualDevice;
                        jQuery.ajax(
                        {
                            url : GLOBALAjaxURL,
                            data : "ajaxTo=manualCreateDevice" + data,
                            dataType : "html",
                            success : function( text )
                            {
                                $( '#refreshing' ).hide( );
                                showDevices( );
                            }
                        } );
                    }
                    else if( text == 1 )
                    {
                        ajaxAlert( 'serialExistente' );
                    }
                    else
                    {
                        ajaxAlert( 'SerialAlreadyExistAsReplacer' );
                    }

                    $( '#refreshing' ).hide( );
                }
            } );
        }
        else
        {
            ajaxAlert( 'enterSerial' );
            document.getElementById( "formulario" ).scrollTop = 0;
            setfocus( 'manualSerial' );
            $( '#manualSerial' ).css( 'background', '#F96868' );
        }
    }
    else
        ajaxAlert( 'selectOneDevice' );
}

function getValor( radios )
{
    for( var i = 0; i < radios.length; i++ )
    {
        if( radios[i].checked )
        {
            valueIndex = i;
            return radios[i].value;
        }
    }
    return '';
}

function resetProfiles( )
{
    if( ajaxConfirm( 'ConfirmResetProfiles' ) )
    {
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=resetProfile",
            dataType : "html",
            success : function( text )
            {
                $( '#refreshing' ).hide( );
                ajaxAlert( text );
                listProfiles( );
            }
        } );
    }
}

function createFXO( action )
{
    if( action == 'copy' )
    {
        if( $( '#name' ).val( ) == '' )
        {
            ajaxAlert( 'nameEmpty' );
            return;
        }
    }
    var data = '';
    $( '#Profiles input[type=hidden], input[type=text], select, ' ).each( function( i, c )
    {
        data += $( c ).attr( 'id' ) + ':' + $( c ).val( ) + ',';
    } );
    $( '#Profiles input[type=checkbox] ' ).each( function( i, c )
    {
        data += $( c ).is( ':checked' ) ? $( c ).attr( 'id' ) + ':true' + ',' : $( c ).attr( 'id' ) + ':false' + ',';
    } );

    if( data != '' )
    {
        data = data.substr( 0, data.length - 1 );
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=createProfile&action=" + action + "&type=FXO&data=" + data,
            dataType : "html",
            success : function( text )
            {
                $( '#refreshing' ).hide( );
                ret = text.split( '|' );
                ajaxAlert( ret[1] )
                if( ret[0] > 0 )
                    listProfiles( );
            }
        } );
    }
}

function createLineSide( action )
{
    if( action == 'copy' )
    {
        if( $( '#name' ).val( ) == '' )
        {
            ajaxAlert( 'nameEmpty' );
            return;
        }
    }
    var data = '';
    $( '#Profiles input[type=hidden], input[type=text], select, ' ).each( function( i, c )
    {
        data += $( c ).attr( 'id' ) + ':' + $( c ).val( ) + ',';
    } );
    $( '#Profiles input[type=checkbox] ' ).each( function( i, c )
    {
        data += $( c ).is( ':checked' ) ? $( c ).attr( 'id' ) + ':true' + ',' : $( c ).attr( 'id' ) + ':false' + ',';
    } );

    if( data != '' )
    {
        data = data.substr( 0, data.length - 1 );
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=createProfile&action=" + action + "&type=LineSide&data=" + data,
            dataType : "html",
            success : function( text )
            {
                $( '#refreshing' ).hide( );
                ret = text.split( '|' );
                ajaxAlert( ret[1] )
                if( ret[0] > 0 )
                    listProfiles( );
            }
        } );
    }
}

function createFXS( action )
{
    if( action == 'copy' )
    {
        if( $( '#name' ).val( ) == '' )
        {
            ajaxAlert( 'nameEmpty' );
            return;
        }
    }
    var data = '';
    $( '#Profiles input[type=hidden], input[type=text], select, ' ).each( function( i, c )
    {
        data += $( c ).attr( 'id' ) + ':' + $( c ).val( ) + ',';
    } );

    if( data != '' )
    {
        data = data.substr( 0, data.length - 1 );
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=createProfile&action=" + action + "&type=FXS&data=" + data,
            dataType : "html",
            success : function( text )
            {
                $( '#refreshing' ).hide( );
                ret = text.split( '|' );
                ajaxAlert( ret[1] )
                if( ret[0] > 0 )
                    listProfiles( );
            }
        } );
    }
}

function createGSM( action )
{
    if( action == 'copy' )
    {
        if( $( '#name' ).val( ) == '' )
        {
            ajaxAlert( 'nameEmpty' );
            return;
        }
    }

    var data = '';
    $( '#Profiles input[type=hidden], input[type=text], select, ' ).each( function( i, c )
    {
        data += $( c ).attr( 'id' ) + ':' + $( c ).val( ) + ',';
    } );
    $( '#Profiles input[type=checkbox] ' ).each( function( i, c )
    {
        data += $( c ).is( ':checked' ) ? $( c ).attr( 'id' ) + ':true' + ',' : $( c ).attr( 'id' ) + ':false' + ',';
    } );

    if( data != '' )
    {
        data = data.substr( 0, data.length - 1 );
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=createProfile&action=" + action + "&type=GSM&data=" + data,
            dataType : "html",
            success : function( text )
            {
                $( '#refreshing' ).hide( );
                ret = text.split( '|' );
                ajaxAlert( ret[1] )
                if( ret[0] > 0 )
                    listProfiles( );
            }
        } );
    }
}

function createISDN( action )
{
    if( action == 'copy' )
    {
        if( $( '#name' ).val( ) == '' )
        {
            ajaxAlert( 'nameEmpty' );
            return;
        }
    }

    var data = '';
    $( '#Profiles input[type=hidden], input[type=text], select, ' ).each( function( i, c )
    {
        data += $( c ).attr( 'id' ) + ':' + $( c ).val( ) + ',';
    } );
    $( '#Profiles input[type=checkbox] ' ).each( function( i, c )
    {
        data += $( c ).is( ':checked' ) ? $( c ).attr( 'id' ) + ':true' + ',' : $( c ).attr( 'id' ) + ':false' + ',';
    } );

    if( data != '' )
    {
        data = data.substr( 0, data.length - 1 );
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=createProfile&action=" + action + "&type=ISDN&data=" + data,
            dataType : "html",
            success : function( text )
            {
                $( '#refreshing' ).hide( );
                ret = text.split( '|' );
                ajaxAlert( ret[1] )
                if( ret[0] > 0 )
                    listProfiles( );
            }
        } );
    }
}

function createR2( action )
{
    if( action == 'copy' )
    {
        if( $.trim( $( '#name' ).val( ) ) == '' )
        {
            ajaxAlert( 'nameEmpty' );
            return;
        }
    }
    var data = '';
    $( '#Profiles input[type=hidden], input[type=text], select, ' ).each( function( i, c )
    {
        data += $( c ).attr( 'id' ) + ':' + $( c ).val( ) + ',';
    } );
    data += 'ForcedDisconnection:' + $( '#ForcedDisconnection' ).is( ':checked' ) + ',';

    for( x = 0; x < 30; x++ )
    {
        part1 = 0;
        part2 = 0;
        if( $( '#entrante' + x ).is( ':checked' ) )
            part1 = 1;
        if( $( '#sainte' + x ).is( ':checked' ) )
            part2 = 2;
        finalPart = part1 + part2;
        if( finalPart != 0 )
            data += 'Channels' + x + ':' + finalPart + ',';
    }

    if( data != '' )
    {
        data = data.substr( 0, data.length - 1 );
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=createProfile&action=" + action + "&type=R2&data=" + data,
            dataType : "html",
            success : function( text )
            {
                $( '#refreshing' ).hide( );
                ret = text.split( '|' );
                ajaxAlert( ret[1] )
                if( ret[0] > 0 )
                    listProfiles( );
            }
        } );
    }
}

function removeProfile( name )
{
    if( ajaxConfirm( 'ConfirmdeleteProfile' ) )
    {
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=removeProfile&name=" + name,
            dataType : "html",
            success : function( text )
            {
                $( '#refreshing' ).hide( );
                ajaxAlert( text );
                listProfiles( );
            }
        } );
    }
}

function copyProfile( name )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=copyProfile&name=" + name,
        dataType : "html",
        success : function( text )
        {
            $( '#Profiles' ).html( text );
            $( '#refreshing' ).hide( );
        }
    } );
}

function listProfiles( )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showProfiles",
        dataType : "html",
        success : function( text )
        {
            $( '#Profiles' ).html( text );
            $( '#refreshing' ).hide( );
        }
    } );
}

function editProfile( name )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=editProfile&name=" + name,
        dataType : "html",
        success : function( text )
        {
            $( '#Profiles' ).html( text );
            $( '#refreshing' ).hide( );
        }
    } );
}

function saveDCCallConfigs( qtde )
{
    var data = ''
    for( x = 0; x < qtde; x++ )
    {
        data += $( '#DropCollectCallsA' + x ).val( ) + '|AutoBlock;' + $( '#DropCollectCallsB' + x ).is( ':checked' ) + '|BlockResponse;' + $( '#DropCollectCallsC' + x ).val( ) + '|DropCallAnalyzer;' + $( '#DropCollectCallsD' + x ).is( ':checked' ) + '|AutoDoubleAnswer;' + $( '#DropCollectCallsE' + x ).is( ':checked' ) + '|DoubleAnswerDelay;' + $( '#DropCollectCallsF' + x ).val( );
        data += qtde > 0 && x != qtde - 1 ? ',' : '';
    }

    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=assistant&action=saveDCCallConfigs&data=" + data,
        dataType : "html",
        success : function( text )
        {
            $( '#DropCollectCalls' ).html( text );
            $( '#dialog-modal' ).dialog( 'close' );
            $( '#refreshing' ).hide( );
        }
    } );
}

function saveAssistant( divName )
{
    var WCSubType = $( '#WCSubType' ).val( );
    var type = $( '#WCType' ).val( )

    switch(WCSubType)
    {

        case 'Channel':
            var device = $( '#WCDevice' ).val( );
            var sChannel = $( '#WCSChannel' ).val( );
            var eChannel = $( '#WCEChannel' ).val( );

            if( device == '' )
            {
                ajaxAlert( 'emptyDevice' );
                return;
            }

            if( $( '#WCSChannel' ).val( ) != '' && $( '#WCEChannel' ).val( ) != '' )
                var wc = device + '.[' + sChannel + '-' + eChannel + ']';
            else
            {
                ajaxAlert( 'emptyRange' );
                return;
            }
            break;

        case 'Device':
            var device = $( '#WCTab2Device' ).val( );
            if( device != '' )
                var wc = device + '.*';
            else
            {
                ajaxAlert( 'emptyDevice' );
                return;
            }
            break;

        case'Links':
            var device = $( '#WCTab3Device' ).val( );
            var link = $( '#WCLink' ).val( );
            if( device != '' )
                var wc = device + '.' + link;
            else
            {
                ajaxAlert( 'emptyDevice' );
                return;
            }
            break;

        case 'Tech':
            var tech = $( '#WCTech' ).val( );
            if( tech != '' )
                var wc = '*.' + tech;
            else
            {
                ajaxAlert( 'emptyTech' );
                return;
            }
            break;

        case 'All':
            var wc = '*.*';
            break;

        default:
            return;
    }

    execute = '&wc=' + wc;
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=assistant&action=add" + type + "&type=" + type + execute,
        dataType : "html",
        success : function( text )
        {
            $( '#' + divName ).html( text );
            $( '#dialog-modal' ).dialog( 'close' );
            $( '#dialog-modal' ).dialog( 'destroy' );
            $( '#refreshing' ).hide( );
        }
    } );
}

function removeACAanalyzer( ACA )
{
    if( ajaxConfirm( 'sureToRemoveRule' ) )
    {
        var execute = 'action=removeACAanalyzer&type=ACAnalyzer&WC=' + ACA;
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            data : "ajaxTo=assistant&" + execute,
            url : GLOBALAjaxURL,
            dataType : "text",
            async : false,
            success : function( ret )
            {
                $( '#AutoCallAnalyser' ).html( ret );
                $( '#refreshing' ).hide( );
                ajaxAlert( 'ConfiguracaoSalva' );
            }
        } );
    }
}

function removeAECancel( AEC )
{
    if( ajaxConfirm( 'sureToRemoveRule' ) )
    {
        var execute = 'action=removeAECancel&type=AECancel&WC=' + AEC;
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            data : "ajaxTo=assistant&" + execute,
            url : GLOBALAjaxURL,
            dataType : "text",
            async : false,
            success : function( ret )
            {
                $( '#AutoEchoCanceller' ).html( ret );
                $( '#refreshing' ).hide( );
                ajaxAlert( 'ConfiguracaoSalva' );
            }
        } );
    }
}

function removeADSupression( AED )
{
    if( ajaxConfirm( 'sureToRemoveRule' ) )
    {
        var execute = 'action=removeADSup&type=ADSup&WC=' + AED;
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            data : "ajaxTo=assistant&" + execute,
            url : GLOBALAjaxURL,
            dataType : "text",
            async : false,
            success : function( ret )
            {
                $( '#AutoDtmfSuppression' ).html( ret );
                $( '#refreshing' ).hide( );
                ajaxAlert( 'ConfiguracaoSalva' );
            }
        } );
    }
}

function removeAAGC( AGC )
{
    if( ajaxConfirm( 'sureToRemoveRule' ) )
    {
        var execute = 'action=removeAAGC&type=AAGC&WC=' + AGC;
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            data : "ajaxTo=assistant&" + execute,
            url : GLOBALAjaxURL,
            dataType : "text",
            async : false,
            success : function( ret )
            {
                $( '#AutoAGC' ).html( ret );
                $( '#refreshing' ).hide( );
                ajaxAlert( 'ConfiguracaoSalva' );
            }
        } );
    }
}

function removeDCCall( DCC )
{
    if( ajaxConfirm( 'sureToRemoveRule' ) )
    {
        var execute = 'action=removeDCCall&type=DCCall&WC=' + DCC;
        $( '#refreshing' ).show( );
        jQuery.ajax(
        {
            data : "ajaxTo=assistant&" + execute,
            url : GLOBALAjaxURL,
            dataType : "text",
            async : false,
            success : function( ret )
            {
                $( '#DropCollectCalls' ).html( ret );
                $( '#refreshing' ).hide( );
                ajaxAlert( 'ConfiguracaoSalva' );
            }
        } );
    }
}

function getEChannel( channel )
{
    var device = $( '#WCDevice' ).val( );
    var WCEChannel = $( '#WCEChannel' ).val( );

    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        data : "ajaxTo=assistant&action=getEChannels&Schannel=" + channel + '&EChannel=' + WCEChannel + '&device=' + device,
        url : GLOBALAjaxURL,
        dataType : "text",
        async : false,
        success : function( ret )
        {
            $( '#WCEChannel' ).html( ret );
            $( '#refreshing' ).hide( );
        }
    } );
}

function getSChannel( device )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        data : "ajaxTo=assistant&action=getSChannels&device=" + device,
        url : GLOBALAjaxURL,
        dataType : "text",
        async : false,
        success : function( ret )
        {
            $( '#WCSChannel' ).html( ret );
            $( '#WCEChannel' ).html( ret );
            $( '#refreshing' ).hide( );
        }
    } );
}

function getDeviceLinks( device )
{

    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        data : "ajaxTo=assistant&action=getLinks&device=" + device,
        url : GLOBALAjaxURL,
        dataType : "text",
        async : false,
        success : function( ret )
        {
            $( '#WCLink' ).html( ret );
            $( '#refreshing' ).hide( );

        }
    } );
}

function initAssistant( type )
{
    $( '#refreshing' ).show( );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=getAssistant&action=getWCAssistant&type=" + type,
        dataType : "html",
        success : function( text )
        {
            if($('#dialog-modal').length > 0)
                $('#dialog-modal').remove();
                
            var div = $( "<div id='dialog-modal' > </div>" );
            div.html( text );
            div.css( 'text-align', 'left' );
            div.dialog(
            {
                height : 600,
                width : 600,
                modal : true,
                closeOnEscape : true,
                close : function( )
                {
                    $( this ).dialog( 'destroy' );
                    div.remove( );
                }
            } );
            $( "#tabs" ).tabs( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function saveCallAnalyzer( )
{
    var data = '';
    $( 'fieldset select' ).each( function( i, a )
    {
        data += $( a ).attr( 'id' ) + '=' + $( a ).val( ) + ',';
    } );
    data = data.substr( 0, data.length - 1 );

    $( '#refreshing' ).show( );
    $( '#saveCallAnalyzerB' ).attr( 'disabled', 'true' );
    $( '#saveCallAnalyzerB' ).css( 'background', 'gray' );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveCallAnalyzer&data=" + data,
        dataType : "html",
        success : function( text )
        {
            ShowNotice( text, true );
            $( '#refreshing' ).hide( );
            $( '#saveCallAnalyzerB' ).removeAttr( 'disabled' );
            $( '#saveCallAnalyzerB' ).css( 'background', '#339966' );
        }
    } );
}

function saveFax( )
{
    var data = '';
    $( 'fieldset input[type=text]' ).each( function( i, a )
    {
        data += $( a ).attr( 'id' ) + '=' + $( a ).val( ) + ',';
    } );
    $( 'fieldset input[type=checkbox] ' ).each( function( i, a )
    {
        if( $( a ).is( ':checked' ) )
            data += $( a ).attr( 'id' ) + '=true,';
        else
            data += $( a ).attr( 'id' ) + '=false,';
    } );
    data = data.substr( 0, data.length - 1 );
    
    $( '#refreshing' ).show( );
    $( '#saveFaxB' ).attr( 'disabled', 'true' );
    $( '#saveFaxB' ).css( 'background', 'gray' );
    
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveFax&data=" + data,
        dataType : "html",
        success : function( text )
        {
            ShowNotice( text, true );
            $( '#refreshing' ).hide( );
            $( '#saveFaxB' ).removeAttr( 'disabled' );
            $( '#saveFaxB' ).css( 'background', '#339966' );
        }
    } );
}

function saveLogsErrorCount( )
{
    var data = '';
    $( 'fieldset select' ).each( function( i, a )
    {
        data += $( a ).attr( 'id' ) + '=' + $( a ).val( ) + ',';
    } );

    counters = '';
    countersTrue = false;

    $( 'fieldset input[type=checkbox]' ).each( function( i, a )
    {
        if( $( a ).is( ':checked' ) )
        {
            counters += 'true:'
            countersTrue = true;
        }
        else
            counters += 'false:'

    } );
    counters = counters.substr( 0, counters.length - 1 );

    if( countersTrue )
        data += 'IgnoredCounters=' + counters;
    else
        data += 'IgnoredCounters=';

    $( '#refreshing' ).show( );
    $( '#saveLogsErrorCountB' ).attr( 'disabled', 'true' );
    $( '#saveLogsErrorCountB' ).css( 'background', 'gray' );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveLogsErrorCount&data=" + data,
        dataType : "html",
        success : function( text )
        {
            ShowNotice( text, true );
            $( '#refreshing' ).hide( );
            $( '#saveLogsErrorCountB' ).removeAttr( 'disabled' );
            $( '#saveLogsErrorCountB' ).css( 'background', '#339966' );
        }
    } );
}

function saveAPICompatibility( )
{
    var data = '';
    $( 'fieldset select' ).each( function( i, a )
    {
        data += $( a ).attr( 'id' ) + '=' + $( a ).val( ) + ',';
    } );
    $( 'fieldset input[type=checkbox]' ).each( function( i, a )
    {
        data += $( a ).is( ':checked' ) ? $( a ).attr( 'id' ) + '=true,' : $( a ).attr( 'id' ) + '=false,'
    } );

    data = data.substr( 0, data.length - 1 );

    $( '#refreshing' ).show( );
    $( '#saveAPICompatibilityB' ).attr( 'disabled', 'true' );
    $( '#saveAPICompatibilityB' ).css( 'background', 'gray' );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveAPICompatibility&data=" + data,
        dataType : "html",
        success : function( text )
        {
            ShowNotice( text, true );
            $( '#refreshing' ).hide( );
            $( '#saveAPICompatibilityB' ).removeAttr( 'disabled' );
            $( '#saveAPICompatibilityB' ).css( 'background', '#339966' );
        }
    } );
}

function saveVoIPCodecs( )
{
    var data = '';
    $( 'input[type=checkbox]' ).each( function( i, v )
    {
        if( $( v ).is( ':checked' ) )
            data += $( v ).val( ) + ',';
    } );
    data = data.substr( 0, data.length - 1 );

    if( data == '' )
    {
        ajaxAlert( 'AtLeastOneCodec' );
        return;
    }

    $( '#refreshing' ).show( );
    $( '#saveVoIPCodecsB' ).attr( 'disabled', 'true' );
    $( '#saveVoIPCodecsB' ).css( 'background', 'gray' );

    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveVoIPCodecs&data=" + data,
        dataType : "html",
        success : function( text )
        {
            ShowNotice( text, true );
            $( '#refreshing' ).hide( );
            $( '#saveVoIPCodecsB' ).removeAttr( 'disabled' );
            $( '#saveVoIPCodecsB' ).css( 'background', '#339966' );
        }
    } );
}

function saveVoIPOptions( )
{
    var data = '';
    var validation = true;

    $( 'fieldset input[type=text], select' ).each( function( a, i )
    {
        id = $( i ).attr( 'id' );
        comp = $( i );
        if( $.trim( comp.val( ) ) == '' && id != 'Proxy' && id != 'SipInterface' && id != 'RtpInterface' )
        {
            comp.css( 'background', '#F96868' );
            validation = false;
            return;
        }
        data += $( i ).attr( 'id' ) + '=' + $( i ).val( ) + ',';
    } );

    if( document.getElementById( 'Proxy' ) )
    {
        if( !validateIP( document.getElementById( 'Proxy' ) ) || !validateIP( document.getElementById( 'SipInterface' ) ) )
        {
            ajaxAlert( 'WAddress' );
            return;
        }
    }
    if( !validation )
    {
        ajaxAlert( 'needToFillTheField' );
        return;
    }

    if( $( '#VoIPDeviceSerial' ).val( ) < 99 )
    {
        ajaxAlert( 'WrongVoIPDeviceSerial' );
        return;
    }
    data = data.substr( 0, data.length - 1 );

    $( '#refreshing' ).show( );
    $( '#saveVoIPOptionsB' ).attr( 'disabled', 'true' );
    $( '#saveVoIPOptionsB' ).css( 'background', 'gray' );
    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveVoIPOptions&data=" + data,
        dataType : "html",
        success : function( text )
        {
            ShowNotice( text, true );
            $( '#refreshing' ).hide( );
            $( '#saveVoIPOptionsB' ).removeAttr( 'disabled' );
            $( '#saveVoIPOptionsB' ).css( 'background', '#339966' );
        }
    } );
}

function saveMediaServer( )
{
    var data = '';
    var validation = true;

    $( 'fieldset input[type=text]' ).each( function( a, i )
    {
        comp = $( i );
        if( $.trim( comp.val( ) ) == '' && comp.attr( 'id' ) != 'LocalAudioInterface' )
        {
            comp.css( 'background', '#F96868' );
            validation = false;
            return;
        }
        data += $( i ).attr( 'id' ) + '=' + $( i ).val( ) + ',';
    } );

    if( !validation )
    {
        ajaxAlert( 'needToFillTheField' );
        return;
    }
    if( !validateIP( document.getElementById( 'LocalAudioInterface' ) ) )
    {
        ajaxAlert( 'WAddress' );
        return
    }

    data = data.substr( 0, data.length - 1 );
    $( '#refreshing' ).show( );
    $( '#saveMediaServerB' ).attr( 'disabled', 'true' );
    $( '#saveMediaServerB' ).css( 'background', 'gray' );

    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveMediaServer&data=" + data,
        dataType : "html",
        success : function( text )
        {
            ShowNotice( text, true );
            $( '#refreshing' ).hide( );
            $( '#saveMediaServerB' ).removeAttr( 'disabled' );
            $( '#saveMediaServerB' ).css( 'background', '#339966' );
        }
    } );
}

function saveKIBS( )
{
    if( $( '#nInterfaces' ).val( ) != 0 )
    {
        totalnInterfaces = $( '#nInterfaces' ).val( );
        nInterfaces = '';

        for( x = 0; x < totalnInterfaces; x++ )
        {
            if( nInterfaces == '' )
            {
                if( $( '#kibsinterface' + x ).is( ':checked' ) )
                    nInterfaces = $( '#kibsinterface' + x ).val( );
            }
            else
            {
                if( $( '#kibsinterface' + x ).is( ':checked' ) )
                    nInterfaces += ',' + $( '#kibsinterface' + x ).val( );
            }
        }
        var data = nInterfaces;
        $( '#refreshing' ).show( );
        $( '#saveKIBSB' ).attr( 'disabled', 'true' );
        $( '#saveKIBSB' ).css( 'background', 'gray' );
        jQuery.ajax(
        {
            url : GLOBALAjaxURL,
            data : "ajaxTo=saveKIBS&data=" + data,
            dataType : "html",
            success : function( text )
            {
                ShowNotice( text, true );
                $( '#refreshing' ).hide( );
                $( '#saveKIBSB' ).removeAttr( 'disabled' );
                $( '#saveKIBSB' ).css( 'background', '#339966' );
            }
        } );
    }
}

function checkAllInterfaces( )
{
    if( $( '#nInterfaces' ).val( ) != 0 )
    {
        totalnInterfaces = $( '#nInterfaces' ).val( );
        for( x = 0; x < totalnInterfaces; x++ )
            $( '#kibsinterface' + x ).attr( 'checked', true );
    }
}

function saveServices( containerName )
{
    var pageData = '';
    var validation = true;
    $( '#' + containerName + ' input, select' ).each( function( i, e )
    {
        valor = $( e ).val( );
        if( valor == '' )
        {
            validation = false;
            return;
        }
        campo = String( $( e ).attr( 'id' ) );
        pageData += campo + ':' + valor + ',';
    } );
    if( !validation )
    {
        ajaxAlert( 'needToFillAllFields' );
        return;
    }

    $( '#refreshing' ).show( );

    $( '#saveServicesB' ).attr( 'disabled', 'true' );
    $( '#saveServicesB' ).css( 'background', 'gray' );

    jQuery.ajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveServices&data=" + pageData,
        dataType : "html",
        success : function( text )
        {
            ShowNotice( text, true );
            $( '#refreshing' ).hide( );
            $( '#saveServicesB' ).removeAttr( 'disabled' );
            $( '#saveServicesB' ).css( 'background', '#339966' );

        }
    } );
}

function changeView( section, comp, whoToBold )
{
    $( '.folder' ).each( function( i, c )
    {
        $( c ).css( 'font-weight', 'normal' );
    } );
    $( comp ).css( 'font-weight', 'bold' );
    if( whoToBold != '' )
    {
        var menu = whoToBold.split( ',' );
        for( i = 0; i < menu.length; i++ )
            $( '#' + menu[i] ).css( 'font-weight', 'bold' );
    }

    $( '#refreshing' ).show( );

    $.ajax(
    {
        url : GLOBALAjaxURL + "&ajaxTo=" + section,
        dataType : "html",
        success : function( text )
        {
            $( '#formulario' ).html( text );
            $( '.collapsePara' ).collapser(
            {
                target : 'next',
                effect : 'slide',
                changeText : 0
            } );

            switch(section)
            {
                case 'showVoIPCodecs' :
                    $( "#sortable" ).sortable( );
                    break;
                case 'showDevices' :
                    $( "#sortableDevice" ).sortable( );
                    $( "#sortableDevice" ).sortable(
                    {
                        update : function( event, ui )
                        {
                            delayedCheck( );
                        }
                    } );
                    break;
                // ss7
                case 'showMTP2':
                    initMtp2( );
                    break;
                case 'showPointCodes':
                    initPointCodes( );
                    break;
                case 'showLinkSets':
                    initMtp3LinkSets( );
                    break;
                case 'showRoutes':
                    initMtp3Routes( );
                    break;
                case 'showCircuitGroups':
                    initIsupCircuitGroups( );
                    break;
                case 'showTimers':
                    initIsupTimers( );
                    break;
                // gateway
                case 'showNetworkGW':
                    initNetworkGW( );
                    break;
                case 'showRoutesGW' :
                    initRoutesGW( );
                    break;
                case 'showCDROptions':
                    initCDR( );
                    break;
                case 'showCodecProfiles':
                    initCodecProfiles( );
                    break;
                case 'showNAPsGW':
                    initNAPs( );
                    break;
                case 'showTimeRestraintsGW':
                    initTimeRestraints( );
                    break;
            }

            $( '#refreshing' ).hide( );
        }
    } );

    return true;
}

function showManuallyChannels( )
{
    if( $( '#ManuallyChannels' ).is( ":visible" ) )
        $( '#ManuallyChannels' ).hide( );
    else
        $( '#ManuallyChannels' ).show( );
}

function helpAssistant( )
{
    $( "#dialog:ui-dialog" ).dialog( "destroy" );
    $( '#dialog-modal' ).attr( 'title', 'Help' );
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanPerfil.php?action=getHelpChanAssistant',
        data : '',
        dataType : "text",
        success : function( text )
        {
            $( '#dialog-modal' ).html( text );
            $( '#dialog-modal' ).css( 'text-align', 'left' );
            $( "#dialog-modal" ).dialog(
            {
                height : 600,
                width : 600,
                modal : true,
                closeOnEscape : true
            } );
        }
    } );
}

function showKhompChanToolTip( event, text )
{
    $( '#khompChanToolTip' ).html( text );
    var x = event.pageX;
    var y = event.pageY;
    $( '#khompChanToolTip' ).css(
    {
        'top' : y + 10,
        'left' : x - 480
    } );
    $( '#khompChanToolTip' ).show( );
}

function hideKhompChanToolTip( )
{
    $( '#khompChanToolTip' ).hide( );
}

function listKhompChanPerfis( )
{
    var send = 'action=printKCPerfil';
    xmlhttpGeneric( 'ajax/khompChanPerfil.php', 'KhompChanGeral', 'KhompChanPerfil', send );
}

function construcQueryStrig( name, value )
{
    return name + '=' + value + '|';
}

function saveKhompChan( sessionName )
{
    var vars = '';

    if( sessionName == 'channels' )
        var global = true;
    else
        var global = false;

    // GERAL
    var enabled = document.getElementById( 'enabled' ).checked ? 'yes' : 'no';
    var dropcollectcall = document.getElementById( 'drop-collect-call' ).checked ? 'yes' : 'no';
    var usertransferenable = document.getElementById( 'user-transfer-enable' ).checked ? 'yes' : 'no';
    var selectRightCallGroup = getMultSelectContent( 'selectRightCallGroup' );
    var selectRightPickupGroup = getMultSelectContent( 'selectRightPickupGroup' );
    vars += construcQueryStrig( 'CallGroup', selectRightCallGroup );
    vars += construcQueryStrig( 'PickupGroup', selectRightPickupGroup );
    vars += construcQueryStrig( 'enabled', enabled );
    vars += construcQueryStrig( 'drop-collect-call', dropcollectcall );
    vars += construcQueryStrig( 'amaflags', $( '#amaflags' ).val( ) );
    vars += construcQueryStrig( 'accountcode', $( '#accountcode' ).val( ) );
    vars += construcQueryStrig( 'language', $( '#language' ).val( ) );
    vars += construcQueryStrig( 'mohclass', $( '#mohclass' ).val( ) );
    vars += construcQueryStrig( 'pendulum-digits', $( '#pendulum-digits' ).val( ) );
    vars += construcQueryStrig( 'pendulum-timeout', $( '#pendulum-timeout' ).val( ) );
    vars += construcQueryStrig( 'user-transfer-enable', usertransferenable );
    if( global )
    {
        var loaderror = document.getElementById( 'load-error' ).checked ? 'failure' : 'skip';
        vars += construcQueryStrig( 'load-error', loaderror );
        vars += construcQueryStrig( 'user-transfer-digits', $( '#user-transfer-digits' ).val( ) );
        vars += construcQueryStrig( 'dial-string-like-dahdi', $( '#dial-string-like-dahdi' ).val( ) );
    }
    //AUDIO
    var echocanceller = document.getElementById( 'echo-canceller' ).checked ? 'yes' : 'no';
    var autogaincontrol = document.getElementById( 'auto-gain-control' ).checked ? 'yes' : 'no';
    var outofbanddtmfs = document.getElementById( 'out-of-band-dtmfs' ).checked ? 'yes' : 'no';
    var suppressiondelay = document.getElementById( 'suppression-delay' ).checked ? 'yes' : 'no';
    var autofaxadjustment = document.getElementById( 'auto-fax-adjustment' ).checked ? 'yes' : 'no';
    var ignoreletterdtmfs = document.getElementById( 'ignore-letter-dtmfs' ).checked ? 'yes' : 'no';
    var pulseforwarding = document.getElementById( 'pulse-forwarding' ).checked ? 'yes' : 'no';
    vars += construcQueryStrig( 'echo-canceller', echocanceller );
    vars += construcQueryStrig( 'auto-gain-control', autogaincontrol );
    vars += construcQueryStrig( 'out-of-band-dtmfs', outofbanddtmfs );
    vars += construcQueryStrig( 'suppression-delay', suppressiondelay );
    vars += construcQueryStrig( 'auto-fax-adjustment', autofaxadjustment );
    vars += construcQueryStrig( 'ignore-letter-dtmfs', ignoreletterdtmfs );
    vars += construcQueryStrig( 'fax-adjustment-timeout', $( '#fax-adjustment-timeout' ).val( ) );
    vars += construcQueryStrig( 'input-volume', $( '#input-volume' ).val( ) );
    vars += construcQueryStrig( 'output-volume', $( '#output-volume' ).val( ) );
    vars += construcQueryStrig( 'audio-packet-length', $( '#audio-packet-length' ).val( ) );
    vars += construcQueryStrig( 'pulse-forwarding', pulseforwarding );
    if( global )
    {
        var optimizeaudiopath = document.getElementById( 'optimize-audio-path' ).checked ? 'yes' : 'no';
        vars += construcQueryStrig( 'optimize-audio-path', optimizeaudiopath );
    }
    //E1
    var r2strictbehaviour = document.getElementById( 'r2-strict-behaviour' ).checked ? 'yes' : 'no';
    vars += construcQueryStrig( 'r2-strict-behaviour', r2strictbehaviour );
    vars += construcQueryStrig( 'r2-preconnect-wait', $( '#r2-preconnect-wait' ).val( ) );
    vars += construcQueryStrig( 'r2-hangup-behaviour', $( '#r2-hangup-behaviour' ).val( ) );
    vars += construcQueryStrig( 'qsig-transfer-facility', $( '#qsig-transfer-facility' ).val( ) );
    //FXS
    var fxssendbinadtmf = document.getElementById( 'fxs-send-bina-dtmf' ).checked ? 'yes' : 'no';
    var fxssendfsk = document.getElementById( 'fxs-send-fsk' ).checked ? 'yes' : 'no';
    var fxssharpdial = document.getElementById( 'fxs-sharp-dial' ).checked ? 'yes' : 'no';
    vars += construcQueryStrig( 'fxs-send-bina-dtmf', fxssendbinadtmf );
    vars += construcQueryStrig( 'fxs-send-fsk', fxssendfsk );
    vars += construcQueryStrig( 'fxs-sharp-dial', fxssharpdial );
    vars += construcQueryStrig( 'disconnect-delay', $( '#disconnect-delay' ).val( ) );
    vars += construcQueryStrig( 'delay-ringback-co', $( '#delay-ringback-co' ).val( ) );
    vars += construcQueryStrig( 'delay-ringback-pbx', $( '#delay-ringback-pbx' ).val( ) );
    vars += construcQueryStrig( 'fxs-digit-timeout', $( '#fxs-digit-timeout' ).val( ) );
    if( global )
    {
        var fxscodialtoneselect = getMultSelectContent( 'fxs-co-dialtone-select' );
        vars += construcQueryStrig( 'fxs-co-dialtone-select', fxscodialtoneselect );
        vars += construcQueryStrig( 'fxs-global-orig', $( '#fxs-global-orig' ).val( ) );
    }
    //FXO
    vars += construcQueryStrig( 'fxo-fsk-timeout', $( '#fxo-fsk-timeout' ).val( ) );
    vars += construcQueryStrig( 'fxo-user-xfer-delay', $( '#fxo-user-xfer-delay' ).val( ) );
    vars += construcQueryStrig( 'fxo-busy-disconnection', $( '#fxo-busy-disconnection' ).val( ) );
    vars += construcQueryStrig( 'fxo-fsk-detection', $( '#fxo-fsk-detection' ).val( ) );

    if( global )
    {
        var fxosendpreaudio = document.getElementById( 'fxo-send-pre-audio' ).checked ? 'yes' : 'no';
        vars += construcQueryStrig( 'fxo-send-pre-audio', fxosendpreaudio );
    }

    if( global )
    {
        //KOMMUTER
        vars += construcQueryStrig( 'kommuter-timeout', $( '#kommuter-timeout' ).val( ) );
        vars += construcQueryStrig( 'kommuter-activation', $( '#kommuter-activation' ).val( ) );
        //CONTEXT
        vars += construcQueryStrig( 'context-digital', $( '#context-digital' ).val( ) );
        vars += construcQueryStrig( 'context-fxs', $( '#context-fxs' ).val( ) );
        vars += construcQueryStrig( 'context-fxs-alt', $( '#context-fxs-alt' ).val( ) );
        vars += construcQueryStrig( 'context-fxo', $( '#context-fxo' ).val( ) );
        vars += construcQueryStrig( 'context-fxo-alt', $( '#context-fxo-alt' ).val( ) );
        vars += construcQueryStrig( 'context-gsm-call', $( '#context-gsm-call' ).val( ) );
        vars += construcQueryStrig( 'context-gsm-call-alt', $( '#context-gsm-call-alt' ).val( ) );
        vars += construcQueryStrig( 'context-gsm-sms', $( '#context-gsm-sms' ).val( ) );
        vars += construcQueryStrig( 'context-gsm-wait', $( '#context-gsm-wait' ).val( ) );
        vars += construcQueryStrig( 'context-pr', $( '#context-pr' ).val( ) );
    }
    send = 'action=save&perfil=' + sessionName + '&vars=' + vars;
    xmlhttpGeneric( 'ajax/khompChanPerfil.php', 'KhompChanGeral', 'KhompChanPerfil2', send );
}

function onlyNumbersAndSymbols( evt, comp )
{
    if( escapeKeys( evt ) )
        return true;
    else
    {
        var key = evt.keyCode;
        if( (key >= 96 && key <= 105) || key >= 48 && key <= 57 )
            return true;
        else
            return false;
    }
}

function selectAllGroups( name )
{
    var elRight = document.getElementById( 'selectRight' + name );
    var elLeft = document.getElementById( 'selectLeft' + name );
    var size = elLeft.length;
    for( var i = 0; i < size; i++ )
    {
        var elOptNew = document.createElement( 'option' );
        elOptNew.value = elLeft.options[0].value;
        elOptNew.text = elLeft.options[0].text;
        try
        {
            elRight.add( elOptNew, null );
        }
        catch(ex)
        {
            elRight.add( elOptNew );
        }
        elLeft.remove( 0 );
    }
    sortlist( 'selectRight' + name );
    sortlist( 'selectLeft' + name );
}

function unselectAllGroups( name )
{
    var elRight = document.getElementById( 'selectRight' + name );
    var elLeft = document.getElementById( 'selectLeft' + name );
    var size = elRight.length;
    for( var i = 0; i < size; i++ )
    {
        var elOptNew = document.createElement( 'option' );
        elOptNew.value = elRight.options[0].value;
        elOptNew.text = elRight.options[0].text;
        try
        {
            elLeft.add( elOptNew, null );
        }
        catch(ex)
        {
            elLeft.add( elOptNew );
        }
        elRight.remove( 0 );
    }
    sortlist( 'selectRight' + name );
    sortlist( 'selectLeft' + name );
}

function addGroup( name )
{
    var elRight = document.getElementById( 'selectRight' + name );
    var elLeft = document.getElementById( 'selectLeft' + name );
    for( var i = elLeft.length - 1; i >= 0; i-- )
    {
        if( elLeft.options[i].selected )
        {
            var elOptNew = document.createElement( 'option' );
            elOptNew.value = elLeft.options[i].value;
            elOptNew.text = elLeft.options[i].text;
            try
            {
                elRight.add( elOptNew, null );
            }
            catch(ex)
            {
                elRight.add( elOptNew );
            }
            elLeft.remove( i );
        }
    }
    sortlist( 'selectRight' + name );
    sortlist( 'selectLeft' + name );
}

function sortNumber( a, b )
{
    return a - b;
}

function removeGroup( name )
{
    var elRight = document.getElementById( 'selectRight' + name );
    var elLeft = document.getElementById( 'selectLeft' + name );
    for( var i = elRight.length - 1; i >= 0; i-- )
    {
        if( elRight.options[i].selected )
        {
            var elOptNew = document.createElement( 'option' );
            elOptNew.value = elRight.options[i].value;
            elOptNew.text = elRight.options[i].text;
            try
            {
                elLeft.add( elOptNew, null );
            }
            catch(ex)
            {
                elLeft.add( elOptNew );
            }
            elRight.remove( i );
        }
    }
    sortlist( 'selectRight' + name );
    sortlist( 'selectLeft' + name );
}

function getMultSelectContent( name )
{
    var mselect = document.getElementById( name );
    var arrTexts = '';
    for( var i = 0; i < mselect.length; i++ )
    {
        if( i == 0 )
            arrTexts = mselect.options[i].text;
        else
            arrTexts += ',' + mselect.options[i].text;
    }
    return arrTexts;
}

function sortlist( lista )
{
    var lb = document.getElementById( lista );
    var arrTexts = new Array( );

    for( var i = 0; i < lb.length; i++ )
        arrTexts[i] = lb.options[i].text;

    arrTexts.sort( sortNumber );
    for( var i = 0; i < lb.length; i++ )
    {
        lb.options[i].text = arrTexts[i];
        lb.options[i].value = arrTexts[i];
    }
}

function add( )
{
    var elSel = document.getElementById( 'fxs-co-dialtone-select' )
    var elOptNew = document.createElement( 'option' );
    elOptNew.text = document.getElementById( 'nome' ).value
    elOptNew.value = document.getElementById( 'nome' ).value
    document.getElementById( 'nome' ).value = '';
    try
    {
        // standards compliant; doesn't work in IE
        elSel.add( elOptNew, null );
    }
    catch(ex)
    {
        // IE only
        elSel.add( elOptNew );
    }
}

function remove( )
{
    var elSel = document.getElementById( 'fxs-co-dialtone-select' );
    for( var i = elSel.length - 1; i >= 0; i-- )
    {
        if( elSel.options[i].selected )
            elSel.remove( i );
    }
}

function showToolTip( text, event )
{
    var divToolTip = document.getElementById( 'tooltip' );
    divToolTip.innerHTML = text;
    divToolTip.style.display = "block";
    divToolTip.style.top = event.clientY;
    divToolTip.style.left = event.clientX;
}

function hideToolTip( )
{
    var divToolTip = document.getElementById( 'tooltip' );
    divToolTip.style.display = "none";
}

function editKhompChanPerfil( name )
{
    var send = 'perfil=' + name + '&action=edit';
    xmlhttpGeneric( 'ajax/khompChanPerfil.php', 'KhompChanGeral', 'KhompChanPerfil', send );
}

function listKhompChanPerfil( )
{
    var send = 'action=printKCPerfil';
    xmlhttpGeneric( 'ajax/khompChanPerfil.php', 'KhompChanGeral', 'KhompChanPerfil', send );
}

function addKCFHotline( )
{
    var varData = 'action=load';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanFHotline.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#KCFHotline' ).html( text );
            $( '#bAddKCFHotline' ).hide( );
        }
    } );
}

function showFOptionValues( )
{
    var data = $( "#fOption" ).val( );
    var send = 'vars=';
    for( var i = 0; i < data.length; i++ )
    {
        var varName = data[i].replace( '-', '' );
        if( document.getElementById( varName ) )
        {
            if( send == 'vars=' )
                send += data[i] + '=' + document.getElementById( data[i] ).value;
            else
                send += '|' + data[i] + '=' + document.getElementById( data[i] ).value;
        }
        else
        {
            if( send == 'vars=' )
                send += data[i] + '=';
            else
                send += '|' + data[i] + '=';
        }
    };
    send += '&action=changeOVars';
    alert( send );
    varData = send;
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanFOption.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            document.getElementById( 'fOptionSpan' ).innerHTML = text;
        }
    } );
}

function getvalue( campo )
{
    var dataValue = '';
    switch(campo.type)
    {
        case "select-multiple":
            for( var i = 0; i < campo.options.length; i++ )
            {
                if( campo.options[i].selected )
                {
                    if( dataValue == '' )
                        dataValue += campo.options[i].label;
                    else
                        dataValue += ',' + campo.options[i].label;
                }
            };
            break;
        case "select-one":
            dataValue = campo.value;
            break;
        case "text":
            dataValue = campo.value;
            break;
    }
    return dataValue;
}

function addKCFOption( )
{
    var varData = 'texto=SelectOne';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'tradutor.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            var contentText = text;
            varData = 'action=load';
            jQuery.ajax(
            {
                type : 'POST',
                url : 'ajax/khompChanFOption.php',
                data : varData,
                dataType : "text",
                success : function( text )
                {
                    document.getElementById( 'KCFOption' ).innerHTML = text;
                    document.getElementById( 'bAddKCFOption' ).style.display = 'none';

                    $( "#fOption" ).dropdownchecklist(
                    {
                        textFormatFunction : function( options )
                        {
                            var selectedOptions = options.filter( ":selected" );
                            var countOfSelected = selectedOptions.size( );
                            var size = options.size( );
                            switch(countOfSelected)
                            {
                                case 0:
                                    return "<i>" + contentText + "<i>";
                                case 1:
                                    return "<i>" + contentText + "<i>";
                            }
                        },
                        width : 150,
                        onItemClick : function( checkbox, selector )
                        {
                            var justChecked = checkbox.prop( "checked" );
                            var varName = '';
                            var send = 'vars=';
                            var replaceSTR = '';

                            if( justChecked )
                            {
                                checkbox[0].defaultValue
                                varName = checkbox[0].defaultValue.replace( '-', '' );
                                if( document.getElementById( varName ) )
                                    send += checkbox[0].defaultValue + '=' + getvalue( document.getElementById( varName ) );
                                else
                                    send += checkbox[0].defaultValue + '=';
                            }
                            else
                            {
                                varName = checkbox[0].defaultValue.replace( '-', '' );
                                if( document.getElementById( varName ) )
                                    replaceSTR = checkbox[0].defaultValue + '=' + getvalue( document.getElementById( varName ) );
                                else
                                    replaceSTR = checkbox[0].defaultValue + '=';
                            }

                            for( var i = 0; i < selector.options.length; i++ )
                            {
                                if( selector.options[i].selected )
                                {
                                    varName = selector.options[i].label.replace( '-', '' );
                                    if( document.getElementById( varName ) )
                                    {
                                        if( send == 'vars=' )
                                            send += selector.options[i].label + '=' + getvalue( document.getElementById( varName ) );
                                        else
                                        {
                                            send += '|' + selector.options[i].label + '=' + getvalue( document.getElementById( varName ) );
                                            if( replaceSTR == (selector.options[i].label + '=' + getvalue( document.getElementById( varName ) )) )
                                                replaceSTR = "|" + replaceSTR;
                                        }
                                    }
                                    else
                                    {
                                        if( send == 'vars=' )
                                            send += selector.options[i].label + '=';
                                        else
                                        {
                                            send += '|' + selector.options[i].label + '=';
                                            if( replaceSTR == (selector.options[i].label + '=') )
                                                replaceSTR = "|" + replaceSTR;
                                        }
                                    }
                                }
                            };
                            send += '&action=changeOVars';
                            send = send.replace( replaceSTR, '' );
                            varData = send;
                            jQuery.ajax(
                            {
                                type : 'POST',
                                url : 'ajax/khompChanFOption.php',
                                data : varData,
                                dataType : "text",
                                success : function( text )
                                {
                                    document.getElementById( 'fOptionSpan' ).innerHTML = text;
                                }
                            } );
                        }
                    } );
                }
            } );
        }
    } );
}

function addKCFBranche( )
{
    var varData = 'action=load';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanFBranche.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#KCFBranche' ).html( text );
            $( '#bAddKCFBranche' ).hide( );
        }
    } );
}

function addKCCadence( )
{
    var varData = 'action=load';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanCadence.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#KCCadence' ).html( text );
            $( '#bAddKCCadence' ).hide( );
        }
    } );
}

function addKCGroup( )
{
    var varData = 'action=load';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanGroup.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#KCGroups' ).html( text );
            $( '#bAddKCGroup' ).hide( );
        }
    } );
}

function editKhompChanFOptions( name )
{
    var varData = 'texto=SelectOne';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'tradutor.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            var contentText = text;
            varData = 'action=edit&name=' + name;
            jQuery.ajax(
            {
                type : 'POST',
                url : 'ajax/khompChanFOption.php',
                data : varData,
                dataType : "text",
                success : function( text )
                {
                    $( '#KCFOption' ).html( text );
                    $( '#bAddKCFOption' ).hide( );

                    $( "#fOption" ).dropdownchecklist(
                    {
                        textFormatFunction : function( options )
                        {
                            var selectedOptions = options.filter( ":selected" );
                            var countOfSelected = selectedOptions.size( );
                            var size = options.size( );
                            switch(0)
                            {
                                case 0:
                                    return "<i>" + contentText + "<i>";
                            }
                        },
                        width : 150,
                        onItemClick : function( checkbox, selector )
                        {
                            var justChecked = checkbox.prop( "checked" );
                            var varName = '';
                            var send = 'vars=';
                            var replaceSTR = '';

                            if( justChecked )
                            {
                                checkbox[0].defaultValue
                                varName = checkbox[0].defaultValue.replace( '-', '' );
                                if( document.getElementById( varName ) )
                                    send += checkbox[0].defaultValue + '=' + getvalue( document.getElementById( varName ) );
                                else
                                    send += checkbox[0].defaultValue + '=';
                            }
                            else
                            {
                                varName = checkbox[0].defaultValue.replace( '-', '' );
                                if( document.getElementById( varName ) )
                                    replaceSTR = checkbox[0].defaultValue + '=' + getvalue( document.getElementById( varName ) );
                                else
                                    replaceSTR = checkbox[0].defaultValue + '=';
                            }

                            for( var i = 0; i < selector.options.length; i++ )
                            {
                                if( selector.options[i].selected )
                                {
                                    varName = selector.options[i].label.replace( '-', '' );
                                    if( document.getElementById( varName ) )
                                    {
                                        if( send == 'vars=' )
                                            send += selector.options[i].label + '=' + getvalue( document.getElementById( varName ) );
                                        else
                                        {
                                            send += '|' + selector.options[i].label + '=' + getvalue( document.getElementById( varName ) );
                                            if( replaceSTR == (selector.options[i].label + '=' + getvalue( document.getElementById( varName ) )) )
                                                replaceSTR = "|" + replaceSTR;
                                        }
                                    }
                                    else
                                    {
                                        if( send == 'vars=' )
                                            send += selector.options[i].label + '=';
                                        else
                                        {
                                            send += '|' + selector.options[i].label + '=';
                                            if( replaceSTR == (selector.options[i].label + '=') )
                                                replaceSTR = "|" + replaceSTR;
                                        }
                                    }
                                }
                            };
                            send += '&action=changeOVars';
                            send = send.replace( replaceSTR, '' );
                            varData = send;
                            jQuery.ajax(
                            {
                                type : 'POST',
                                url : 'ajax/khompChanFOption.php',
                                data : varData,
                                dataType : "text",
                                success : function( text )
                                {
                                    document.getElementById( 'fOptionSpan' ).innerHTML = text;
                                }
                            } );

                        }
                    } );
                }
            } );
        }
    } );
}

function editKhompChanFHotlines( name )
{
    var varData = 'action=edit&name=' + name;
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanFHotline.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#KCFHotline' ).html( text );
            $( '#bAddKCFHotline' ).hide( );
        }
    } );
}

function editKhompChanFBranches( name )
{
    var varData = 'action=edit&name=' + name;
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanFBranche.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#KCFBranche' ).html( text );
            $( '#bAddKCFBranche' ).hide( );
        }
    } );
}

function editKhompChanCadence( cadence )
{
    var varData = 'action=edit&cadence=' + cadence;
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanCadence.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#KCCadence' ).html( text );
            $( '#bAddKCCadence' ).hide( );
        }
    } );
}

function editKhompChanGroup( group )
{
    var varData = 'action=edit&group=' + group;
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanGroup.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#KCGroups' ).html( text );
            $( '#bAddKCGroup' ).hide( );
        }
    } );
}

function deleteKhompChanFOptionsConfirmation( fOption )
{
    var varData = 'texto=delFOptions';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'tradutor.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            if( confirm( text ) )
            {
                varData = 'action=delete&name=' + fOption;
                jQuery.ajax(
                {
                    type : 'POST',
                    url : 'ajax/khompChanFOption.php',
                    data : varData,
                    dataType : "text",
                    success : function( text )
                    {
                        listKCFOptions( );
                    }
                } );
            }
        }
    } );
}

function deleteKhompChanFHotlinesConfirmation( fHotline )
{
    var varData = 'texto=delFHotline';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'tradutor.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            if( confirm( text ) )
            {
                varData = 'action=delete&name=' + fHotline;
                jQuery.ajax(
                {
                    type : 'POST',
                    url : 'ajax/khompChanFHotline.php',
                    data : varData,
                    dataType : "text",
                    success : function( text )
                    {
                        listKCFHotlines( );
                    }
                } );
            }
        }
    } );
}

function deleteKhompChanFBranchesConfirmation( fBranche )
{
    var varData = 'texto=delFBranche';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'tradutor.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            if( confirm( text ) )
            {
                varData = 'action=delete&name=' + fBranche;
                jQuery.ajax(
                {
                    type : 'POST',
                    url : 'ajax/khompChanFBranche.php',
                    data : varData,
                    dataType : "text",
                    success : function( text )
                    {
                        listKCFBranches( );
                    }
                } );
            }
        }
    } );
}

function deleteKhompChanCadenceConfirmation( cadence )
{
    var varData = 'texto=delCadence';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'tradutor.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            if( confirm( text ) )
            {
                varData = 'action=delete&cadence=' + cadence;
                jQuery.ajax(
                {
                    type : 'POST',
                    url : 'ajax/khompChanCadence.php',
                    data : varData,
                    dataType : "text",
                    success : function( text )
                    {
                        listKCCadences( );
                    }
                } );
            }
        }
    } );
}

function deleteKhompChanGroupConfirmation( group )
{
    var varData = 'texto=delGroup';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'tradutor.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            if( confirm( text ) )
            {
                varData = 'action=delete&group=' + group;
                jQuery.ajax(
                {
                    type : 'POST',
                    url : 'ajax/khompChanGroup.php',
                    data : varData,
                    dataType : "text",
                    success : function( text )
                    {
                        listKCGroups( );
                    }
                } );
            }
        }
    } );
}

function alterCRule( )
{
    if( $( '#CTone1' ).val( ) == '' || $( '#CTone2' ).val( ) == '' || $( '#CTone3' ).val( ) == '' || $( '#CTone4' ).val( ) == '' )
        AjaxAlert( 'tradutor.php', 'texto=invalidCtone' );
    else
    {
        var varData = 'action=afterEdit';
        varData += '&newName=' + $( '#CName' ).val( );
        varData += '&oldName=' + $( '#CName-old' ).val( );
        varData += '&value=' + $( '#CTone1' ).val( ) + ',' + $( '#CTone2' ).val( ) + ',' + $( '#CTone3' ).val( ) + ',' + $( '#CTone4' ).val( );

        jQuery.ajax(
        {
            type : 'POST',
            url : 'ajax/khompChanCadence.php',
            data : varData,
            dataType : "text",
            success : function( text )
            {
                if( text == 'Ok' )
                {
                    varData = 'action=list';
                    jQuery.ajax(
                    {
                        type : 'POST',
                        url : 'ajax/khompChanCadence.php',
                        data : varData,
                        dataType : "text",
                        success : function( text )
                        {
                            $( '#KhompChanCadences' ).html( text );
                            $( '#bAddKCCadence' ).show( );
                        }
                    } );
                    AjaxAlert( 'tradutor.php', 'texto=sucessEdit' );
                }
            }
        } );
    }
}

function alterGRule( )
{
    if( $( '#GName' ).val( ) != '' && $( '#GExp' ).val( ) != '' )
    {
        var varData = 'action=afterEdit';
        varData += '&newName=' + $( '#GName' ).val( );
        varData += '&oldName=' + $( '#GName-old' ).val( );
        varData += '&expression=' + $( '#GExp' ).val( );
        varData += '&applyTo=' + $( '#GApplyTo' ).val( );
        test = (/(((([bB])[ ]*([0-9]+))|(([sS])[ ]*([0-9]+)))[ ]*(([cClL])[ ]*([0-9]+)[ ]*([-][ ]*([0-9]+))?)?)|(([rR])[ ]*([0-9]+)[ ]*([-][ ]*([0-9]+))?)/).test( document.getElementById( 'GExp' ).value );
        if( test )
        {
            jQuery.ajax(
            {
                type : 'POST',
                url : 'ajax/khompChanGroup.php',
                data : varData,
                dataType : "text",
                success : function( text )
                {
                    if( text == 'Ok' )
                    {
                        varData = 'action=list';
                        jQuery.ajax(
                        {
                            type : 'POST',
                            url : 'ajax/khompChanGroup.php',
                            data : varData,
                            dataType : "text",
                            success : function( text )
                            {
                                $( '#KhompChanGroups' ).html( text )
                                $( '#bAddKCGroup' ).show( );
                            }
                        } );
                        AjaxAlert( 'tradutor.php', 'texto=sucessEdit' );
                    }
                }
            } );
        }
        else
            AjaxAlert( 'tradutor.php', 'texto=wrongExp' );
    }
    else
        AjaxAlert( 'tradutor.php', 'texto=invalidExp' );
}

function getSimilar( group )
{
    var gSize = group.length;
    var compare = '';

    for( var i = 0; i < gSize; i++ )
    {
        compare = group[i];
        for( var x = i + 1; x < gSize; x++ )
        {
            if( compare == group[x] )
                return true;
        };
    };
    return false;
}

function includeFORule( )
{
    var varData = 'action=add';
    var selector = new Array( );
    var send = 'vars=';
    var varName = '';
    var dataValue = '';
    var test = false;

    if( $( "#fOption" ).val( ) )
        selector = $( "#fOption" ).val( );

    for( var i = 0; i < selector.length; i++ )
    {
        varName = selector[i].replace( '-', '' );
        if( document.getElementById( varName ) )
        {
            dataValue = getvalue( document.getElementById( varName ) )
            if( dataValue == '' )
                test = true;
            if( send == 'vars=' )
                send += selector[i] + '=' + dataValue;
            else
                send += '|' + selector[i] + '=' + dataValue;
            dataValue = '';
        }
    };
    if( test || (selector.length == 0) )
    {
        AjaxAlert( 'tradutor.php', 'texto=nVariavelOrnValue' );
        return;
    }
    var name = document.getElementById( 'FORamal' ).value;
    send += '&name=' + name;
    if( name == '' )
    {
        AjaxAlert( 'tradutor.php', 'texto=invalidName' );
        return;
    }
    varData += "&" + send;
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanFOption.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            if( text == 'Ok' )
            {
                listKCFOptions( );
                AjaxAlert( 'tradutor.php', 'texto=sucesso' );
            }
            else
                AjaxAlert( 'tradutor.php', 'texto=existsName' );
        }
    } );
}

function includeFHRule( )
{
    if( $( '#FHRamal' ).val( ) != '' && $( '#FHNumber' ).val( ) != '' )
    {
        var varData = 'action=add';
        var HNumber = $( '#FHNumber' ).val( );
        varData += '&name=' + $( '#FHRamal' ).val( ) + '&value=' + HNumber;

        jQuery.ajax(
        {
            type : 'POST',
            url : 'ajax/khompChanFHotline.php',
            data : varData,
            dataType : "text",
            success : function( text )
            {
                if( text == 'Ok' )
                {
                    listKCFHotlines( );
                    AjaxAlert( 'tradutor.php', 'texto=sucesso' );
                }
                else
                    AjaxAlert( 'tradutor.php', 'texto=existsName' );
            }
        } );
    }
    else
        AjaxAlert( 'tradutor.php', 'texto=invalidNameAndNumber' );
}

function includeFBRule( )
{
    if( $( '#FBRamal' ).val( ) != '' && $( '#SGroup' ).val( ) != '' )
    {
        var varData = 'action=add';
        var SGroup = $( '#FBSerial' ).val( );
        varData += '&name=' + $( '#FBRamal' ).val( ) + '&value=' + SGroup;
        test = (/^(([0-9]+)|([0-9]+(,[0-9]+)*))$/).test( SGroup );
        if( test )
        {
            var serialGroups = SGroup.split( "," );
            if( !getSimilar( serialGroups ) )
            {
                jQuery.ajax(
                {
                    type : 'POST',
                    url : 'ajax/khompChanFBranche.php',
                    data : varData,
                    dataType : "text",
                    success : function( text )
                    {
                        if( text == 'Ok' )
                        {
                            listKCFBranches( );
                            AjaxAlert( 'tradutor.php', 'texto=sucesso' );
                        }
                        else
                            AjaxAlert( 'tradutor.php', 'texto=existsName' );
                    }
                } );
            }
            else
                AjaxAlert( 'tradutor.php', 'texto=serialsDifferent' );
        }
        else
            AjaxAlert( 'tradutor.php', 'texto=wrongSerialGroup' );
    }
    else
        AjaxAlert( 'tradutor.php', 'texto=invalidNameAndSerialGroup' );
}

function alterFORule( )
{
    var varData = 'action=afterEdit';
    var selector = new Array( );
    var send = 'vars=';
    var varName = '';
    var dataValue = '';
    var test = false;

    if( $( "#fOption" ).val( ) )
        selector = $( "#fOption" ).val( );

    for( var i = 0; i < selector.length; i++ )
    {
        varName = selector[i].replace( '-', '' );
        if( document.getElementById( varName ) )
        {
            dataValue = getvalue( document.getElementById( varName ) )
            if( dataValue == '' )
                test = true;
            if( send == 'vars=' )
                send += selector[i] + '=' + dataValue;
            else
                send += '|' + selector[i] + '=' + dataValue;
            dataValue = '';
        }
    };
    if( test || (selector.length == 0) )
    {
        AjaxAlert( 'tradutor.php', 'texto=nVariavelOrnValue' );
        return;
    }
    var newName = $( '#FORamal' ).val( );
    send += '&newName=' + newName;
    var oldName = $( '#FORamal-old' ).val( );
    send += '&oldName=' + oldName;
    varData += "&" + send;
    if( newName == '' )
    {
        AjaxAlert( 'tradutor.php', 'texto=invalidName' );
        return;
    }
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanFOption.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            if( text == 'Ok' )
            {
                listKCFOptions( );
                AjaxAlert( 'tradutor.php', 'texto=sucesso' );
            }
        }
    } );
}

function alterFHRule( )
{
    if( $( '#hNumber' ).val( ) != '' )
    {
        var varData = 'action=afterEdit';
        var hNumber = $( '#FHNumber' ).val( );
        varData += '&newName=' + $( '#FHRamal' ).val( ) + '&oldName=' + $( '#FHRamal-old' ).val( ) + '&value=' + hNumber;

        jQuery.ajax(
        {
            type : 'POST',
            url : 'ajax/khompChanFHotline.php',
            data : varData,
            dataType : "text",
            success : function( text )
            {
                if( text == 'Ok' )
                {
                    listKCFHotlines( );
                    AjaxAlert( 'tradutor.php', 'texto=sucesso' );
                }
            }
        } );
    }
    else
        AjaxAlert( 'tradutor.php', 'texto=invalidNumber' );
}

function alterFBRule( )
{
    if( $( '#FBRamal' ).val( ) != '' || !$( '#FBSerial' ).val( ) != '' )
    {
        var varData = 'action=afterEdit';
        var SGroup = $( '#FBSerial' ).val( );
        varData += '&newName=' + $( '#FBRamal' ).val( ) + '&oldName=' + $( '#FBRamal-old' ).val( ) + '&value=' + SGroup;
        test = (/^(([0-9]+)|([0-9]+(,[0-9]+)*))$/).test( SGroup );
        if( test )
        {
            var serialGroups = SGroup.split( "," );
            if( !getSimilar( serialGroups ) )
            {
                jQuery.ajax(
                {
                    type : 'POST',
                    url : 'ajax/khompChanFBranche.php',
                    data : varData,
                    dataType : "text",
                    success : function( text )
                    {
                        if( text == 'Ok' )
                        {
                            listKCFBranches( );
                            AjaxAlert( 'tradutor.php', 'texto=sucesso' );
                        }
                        else
                            AjaxAlert( 'tradutor.php', 'texto=existsName' );
                    }
                } );
            }
            else
                AjaxAlert( 'tradutor.php', 'texto=serialsDifferent' );
        }
        else
            AjaxAlert( 'tradutor.php', 'texto=wrongSerialGroup' );
    }
    else
        AjaxAlert( 'tradutor.php', 'texto=invalidNameAndSerialGroup' );
}

function includeCRule( )
{
    if( $( '#CTName' ).val( ) == '' )
    {
        AjaxAlert( 'tradutor.php', 'texto=invalidName' );
        return;
    }
    if( $( '#CTone1' ).val( ) != '' && $( '#CTone2' ).val( ) == '' )
    {
        AjaxAlert( 'tradutor.php', 'texto=invalidCtone' );
        return;
    }
    if( $( '#CTone1' ).val( ) != '' && $( '#CTone2' ).val( ) != '' && $( '#CTone3' ).val( ) != '' && $( '#CTone4' ).val( ) == '' )
    {
        AjaxAlert( 'tradutor.php', 'texto=invalidCtone' );
        return;
    }
    if( $( '#CTone1' ).val( ) == '' && $( '#CTone2' ).val( ) == '' && $( '#CTone3' ).val( ) == '' && $( '#CTone4' ).val( ) == '' )
    {
        AjaxAlert( 'tradutor.php', 'texto=invalidCtone' );
        return;
    }
    else
    {
        var varData = 'action=add';
        varData += '&name=' + $( '#CTName' ).val( );
        varData += '&value=';
        for( var i = 1; i < 5; i++ )
            $.trim( $( '#CTone' + i ).val( ) ) != '' ? varData += $( '#CTone' + i ).val( ) + ',' : '';
        varData = varData.substr( 0, varData.length - 1 );
        jQuery.ajax(
        {
            type : 'POST',
            url : 'ajax/khompChanCadence.php',
            data : varData,
            dataType : "text",
            success : function( text )
            {
                if( text == 'Ok' )
                {
                    varData = 'action=list';
                    jQuery.ajax(
                    {
                        type : 'POST',
                        url : 'ajax/khompChanCadence.php',
                        data : varData,
                        dataType : "text",
                        success : function( text )
                        {
                            $( '#KhompChanCadences' ).html( text );
                            $( '#bAddKCCadence' ).show( );
                        }
                    } );
                    AjaxAlert( 'tradutor.php', 'texto=sucesso' );
                }
                else
                    AjaxAlert( 'tradutor.php', 'texto=existsName' );

            }
        } );
    }
}

function includeGRule( )
{
    if( $( '#GName' ).val( ) != '' && $( '#GExp' ).val( ) != '' )
    {
        var varData = 'action=add';
        varData += '&name=' + $( '#GName' ).val( );
        varData += '&expression=' + $( '#GExp' ).val( );
        varData += '&applyTo=' + $( '#GApplyTo' ).val( );
        test = (/(((([bB])[ ]*([0-9]+))|(([sS])[ ]*([0-9]+)))[ ]*(([cClL])[ ]*([0-9]+)[ ]*([-][ ]*([0-9]+))?)?)|(([rR])[ ]*([0-9]+)[ ]*([-][ ]*([0-9]+))?)/).test( document.getElementById( 'GExp' ).value );
        if( test )
        {
            jQuery.ajax(
            {
                type : 'POST',
                url : 'ajax/khompChanGroup.php',
                data : varData,
                dataType : "text",
                success : function( text )
                {
                    if( text == 'Ok' )
                    {
                        varData = 'action=list';
                        jQuery.ajax(
                        {
                            type : 'POST',
                            url : 'ajax/khompChanGroup.php',
                            data : varData,
                            dataType : "text",
                            success : function( text )
                            {
                                $( '#KhompChanGroups' ).html( text );
                                $( '#bAddKCGroup' ).show( );
                            }
                        } );
                        AjaxAlert( 'tradutor.php', 'texto=sucesso' );
                    }
                    else
                        AjaxAlert( 'tradutor.php', 'texto=existsName' );
                }
            } );
        }
        else
            AjaxAlert( 'tradutor.php', 'texto=wrongExp' );
    }
    else
        AjaxAlert( 'tradutor.php', 'texto=invalidNameAndExp' );
}

function listKCFHotlines( )
{
    var varData = 'action=list';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanFHotline.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#fxs-hotlines' ).html( text );
            $( '#bAddKCFHotline' ).show( );
        }
    } );
}

function listKCFOptions( )
{
    var varData = 'action=list';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanFOption.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#fxs-options' ).html( text );
            $( '#bAddKCFOption' ).show( );
        }
    } );
}

function listKCFBranches( )
{
    var varData = 'action=list';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanFBranche.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#fxs-branches' ).html( text );
            $( '#bAddKCFBranche' ).show( );
        }
    } );
}

function listKCCadences( )
{
    var varData = 'action=list';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanCadence.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#KhompChanCadences' ).html( text );
            $( '#bAddKCCadence' ).show( );
        }
    } );
}

function listKCGroups( )
{
    var varData = 'action=list';
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanGroup.php',
        data : varData,
        dataType : "text",
        success : function( text )
        {
            $( '#KhompChanGroups' ).html( text );
            $( '#bAddKCGroup' ).show( );
        }
    } );
}

function copyKhompChanPerfil( name )
{
    var pNewName = document.getElementById( 'newName' ).value;
    var subNames = pNewName.split( '+' );
    for( var i = 0; i < subNames.length; i++ )
    {
        test = (/(((([bB])[ ]*([0-9]+))|(([sS])[ ]*([0-9]+)))[ ]*(([cClL])[ ]*([0-9]+)[ ]*([-][ ]*([0-9]+))?)?)|(([rR])[ ]*([0-9]+)[ ]*([-][ ]*([0-9]+))?)|(([gG])[ ]*(\S)+)/).test( subNames[i] );
        if( !test )
        {
            AjaxAlert( 'tradutor.php', 'texto=invalidName' );
            return;
        }
    };
    var finalName = '';
    finalName = 'channels-' + document.getElementById( 'newName' ).value;
    jQuery.ajax(
    {
        type : 'POST',
        url : 'ajax/khompChanPerfil.php?action=test&perfil=' + finalName,
        data : '',
        dataType : "text",
        success : function( text )
        {
            if( text == 'Ok' )
            {
                var send = 'newPerfil=' + document.getElementById( 'newName' ).value + '&action=copy' + '&perfil=' + name;
                xmlhttpGeneric( 'ajax/khompChanPerfil.php', 'KhompChanGeral', 'KhompChanPerfil', send );
            }
            else
                AjaxAlert( 'tradutor.php', 'texto=existsName' );
        }
    } );
}

function preCopyKhompChanPerfil( name )
{
    if( ajaxConfirm( 'sureToCreateNewChannel' ) )
    {
        var send = 'perfil=' + name + '&action=preCopy';
        xmlhttpGeneric( 'ajax/khompChanPerfil.php', 'KhompChanGeral', 'KhompChanPerfil', send );
    }
}

function deleteKhompChanPerfilConfirmation( name )
{
    AjaxConfirm( 'tradutor.php', 'deleteKhompChan', 'texto=deleteKhompChan', name );
}

function sleep( milliseconds )
{
    var start = new Date( ).getTime( );
    for( var i = 0; i < 1e7; i++ )
    {
        if( (new Date( ).getTime( ) - start) > milliseconds )
            break;
    }
}

function d2b( d )
{
    return d.toString( 2 );
}

function b2d( b )
{
    return parseInt( b, 2 );
}

function b2h( b )
{
    b = b2d( b );
    return b.toString( 16 );
}

function h2b( h )
{
    h = parseInt( h, 16 );
    return d2b( h );
}

function marcarTodos( nome, quantidade )
{
    var x = 0;
    var nomeCampo = '';
    var campo;
    for( x = 1; x <= quantidade; x++ )
    {
        nomeCampo = nome + '_' + x;
        campo = document.getElementById( nomeCampo );
        if( !campo.disabled )
        {
            campo.checked = true;
            changeCheckTimeslotValues( campo )
        }
    }
}

function desmarcarTodos( nome, quantidade )
{
    var x = 0;
    var nomeCampo = '';
    var campo;
    for( x = 1; x <= quantidade; x++ )
    {
        nomeCampo = nome + '_' + x;
        campo = document.getElementById( nomeCampo );
        if( !campo.disabled )
        {
            campo.checked = false;
            changeCheckTimeslotValues( campo )
        }
    }
}

function getChecked( nome, total )
{
    strChecked = '';
    for( x = 0; x < total; x++ )
    {
        if( strChecked == '' )
        {
            if( document.getElementById( nome + x ).checked == true )
                strChecked = strChecked + document.getElementById( nome + x ).value;
        }
        else
        {
            if( document.getElementById( nome + x ).checked == true )
                strChecked = strChecked + ',' + document.getElementById( nome + x ).value;
        }
    }
    return strChecked;
}

function getRadioValue( element )
{
    radioLength = element.length;
    for( var i = 0; i < radioLength; i++ )
    {
        if( element[i].checked )
            return element[i].value;
    }
    return false;
}

function isNumeric( sText )
{
    var ValidChars = "0123456789.";
    var IsNumber = true;
    var Char;

    for( i = 0; i < sText.length && IsNumber == true; i++ )
    {
        Char = sText.charAt( i );
        if( ValidChars.indexOf( Char ) == -1 )
            IsNumber = false;
    }
    return IsNumber;
}

function getOptions( combo )
{
    if( (window.selectedText.length == 0 & window.from == "") || (window.from == combo.name) )
    {
        window.selectedText = new Array( );
        window.selectedValues = new Array( );
        var selLength = combo.length;
        var selectedCount = 0;
        var i;

        for( i = selLength - 1; i >= 0; i-- )
        {
            if( combo.options[i].selected )
            {
                window.selectedText[selectedCount] = combo.options[i].text;
                window.selectedValues[selectedCount] = combo.options[i].value;
                selectedCount++;
            }
        }
        if( selectedCount > 0 )
            window.from = combo.name;
    }
}

function addOption( theSel, theText, theValue )
{
    var newOpt = new Option( theText, theValue );
    var selLength = theSel.length;
    theSel.options[selLength] = newOpt;
}

function deleteOption( theSel, theIndex )
{
    var selLength = theSel.length;
    if( selLength > 0 )
        theSel.options[theIndex] = null;
}

function changeDisable( CheckTest, Alvo )
{
    target = document.getElementsByName( Alvo );
    if( CheckTest.checked )
    {
        for( i = 0; i < target.length; i++ )
            target[i].disabled = false;
    }
    else
    {
        for( i = 0; i < target.length; i++ )
            target[i].disabled = true;
    }
}

function cancelDevice( )
{
    $( '#deviceOpen' ).html( '' );
    $( '#divDevices' ).show( );
    $( '#manualAutomatico' ).show( );
    listDevices( );
}

function criaArray( options )
{
    var conjunto = new Array( );
    for( i = 0; i < options.length; i++ )
    {
        conjunto[i] = new Array( );
        conjunto[i][0] = options[i].text;
        conjunto[i][1] = options[i].value;
    }
    return conjunto;
}

function criaStringArray( options )
{
    var str = '';
    for( i = 0; i < options.length; i++ )
    {
        if( i == 0 )
            str = options[i].value;
        else
            str = str + ',' + options[i].value;
    }
    return str;
}

function getRadioValue( radios )
{
    for( var i = 0; i < radios.length; i++ )
    {
        if( radios[i].checked )
            return radios[i].value;
    }
    return '';
}

function sendForm( )
{
    addTimers( );
}

function setfocus( nome )
{
    document.getElementById( nome ).focus( );
}

function changeArrow( place )
{
    innerString = place.innerHTML;
    if( innerString[0] == "-" )
        place.innerHTML = innerString.replace( "-", "+" );
    else
        place.innerHTML = innerString.replace( "+", "-" );
}

function escapeKeys( event )
{
    //arrows
    if( event.keyCode > 36 && event.keyCode < 41 )
        return true
    if( event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 46 || event.keyCode == 116 || event.keyCode == 35 || event.keyCode == 36 || event.keyCode == 27 || event.keyCode == 16 || event.keyCode == 17 || event.keyCode == 18 )
    {
        return true;
    }
    return false;
}

function ipMask( event, comp )
{
    if( escapeKeys( event ) )
        return true;
    else
    {
        if( (/^(\d{1,3}\.){3}\d{3}$/).test( comp.value ) )
            return false;
        var chr = String.fromCharCode( event.keyCode );
        if( !(/[\d]/).test( chr ) && event.keyCode == 190 && event.keyCode == 194 )
            return false;
        if( event.keyCode == 190 || event.keyCode == 194 )
            return (!(/\.$|^(\d{1,3}\.){3}/).test( comp.value ) );
        else if( (/\d{3}$/).test( comp.value ) )
            comp.value += '.';
        return true;
    }
}

function preValidate( form, ipField, way )
{
    if( validateIP( ipField ) )
        updateVar( form, ipField, way );
}

function portMask( myfield, e, dec )
{
    var key;
    var keychar;

    if( window.event )
        key = window.event.keyCode;
    else if( e )
        key = e.which;
    else
        return true;
    keychar = String.fromCharCode( key );

    if( (myfield.value + keychar) > 65535 )
        return false;

    // control keys
    if( (key == null) || (key == 0) || (key == 8) || (key == 9) || (key == 13) || (key == 27) )
        return true;

    // numbers
    else if( (("0123456789").indexOf( keychar ) > -1) )
        return true;

    // decimal point jump
    else if( dec && (keychar == ".") )
    {
        myfield.form.elements[dec].focus( );
        return false;
    }
    else
        return false;
}

function validatePort( field )
{
    port = field.value;
    test = (/([0-9]{1,5})*/).test( port );
    if( !test )
    {
        field.style.background = '#F96868';
        return false;
    }
    else
    {
        field.style.background = '';
        return true;
    }
}

function serialMask( myfield, e, dec )
{
    var key;
    var keychar;

    if( window.event )
        key = window.event.keyCode;
    else if( e )
        key = e.which;
    else
        return true;
    keychar = String.fromCharCode( key );

    if( (myfield.value + keychar) > 4398046511104 )
        return false;

    // control keys
    if( (key == null) || (key == 0) || (key == 8) || (key == 9) || (key == 13) || (key == 27) )
        return true;

    // numbers
    else if( (("0123456789").indexOf( keychar ) > -1) )
        return true;

    // decimal point jump
    else if( dec && (keychar == ".") )
    {
        myfield.form.elements[dec].focus( );
        return false;
    }
    else
        return false;
}

function validateSerial( field )
{
    serial = field.value;
    test = (/([0-9])*/).test( serial );
    if( field.value < 100 )
        test = false;
    if( !test )
    {
        field.style.background = '#F96868';
        return false;
    }
    else
    {
        field.style.background = '';
        return true;
    }
}

function validateSerial2( field )
{
    serial = field.value;
    test = (/([0-9])*/).test( serial );
    if( field.value < 99 )
        test = false;
    if( !test )
    {
        field.style.background = '#F96868';
        return false;
    }
    else
    {
        field.style.background = '';
        return true;
    }
}

function numberMask( myfield, e, dec )
{
    var key;
    var keychar;

    if( window.event )
        key = window.event.keyCode;
    else if( e )
        key = e.which;
    else
        return true;
    keychar = String.fromCharCode( key );

    if( (myfield.value + keychar) > 4398046511104 )
        return false;

    // control keys
    if( (key == null) || (key == 0) || (key == 8) || (key == 9) || (key == 13) || (key == 27) )
        return true;

    // numbers
    else if( (("0123456789").indexOf( keychar ) > -1) )
        return true;

    // decimal point jump
    else if( dec && (keychar == ".") )
    {
        myfield.form.elements[dec].focus( );
        return false;
    }
    else
        return false;
}

function validateNumber( field )
{
    serial = field.value;
    test = (/([0-9]{1,12})*/).test( serial );

    if( !test )
    {
        field.style.background = '#F96868';
        return false;
    }
    else
    {
        field.style.background = '';
        return true;
    }
}

function leColore( )
{
    var cssClass = 0;
    for( var i = 0; i <= $( '#lastIndex' ).val( ); i++ )
    {
        var obj = document.getElementById( 'trId_' + i );
        if( obj )
        {
            if( (cssClass % 2) != 0 )
                obj.setAttribute( 'class', 'lgreen' );
            else
                obj.setAttribute( 'class', 'green' );
            cssClass++;
        }
    }
}

function changeWCSubType( subType )
{
    $( '#WCSubType' ).val( subType );
}

function closeModal( )
{
    $( '#dialog-modal' ).dialog( 'close' );
}

function closeAdvancedConfig( )
{
    $( '#ConfigE1Data' ).width( '779px' );
    $( '#nadvanced' ).width( '100%' );
    $( '#nadvanced' ).css( 'display', 'block' );
    $( '#advanced' ).hide( );
}

// common functions
function ajaxDefaultError( jqXHR, textStatus, errorThrown )
{
    if( jqXHR.responseText != "" )
    {
        var extra = $( "<div>" ).html( jqXHR.responseText ).text( ) + " ";
    }
    else
    {
        var extra = "";
    }
    ShowNotice( ajaxI18N( 'generic-ajax-request-failed' ) + ": " + extra + "(" + jqXHR.status + ") " + errorThrown, false );
    $( '#refreshing' ).hide( );
    $( '#gateway-cdr-save' ).removeAttr( 'disabled' );
    $( '#gateway-cdr-save' ).css( 'background', '#339966' );
};
// Gateway CDR configuration JS calls
function initCDR( )
{
    // drag options
    $( '.gateway-cdr-option' ).draggable(
    {
        containment : '#gateway-cdr',
        scroll : false,
        opacity : 0.7,
        helper : "clone"
    } );
    // insert option into pattern editor
    $( '.gateway-cdr-option' ).dblclick( function( )
    {
        $( '#gateway-cdr-pattern' ).insertText( "${" + $( this ).attr( 'cdr-value' ) + "}", $( '#gateway-cdr-pattern' ).getSelection( ).start, true );
    } );
    // option help tooltip
    $( '.gateway-tooltip' ).mouseover( function( event )
    {
        showKhompChanToolTip( event, $( this ).attr( 'khelp' ) );
    } );
    $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
    // pattern editor, accept option drag and highlight on drag
    $( '#gateway-cdr-pattern' ).droppable(
    {
        accept : '.gateway-cdr-option',
        activeClass : 'gateway-cdr-data-highlight',
        greedy : true,
        drop : function( event, ui )
        {
            $( ui.draggable ).dblclick( );
        }
    } );
    // pattern editor should restrict the chr(13) (enter) key press
    $( '#gateway-cdr-pattern' ).keypress( function( event )
    {
        if( event.which == 13 )
        {
            event.preventDefault( );
        }
    } );
    // save event, send needed data by POST ajax call
    $( '#gateway-cdr-save' ).click( function( )
    {
        $( '#gateway-cdr-save' ).attr( 'disabled', 'true' );
        $( '#gateway-cdr-save' ).css( 'background', 'gray' );
        $( '#refreshing' ).show( );

        $.ajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=saveCDROptions',
            data :
            {
                'pattern' : $( '#gateway-cdr-pattern' ).val( ),
                'rotate' : $( '#gateway-cdr-rotate :selected' ).val( )
            },
            dataType : "html",
            type : "POST",
            success : function( text )
            {
                ShowNotice( text, true );
                $( '#refreshing' ).hide( );
                $( '#gateway-cdr-save' ).removeAttr( 'disabled' );
                $( '#gateway-cdr-save' ).css( 'background', '#339966' );
            },
            error : ajaxDefaultError
        } );
    } );
    // time format help
    $( '[class~="gateway-cdr-help-title"]' ).each( function( idx, elm )
    {
        $( elm ).collapser(
        {
            target : 'next',
            effect : 'fade',
            changeText : 0
        }, function( )
        {
        }, function( )
        {
            var current_html = $( this ).html( )
            if( current_html[0] == "+" )
            {
                $( this ).html( current_html.replace( "+", "-" ) );
            }
            else
            {
                $( this ).html( current_html.replace( "-", "+" ) );
            }
        } );
    } );
    // sample copy event
    $( '[class~="gateway-cdr-help-sample-copy"]' ).each( function( idx, elm )
    {
        $( elm ).click( function( )
        {
            $( '#gateway-cdr-pattern' ).val( $( this ).prev( ).text( ) );
        } );
    } );
}

// Gateway codec profile functions
function initCodecProfiles( )
{
    saveCodecProfile = function( )
    {
        var codecList = [];
        var name = $.trim( $( '#gateway-codec-profile-name' ).val( ) );

        $( '[class~="gateway-codec-profile-list"]:checked' ).each( function( idx, elm )
        {
            codecList.push( $( elm ).val( ) );
        } );
        if( name.length == 0 )
        {
            ShowNotice( ajaxI18N( 'gateway-codec-profile-save-error-name-required' ), false );
            return;
        }
        else if( codecList.length == 0 )
        {
            ShowNotice( ajaxI18N( 'gateway-codec-profile-save-error-codec-required' ), false );
            return;
        }
        var oldName = $( '#gateway-codec-profile-old-name' ).val( );

        $( '#refreshing' ).show( );
        $( '#gateway-codec-profile-save' ).attr( 'disabled', 'true' );
        $( '#gateway-codec-profile-save' ).css( 'background', 'gray' );
        $.ajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=saveCodecProfile',
            data :
            {
                'name' : name,
                'oldName' : oldName,
                'codecList' : codecList
            },
            dataType : 'json',
            type : 'POST',
            success : function( data )
            {
                $( '#refreshing' ).hide( );
                if( data.success )
                {
                    changeView( 'showCodecProfiles', $( '#menu-codec-profiles-gw' ), 'menu-routing-gw' );
                    ShowNotice( data.message, true );
                }
                else
                {
                    ShowNotice( data.message, false );
                    $( '#gateway-codec-profile-save' ).removeAttr( 'disabled' );
                    $( '#gateway-codec-profile-save' ).css( 'background', '#339966' );
                }
            },
            error : ajaxDefaultError
        } );
    }
    formCodecProfile = function( text )
    {
        $( '#gateway-codec-profile-container' ).html( text );
        $( '#gateway-codec-profile-list-container' ).sortable(
        {
            revert : true
        } );
        $( '#gateway-codec-profile-list-container' ).disableSelection( );
        $( '#gateway-codec-profile-list-container' ).each( function( idx, elm )
        {
            $( elm ).disableSelection( );
        } );
        $( '#gateway-codec-profile-back' ).click( function( )
        {
            changeView( 'showCodecProfiles', $( '#menu-codec-profiles-gw' ), 'menu-routing-gw' );
        } );
        $( '#gateway-codec-profile-save' ).click( saveCodecProfile );
        // tooltips
        $( '.gateway-tooltip' ).mouseover( function( event )
        {
            showKhompChanToolTip( event, $( this ).attr( 'khelp' ) );
        } );
        $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
        $( '#gateway-codec-profile-select-all' ).click( function( ev )
        {
            $( '[class~="gateway-codec-profile-list"]' ).each( function( idx, elm )
            {
                $( elm ).attr( 'checked', true );
            } );
        } );
        $( '#gateway-codec-profile-select-none' ).click( function( ev )
        {
            $( '[class~="gateway-codec-profile-list"]' ).each( function( idx, elm )
            {
                $( elm ).attr( 'checked', false );
            } );
        } );
        $( '#refreshing' ).hide( );
    }
    // new codec profile button
    $( '#gateway-codec-profile-button-new' ).click( function( )
    {
        $( '#refreshing' ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=addCodecProfile',
            dataType : 'html',
            type : 'POST',
            success : formCodecProfile,
            error : ajaxDefaultError
        } );
    } );
    // edit codec profile buttons
    $( '[class~="gateway-codec-profile-edit"]' ).each( function( idx, elm )
    {
        $( elm ).click( function( )
        {
            var name = $( elm ).parent( ).parent( ).children( ).first( ).text( );
            $.ajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=editCodecProfile',
                data :
                {
                    'name' : name
                },
                dataType : 'html',
                type : 'POST',
                success : formCodecProfile,
                error : ajaxDefaultError
            } );
        } );
    } );
    // delete codec profile buttons
    $( '[class~="gateway-codec-profile-delete"]' ).each( function( idx, elm )
    {
        $( elm ).click( function( )
        {
            if( ajaxConfirm( 'gateway-codec-profile-confirm-delete' ) )
            {
                var name = $( elm ).parent( ).parent( ).children( ).first( ).text( );
                $.ajax(
                {
                    url : GLOBALAjaxURL + '&ajaxTo=deleteCodecProfile',
                    data :
                    {
                        'name' : name
                    },
                    dataType : 'json',
                    type : 'POST',
                    success : function( data )
                    {
                        $( '#refreshing' ).hide( );
                        if( data.success )
                        {
                            changeView( 'showCodecProfiles', $( '#menu-codec-profiles-gw' ), 'menu-routing-gw' );
                            ShowNotice( data.message, true );
                        }
                        else
                        {
                            ShowNotice( data.message, false );
                        }
                    },
                    error : ajaxDefaultError
                } );
            }
        } );
    } );
    // main table sorter
    $( '#gateway-codec-profile-table' ).tablesorter(
    {
        cssAsc : 'tablesorter-asc',
        cssDesc : 'tablesorter-desc',
        cssHeader : 'tablesorter-undefined',
        headers :
        {
            2 :
            {
                sorter : false
            }
        },
        sortList : [[0, 0]]
    } );
}

// gateway routes
function initRoutesGW( )
{
    // (re)load routes table
    var loadRoutes = function( )
    {
        changeView( 'showRoutesGW', null, 'menu-routing-gw,menu-routes-gw' );
    }
    // save main table routes order
    var reorderRoutes = function( )
    {
        var order = [];
        $( '#gateway-route-list-table tbody tr' ).each( function( idx, elm )
        {
            order.push( $( elm ).children( ).first( ).text( ) );
        } );
        if( order.length > 0 )
        {
            $( '#refreshing' ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=routesOrder',
                data :
                {
                    'order' : order
                },
                dataType : 'json',
                type : 'POST',
                success : function( data )
                {
                    $( '#refreshing' ).hide( )
                    if( !data.success )
                    {
                        ShowNotice( data.message, false );
                    }
                },
                error : ajaxDefaultError
            } )
        }
    }
    // attach route form events
    var initRouteForm = function( )
    {
        // attach events
        $( '#gateway-route-form-destination-nap' ).change( function( )
        {
            var _val = $( '#gateway-route-form-destination-nap' ).val( );
            _val = _val.slice( 0, _val.search( '>' ) );
            if( _val == 'SIP' )
            {
                $( '#gateway-route-form-codec-profile-list' ).show( 350 );
            }
            else
            {
                $( '#gateway-route-form-codec-profile-list' ).hide( 350 );
            }
        } );
        $( '#gateway-route-form-destination-nap' ).change( );
        // tooltips
        $( '.gateway-tooltip' ).mouseover( function( event )
        {
            showKhompChanToolTip( event, $( this ).attr( 'khelp' ) );
        } );
        $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
        $( '#gateway-route-form-save' ).click( function( )
        {
            var mydata =
            {
            };

            $( '#refreshing' ).show( );
            try
            {
                // grab data
                $( '#gateway-table-form input[type~="text"]' ).each( function( )
                {
                    mydata[$( this ).attr( 'name' )] = $( this ).val( );
                } );
                $( '#gateway-table-form input[type~="hidden"]' ).each( function( )
                {
                    mydata[$( this ).attr( 'name' )] = $( this ).val( );
                } );
                $( '#gateway-table-form select' ).each( function( )
                {
                    var _val = $( this ).val( );
                    if( _val.indexOf( '>' ) > -1 && _val.indexOf( '>' ) < (_val.length - 1) )
                    {
                        _val = _val.slice( _val.search( '>' ) + 1 )
                    }
                    mydata[$( this ).attr( 'name' )] = _val;
                } );

                // validation
                if( mydata['Name'] == '' )
                {
                    throw 'gateway-route-error-name-is-required';
                }
                if( mydata['OriginNAP'] == '<SELECT>' )
                {
                    throw 'gateway-route-error-origin-nap-is-required';
                }
                if( mydata['DestinationNAP'] == '<SELECT>' )
                {
                    throw 'gateway-route-error-destination-nap-is-required';
                }
                var _val = $( '#gateway-route-form-destination-nap' ).val( );
                _val = _val.slice( 0, _val.search( '>' ) );
                if( _val == 'SIP' && mydata['CodecProfile'] == '<SELECT>' )
                {
                    throw 'gateway-route-error-codec-profile-is-required';
                }
                else if( _val != 'SIP' )
                {
                    // always blank codec profile if it is not SIP
                    mydata['CodecProfile'] = '';
                }

                $.ajax(
                {
                    url : GLOBALAjaxURL + '&ajaxTo=saveRouteGW',
                    data : mydata,
                    dataType : "json",
                    type : "POST",
                    success : function( data )
                    {
                        ShowNotice( data.message, data.success );
                        if( data.success )
                        {
                            loadRoutes( );
                        }
                    },
                    error : ajaxDefaultError
                } );
            }
            catch( e )
            {
                ShowNotice( ajaxI18N( e ), false );
            }
            $( '#refreshing' ).hide( );
        } );
        // back to list event
        $( '#gateway-route-form-back' ).click( loadRoutes );
    }
    // add route
    var addRoute = function( )
    {
        $( '#refreshing' ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=newRouteGW",
            dataType : "html",
            success : function( data )
            {
                $( '#gateway-route' ).html( data );
                initRouteForm( );
                $( '#refreshing' ).hide( );
            },
            error : ajaxDefaultError
        } );

    }
    // find route name inside main table
    var findRoute = function( elm )
    {
        return $( elm ).parent( ).parent( ).children( ).first( ).text( );
    }
    // edit route
    var editRoute = function( )
    {
        var name = findRoute( $( this ) );
        $( '#refreshing' ).show( );
        $.ajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=editRouteGW",
            data :
            {
                name : name
            },
            dataType : "html",
            type : "POST",
            success : function( data )
            {
                $( '#gateway-route' ).html( data );
                initRouteForm( );
                $( '#refreshing' ).hide( );
            },
            error : ajaxDefaultError
        } )
    }
    // delete route
    var deleteRoute = function( )
    {
        if( ajaxConfirm( 'gateway-route-confirm-delete' ) )
        {
            var name = findRoute( $( this ) );
            $( '#refreshing' ).show( );
            $.ajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=removeRouteGW",
                data :
                {
                    name : name
                },
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( '#refreshing' ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        loadRoutes( );
                    }
                },
                error : ajaxDefaultError
            } );
        }
    }
    // main screen events
    // main table is sortable
    $( "#gateway-route-list-table tbody" ).sortable(
    {
        revert : 100,
        stop : reorderRoutes,
        helper : function( e, ui )
        {
            ui.children( ).each( function( )
            {
                $( this ).width( $( this ).width( ) );
            } );
            return ui;
        },
        cancel : 'img,a,input,button'
    } );
    // add/edit/delete buttons
    $( '.gateway-route-add' ).click( addRoute );
    $( '.gateway-route-edit' ).click( editRoute );
    $( '.gateway-route-delete' ).click( deleteRoute );

}

// initialize the license manager inside admin
function initLicenseManager( )
{
    $( '.license-manager-row' ).each( function( idx, elm )
    {
        $( elm ).click( function( ev )
        {
            var id = '#license-manager-row-' + $.trim( $( this ).children( ).first( ).text( ) );
            $( id ).toggle( );
        } );
    } );
    $( '.license-manager-download' ).each( function( idx, elm )
    {
        $( elm ).click( function( ev )
        {
            window.open( GLOBALAjaxURL + '&location=downloadLicense&name=' + $( this ).attr( 'name' ) );
            ev.stopPropagation( );
        } );
    } );
    $( '.license-manager-delete' ).each( function( idx, elm )
    {
        $( elm ).click( function( ev )
        {
            if( ajaxConfirm( 'license-manager-delete-confirm' ) )
            {
                var _img = $( this );
                $.ajax(
                {
                    url : GLOBALAjaxURL + '&ajaxTo=deleteLicense',
                    data :
                    {
                        'name' : $( this ).attr( 'name' )
                    },
                    dataType : 'json',
                    type : 'POST',
                    success : function( data )
                    {
                        $( '#refreshing' ).hide( );
                        if( data.success )
                        {
                            //TODO: reload license table
                            _img.parent( ).parent( ).next( ).remove( );
                            _img.parent( ).parent( ).remove( );
                            ShowNotice( data.message, true );
                        }
                        else
                        {
                            ShowNotice( data.message, false );
                        }
                    },
                    error : ajaxDefaultError
                } );
            }
            ev.stopPropagation( );
        } );
    } );
    $( '#license-manager-upload' ).ajaxForm(
    {
        dataType : 'json',
        beforeSend : function( )
        {
            var _submit = $( '#license-manager-upload input[type="submit"]' );
            _submit.prop( 'disabled', true );
            _submit.css( 'background', 'gray' );
            $( '#refreshing' ).show( );
        },
        complete : function( )
        {
            var _submit = $( '#license-manager-upload input[type="submit"]' );
            _submit.prop( 'disabled', false );
            _submit.css( 'background', '#339966' );
        },
        success : function( data )
        {
            $( '#refreshing' ).hide( );
            if( data.success )
            {
                ShowNotice( data.message, true );
                //TODO: reload license table
                window.location.reload( );
            }
            else
            {
                ShowNotice( data.message, false );
            }
        }
    } );
}

/*************************** old stuffs *******************************/

// function selectFXODeviceChannels(device)
// {
// var execute = 'action=changeDevice&device=' + device;
// document.getElementById('loading').style.display = 'block';
// xmlhttpGeneric('./ajax/assistant.php', 'fxoDeviceChannelsList',
// 'assistantSave', execute);
// }

// function deleteEF(EF)
// {
// var execute = 'action=delWC&type=EF&WC=' + EF;
// xmlhttpGeneric('./ajax/assistant.php', 'EnabledFeaturesList', 'WCAdd',
// execute);
// }
//
// function deleteAG(AG)
// {
// var execute = 'action=delWC&type=AG&WC=' + AG;
// xmlhttpGeneric('./ajax/assistant.php', 'AgcGainList', 'WCAdd', execute);
// }
//
// function deletePAG(PAG)
// {
// var execute = 'action=delWC&type=PAG&WC=' + PAG;
// xmlhttpGeneric('./ajax/assistant.php', 'PlayerAgcGainList', 'WCAdd', execute);
// }
//
// function deleteGeneration(Gen)
// {
// var execute = 'action=delWC&type=Gen&WC=' + Gen;
// xmlhttpGeneric('./ajax/assistant.php', 'GenerationList', 'WCAdd', execute);
// }
//
// function deleteDetection(Det)
// {
// var execute = 'action=delWC&type=Det&WC=' + Det;
// xmlhttpGeneric('./ajax/assistant.php', 'DetectionList', 'WCAdd', execute);
// }
//
// function deleteAEC(AEC)
// {
// var execute = 'action=delWC&type=AECancel&WC=' + AEC;
// xmlhttpGeneric('./ajax/assistant.php', 'AutoEchoCancellerList', 'WCAdd',
// execute);
// }
//
// function deleteADS(ADS)
// {
// var execute = 'action=delWC&type=ADSup&WC=' + ADS;
// xmlhttpGeneric('./ajax/assistant.php', 'AutoDtmfSuppressionList', 'WCAdd',
// execute);
// }
//
// function deleteAAGC(AAGC)
// {
// var execute = 'action=delWC&type=AAGC&WC=' + AAGC;
// xmlhttpGeneric('./ajax/assistant.php', 'AutoAGCList', 'WCAdd', execute);
// }
//
// function deleteGeralItem(name, type)
// {
// var action = 'delete';
// var divname = 'div' + name;
// var send = 'action=' + action + '&name=' + name + '&type=' + type;
// var url = 'geralConfigSession.php';
// xmlhttpGeneric(url, divname, 'geralConfig', send);
// return;
// }
//
// function deleteGeralSubItem(name, subName, type)
// {
// var action = 'deleteSubVar';
// var divname = 'div' + name;
// var send = 'action=' + action + '&name=' + name + '&type=' + type +
// '&subName=' + subName;
// var url = 'geralConfigSession.php';
// xmlhttpGeneric(url, divname, 'geralConfig', send);
// return;
// }
//
// function preAddGroupCheckbox(name, type)
// {
// var action = 'preCreateSubVar';
// var divname = 'div' + name;
// var send = 'action=' + action + '&name=' + name + '&type=' + type;
// var url = 'geralConfigSession.php';
// xmlhttpGeneric(url, divname, 'geralConfig', send);
// return;
// }
//
// function createGroupCheckbox(name, type)
// {
// var action = 'addValue';
// var divname = 'div' + name;
// var value = document.getElementById(name + 'subVar').value
// var send = 'action=' + action + '&name=' + name + '&type=' + type + '&value='
// + value;
// var url = 'geralConfigSession.php';
// xmlhttpGeneric(url, divname, 'geralConfig', send);
// return;
// }
//
// function createGeralItem(name, type)
// {
// var action = 'create';
// var divname = 'div' + name;
// var send = 'action=' + action + '&name=' + name + '&type=' + type;
// var url = 'geralConfigSession.php';
// xmlhttpGeneric(url, divname, 'geralConfig', send);
// return;
// }
//
// function preCreateGeralSubItem(name, type)
// {
// var action = 'preCreate';
// var divname = 'div' + name;
// var total = document.getElementById(name + 'Total').value;
// var Aside = '';
// var Bside = '';
// var send = '';
// if(type != 'preCreateMultAssociativeArray')
// for( x = 0; x < total; x++)
// {
// if(x == 0)
// {
// Aside += document.getElementById(name + 'A' + x).value;
// Bside += document.getElementById(name + 'B' + x).value;
// }
// else
// {
// Aside += ',' + document.getElementById(name + 'A' + x).value;
// Bside += ',' + document.getElementById(name + 'B' + x).value;
// }
// }
// if(Aside != '')
// send = 'action=' + action + '&name=' + name + '&type=' + type + '&Aside=' +
// Aside + '&Bside=' + Bside;
// else
// send = 'action=' + action + '&name=' + name + '&type=' + type;
//
// var url = 'geralConfigSession.php';
// xmlhttpGeneric(url, divname, 'geralConfig', send);
// return;
// }
//
// function createGeralSubItem(name, type)
// {
// var action = 'createSubVar';
// var divname = 'div' + name;
// var Aside = '';
// var Bside = '';
// var send = '';
// Aside = document.getElementById(name + 'subVarA').value;
// Bside = document.getElementById(name + 'subVarB').value;
// if(Aside != '')
// send = 'action=' + action + '&name=' + name + '&type=' + type + '&Aside=' +
// Aside + '&Bside=' + Bside;
// else
// send = 'action=' + action + '&name=' + name + '&type=' + type;
//
// var url = 'geralConfigSession.php';
// xmlhttpGeneric(url, divname, 'geralConfig', send);
// return;
// }
//
// function createMultAssociativeArray(name, type)
// {
// var action = 'createMultAssociativeArray';
// var divname = 'div' + name;
// var send = '';
// if(name == "DropCollectCalls")
// {
// send += 'action=' + action + '&name=' + name + '&type=' + type + '&value=' +
// document.getElementById(name + 'subVarA').value + '|' +
// document.getElementById(name + 'subVarB').checked + '|' +
// document.getElementById(name + 'subVarC').value + '|' +
// document.getElementById(name + 'subVarD').checked;
// if(document.getElementById(name + 'subVarE'))
// send += '|' + document.getElementById(name + 'subVarE').checked;
// if(document.getElementById(name + 'subVarF'))
// send += '|' + document.getElementById(name + 'subVarF').value;
// }
// else
// send += 'action=' + action + '&name=' + name + '&type=' + type + '&value=' +
// document.getElementById(name + 'subVarA').value + '|' +
// document.getElementById(name + 'subVarB').value + '|' +
// document.getElementById(name + 'subVarC').value + '|' +
// document.getElementById(name + 'subVarD').value;
// var url = 'geralConfigSession.php';
// xmlhttpGeneric(url, divname, 'geralConfig', send);
// return;
// }
//
// function getValues(name, total)
// {
// strValues = '';
// for( x = 0; x < total; x++)
// {
// if(document.getElementById(name + x))
// {
// if(x == 0)
// strValues = strValues + document.getElementById(name + x).value;
// else
// strValues = strValues + ';' + document.getElementById(name + x).value;
// }
// }
// return strValues;
// }
//
// function getTexts(nome, total)
// {
// strTexts = '';
// for( x = 0; x < total; x++)
// {
// if(x == 0)
// strTexts = strTexts + document.getElementById(nome + 'A' + x).value + '|' +
// document.getElementById(nome + 'B' + x).value;
// else
// strTexts = strTexts + ',' + document.getElementById(nome + 'A' + x).value +
// '|' + document.getElementById(nome + 'B' + x).value;
// }
// return strTexts;
// }
//
// function getTextLine(nome, total)
// {
// strTexts = '';
// for( x = 0; x < total; x++)
// {
// if(x == 0)
// strTexts = strTexts + document.getElementById(nome + 'A' + x).value;
// else
// strTexts = strTexts + ',' + document.getElementById(nome + 'A' + x).value;
// }
// return strTexts;
// }
//
// function getStringFromArray(conjunto)
// {
// var str = '';
// var count = 0;
// for( i = 0; i < conjunto.length; i++)
// {
// if(conjunto[i] == true)
// {
// if(count == 0)
// {
// count = 1;
// str = i;
// }
// else
// str = str + ',' + i;
// }
// }
// return str;
// }
//
// function getCodecs()
// {
// var codecList = document.getElementById('sortable').children;
// var codecLength = codecList.length;
// var firstCodec =
// document.getElementById('sortable').children[0].children[0].id;
// var codecStr = '';
// for(var i = 0; i < codecLength; i++)
// {
// node = document.getElementById('sortable').children[i].children[0].id;
// if(document.getElementById(node).checked)
// {
// if(codecStr == '')
// codecStr = document.getElementById(node).value;
// else
// codecStr += ',' + document.getElementById(node).value
// }
// }
// return codecStr;
// }
//
